searchData={"items":[{"type":"task","title":"mix burn","doc":"Writes the generated firmware image to an attached SDCard or file.\n\nBy default, this task detects attached SDCards and then invokes `fwup`\nto overwrite the contents of the selected SDCard with the new image.\nData on the SDCard will be lost, so be careful.","ref":"Mix.Tasks.Burn.html"},{"type":"task","title":"Command line options - mix burn","doc":"* `--device  ` - skip SDCard detection and write the image to\n    the specified filename. SDCard paths depend on the operating system, but\n    have a form like `/dev/sdc` or `/dev/mmcblk0`. You may also specify a\n    filename to create an image that can be used with a bulk memory programmer\n    or copied to an SDCard manually with a utility like `dd`.\n\n  * `--task  ` - apply the specified `fwup` task. See the `fwup.conf`\n    file that was used to create the firmware image for options. By\n    convention, the `complete` task writes everything to the SDCard including\n    bootloader and application data partitions. The `upgrade` task only\n    modifies the parts of the SDCard required to run the new software.\n\n  * `--firmware  ` - (Optional) The path to the fw file to use.\n    Defaults to ` / .fw`","ref":"Mix.Tasks.Burn.html#module-command-line-options"},{"type":"task","title":"Examples - mix burn","doc":"```\n# Upgrade the contents of the SDCard located at /dev/mmcblk0\nmix burn --device /dev/mmcblk0 --task upgrade\n```","ref":"Mix.Tasks.Burn.html#module-examples"},{"type":"function","title":"Mix.Tasks.Burn.firmware_file/1","doc":"","ref":"Mix.Tasks.Burn.html#firmware_file/1"},{"type":"task","title":"mix compile.nerves_package","doc":"Build a Nerves Artifact from a Nerves Package","ref":"Mix.Tasks.Compile.NervesPackage.html"},{"type":"task","title":"mix firmware","doc":"Build a firmware image for the selected target platform.\n\nThis task builds the project, combines the generated OTP release with\na Nerves system image, and creates a `.fw` file that may be written\nto an SDCard or sent to a device.","ref":"Mix.Tasks.Firmware.html"},{"type":"task","title":"Command line options - mix firmware","doc":"* `--verbose` - produce detailed output about release assembly\n  * `--output` - (Optional) The path to the .fw file used to write the patch\n    firmware. Defaults to `Nerves.Env.firmware_path/1`","ref":"Mix.Tasks.Firmware.html#module-command-line-options"},{"type":"task","title":"Environment variables - mix firmware","doc":"* `NERVES_SYSTEM`    - may be set to a local directory to specify the Nerves\n    system image that is used\n\n  * `NERVES_TOOLCHAIN` - may be set to a local directory to specify the\n    Nerves toolchain (C/C++ crosscompiler) that is used","ref":"Mix.Tasks.Firmware.html#module-environment-variables"},{"type":"task","title":"mix firmware.burn","doc":"This task calls `mix firmware` & `mix burn` to burn a new firmware to a SDCard","ref":"Mix.Tasks.Firmware.Burn.html"},{"type":"task","title":"Command line options - mix firmware.burn","doc":"* `--device  ` - skip SDCard detection and write the image to\n    the specified filename. SDCard paths depend on the operating system, but\n    have a form like `/dev/sdc` or `/dev/mmcblk0`. You may also specify a\n    filename to create an image that can be used with a bulk memory programmer\n    or copied to an SDCard manually with a utility like `dd`.\n\n  * `--task  ` - apply the specified `fwup` task. See the `fwup.conf`\n    file that was used to create the firmware image for options. By\n    convention, the `complete` task writes everything to the SDCard including\n    bootloaders and application data partitions. The `upgrade` task only\n    modifies the parts of the SDCard required to run the new software.\n\n  * `--verbose` - produce detailed output about release assembly\n\n  * The `mix firmware.burn` task uses the `fwup` tool internally; any extra\n    arguments passed to it will be forwarded along to `fwup`. You can read\n    about the other supported options in the\n    [`fwup` documentation](https://github.com/fwup-home/fwup#invoking).","ref":"Mix.Tasks.Firmware.Burn.html#module-command-line-options"},{"type":"task","title":"Environment variables - mix firmware.burn","doc":"* `NERVES_SYSTEM`    - may be set to a local directory to specify the Nerves\n    system image that is used\n\n  * `NERVES_TOOLCHAIN` - may be set to a local directory to specify the\n    Nerves toolchain (C/C++ crosscompiler) that is used","ref":"Mix.Tasks.Firmware.Burn.html#module-environment-variables"},{"type":"task","title":"Examples - mix firmware.burn","doc":"Upgrade the contents of the SDCard at `/dev/mmcblk0` using the `rpi0` system\n\n```bash\nmix firmware.burn --device /dev/mmcblk0 --task upgrade\n```\n\nIf you are sure there is only one SD card inserted, you can also add the `-y`\nflag to skip the confirmation that it is the correct device.\n\n```bash\nmix firmware.burn -y\n```","ref":"Mix.Tasks.Firmware.Burn.html#module-examples"},{"type":"task","title":"mix firmware.gen.gdb","doc":"Generates a helper shell script for using gdb to analyze core dumps\n\nThis script may be used on its own or used as a base for more complicated debugging.\nIt saves the script to gdb.sh.","ref":"Mix.Tasks.Firmware.Gen.Gdb.html"},{"type":"task","title":"mix firmware.image","doc":"Create a firmware image file that can be copied byte-for-byte to an SDCard\nor other memory device.","ref":"Mix.Tasks.Firmware.Image.html"},{"type":"task","title":"Usage - mix firmware.image","doc":"mix firmware.image [my_image.img]\n\nIf not supplied, the output image file will be based off the OTP application\nname.","ref":"Mix.Tasks.Firmware.Image.html#module-usage"},{"type":"task","title":"Examples - mix firmware.image","doc":"```\n# Create the image file\nmix firmware.image my_image.img\n\n# Write it to a MicroSD card in Linux\ndd if=my_image.img of=/dev/sdc bs=1M\n```","ref":"Mix.Tasks.Firmware.Image.html#module-examples"},{"type":"task","title":"mix firmware.metadata","doc":"This task calls `fwup` to report the firmware stored in the currently built\nfirmware bundle. No firmware is built, so this task will fail if the firmware\nbundle doesn't exist.\n\nNote: Rebuilding firmware will almost certainly change the UUID if the build\nis not [reproducible](https://reproducible-builds.org/).","ref":"Mix.Tasks.Firmware.Metadata.html"},{"type":"task","title":"Command line options - mix firmware.metadata","doc":"* `--firmware  ` - (Optional) The path to the fw file to use.\n    Defaults to ` / .fw`","ref":"Mix.Tasks.Firmware.Metadata.html#module-command-line-options"},{"type":"task","title":"Examples - mix firmware.metadata","doc":"```\n$ mix firmware.metadata\nmeta-product=\"my_firmware\"\nmeta-description=\"A description\"\nmeta-version=\"1.0.0\"\nmeta-author=\"me\"\nmeta-platform=\"rpi\"\nmeta-architecture=\"arm\"\nmeta-creation-date=\"2020-01-31T21:15:25Z\"\nmeta-uuid=\"62f80587-ce82-59c4-4200-9c92df9849fd\"\n```","ref":"Mix.Tasks.Firmware.Metadata.html#module-examples"},{"type":"function","title":"Mix.Tasks.Firmware.Metadata.firmware_file/1","doc":"","ref":"Mix.Tasks.Firmware.Metadata.html#firmware_file/1"},{"type":"task","title":"mix firmware.patch","doc":"Generate a firmware patch from a source and target firmware and output a new\nfirmware file with the patch contents. The source firmware file\n\nThis requires fwup >= 1.6.0","ref":"Mix.Tasks.Firmware.Patch.html"},{"type":"task","title":"Command line options - mix firmware.patch","doc":"* `--source` - (Optional) The path to the .fw file used as the source.\n    Defaults to the last firmware built.\n  * `--target` - (Optional) The path to the .fw file used as the target.\n    Defaults to generating a new firmware without overwriting the source.\n  * `--output` - (Optional) The path to the .fw file used to write the patch\n    firmware. Defaults to `Nerves.Env.firmware_path/1`","ref":"Mix.Tasks.Firmware.Patch.html#module-command-line-options"},{"type":"task","title":"mix firmware.unpack","doc":"Unpack the firmware so that its contents can be inspected locally.","ref":"Mix.Tasks.Firmware.Unpack.html"},{"type":"task","title":"Usage - mix firmware.unpack","doc":"mix firmware.unpack [--output output directory] [--fw path to firmware]","ref":"Mix.Tasks.Firmware.Unpack.html#module-usage"},{"type":"task","title":"Command line options - mix firmware.unpack","doc":"* `--fw` - (Optional) The path to the .fw file for unpacking.\n    Defaults to `Nerves.Env.firmware_path/1`\n  * `--output` - (Optional) The output directory for the unpacked firmware.\n    Defaults to the name of the firmware bundle with the extension replaced\n    with `.unpacked`.","ref":"Mix.Tasks.Firmware.Unpack.html#module-command-line-options"},{"type":"task","title":"Examples - mix firmware.unpack","doc":"```\n# Create a firmware bundle. It will be under the _build directory\nmix firmware\n\n# Unpack the built firmware\nmix firmware.unpack --output firmware_contents\n\n# Unpack a specified fw file\nmix firmware.unpack --fw hello_nerves.fw\n\n# Inspect it\nls hello_nerves.unpacked/\n```","ref":"Mix.Tasks.Firmware.Unpack.html#module-examples"},{"type":"task","title":"mix nerves.artifact","doc":"Creates a Nerves artifact for a Nerves system or toolchain\n\nThis compiles the system or toolchain and creates the tar ball containing the\nresult. One would normally post this to GitHub releases or another website so\nthat it can be downloaded when someone uses the system or toolchain.","ref":"Mix.Tasks.Nerves.Artifact.html"},{"type":"task","title":"Command line options - mix nerves.artifact","doc":"* `--path  `: The location where you want the archive to be placed.\n    Default: `$NERVES_DL_DIR || ~/.nerves/dl`","ref":"Mix.Tasks.Nerves.Artifact.html#module-command-line-options"},{"type":"task","title":"Examples - mix nerves.artifact","doc":"$ mix nerves.artifact nerves_system_rpi0\n\nIf the command is called without the package name,\n`Nerves.Project.config()[:app]` will be used by default.\n\n    $ mix nerves.artifact --path /tmp","ref":"Mix.Tasks.Nerves.Artifact.html#module-examples"},{"type":"task","title":"mix nerves.artifact.details","doc":"Prints Nerves artifact details.\n\nThis displays various details.","ref":"Mix.Tasks.Nerves.Artifact.Details.html"},{"type":"task","title":"Examples - mix nerves.artifact.details","doc":"$ mix nerves.artifact.details nerves_system_rpi0\n\nIf the command is called without the package name,\n`Nerves.Project.config()[:app]` will be used by default.","ref":"Mix.Tasks.Nerves.Artifact.Details.html#module-examples"},{"type":"task","title":"mix nerves.clean","doc":"Cleans dependencies and build artifacts\n\nSince this is a destructive action, cleaning of dependencies\nonly occurs when one of the following are specified:\n\n  * `dep1 dep2` - the names of Nerves dependencies to be cleaned, separated by spaces\n  * `--all` - cleans all Nerves dependencies","ref":"Mix.Tasks.Nerves.Clean.html"},{"type":"task","title":"mix nerves.info","doc":"Prints Nerves system information.\n\n    mix nerves.info","ref":"Mix.Tasks.Nerves.Info.html"},{"type":"task","title":"mix nerves.system.shell","doc":"Open a shell in a system's build directory.\n\nIn order to make the experience as similar as possible, we attach to a Docker\ncontainer on non-Linux platforms and run a sub-shell on Linux.","ref":"Mix.Tasks.Nerves.System.Shell.html"},{"type":"task","title":"Examples - mix nerves.system.shell","doc":"Configure the system for the current project's target:\n\n    mix nerves.system.shell","ref":"Mix.Tasks.Nerves.System.Shell.html#module-examples"},{"type":"module","title":"Nerves.Artifact","doc":"Package artifacts are the product of compiling a package with a\nspecific toolchain.","ref":"Nerves.Artifact.html"},{"type":"function","title":"Nerves.Artifact.archive/3","doc":"Produces an archive of the package artifact which can be fetched when\ncalling `nerves.artifact.get`.","ref":"Nerves.Artifact.html#archive/3"},{"type":"function","title":"Nerves.Artifact.base_dir/0","doc":"Get the base dir for where an artifact for a package should be stored.\n\nThe directory for artifacts will be found in the directory returned\nby `Nerves.Env.data_dir/0` (i.e. `\"/home/fhunleth/.nerves/artifacts/\"`).\nThis location can be overriden by the environment variable `NERVES_ARTIFACTS_DIR`.","ref":"Nerves.Artifact.html#base_dir/0"},{"type":"function","title":"Nerves.Artifact.build/2","doc":"Builds the package and produces an  See Nerves.Artifact\nfor more information.","ref":"Nerves.Artifact.html#build/2"},{"type":"function","title":"Nerves.Artifact.build_path/1","doc":"Get the path to where the artifact is built","ref":"Nerves.Artifact.html#build_path/1"},{"type":"function","title":"Nerves.Artifact.build_path_link/1","doc":"Get the path where the global artifact will be linked to.\nThis path is typically a location within build_path, but can be\nvary on different build platforms.","ref":"Nerves.Artifact.html#build_path_link/1"},{"type":"function","title":"Nerves.Artifact.build_runner/1","doc":"","ref":"Nerves.Artifact.html#build_runner/1"},{"type":"function","title":"Nerves.Artifact.checksum/2","doc":"Produce a base16 encoded checksum for the package from the list of files\nand expanded folders listed in the checksum config key.","ref":"Nerves.Artifact.html#checksum/2"},{"type":"function","title":"Nerves.Artifact.clean/1","doc":"Cleans the artifacts for the package build_runners of all packages.","ref":"Nerves.Artifact.html#clean/1"},{"type":"function","title":"Nerves.Artifact.dir/1","doc":"The full path to the artifact.","ref":"Nerves.Artifact.html#dir/1"},{"type":"function","title":"Nerves.Artifact.download_name/2","doc":"Get the artifact download name","ref":"Nerves.Artifact.html#download_name/2"},{"type":"function","title":"Nerves.Artifact.download_path/1","doc":"Get the path to where the artifact archive is downloaded to.","ref":"Nerves.Artifact.html#download_path/1"},{"type":"function","title":"Nerves.Artifact.env_var/1","doc":"Determine the environment variable which would be set to override the path.","ref":"Nerves.Artifact.html#env_var/1"},{"type":"function","title":"Nerves.Artifact.env_var?/1","doc":"Check to see if the artifact path is being set from the system env.","ref":"Nerves.Artifact.html#env_var?/1"},{"type":"function","title":"Nerves.Artifact.expand_sites/1","doc":"Expands the sites helpers from `artifact_sites` in the nerves_package config.\n\nArtifact sites can pass options as a third parameter for adding headers\nor query string parameters. For example, if you are trying to resolve\nartifacts hosted in a private Github repo, use `:github_api` and\npass a user, tag, and personal access token into the sites helper:\n\n```elixir\n{:github_api, \"owner/repo\", username: \"skroob\", token: \"1234567\", tag: \"v0.1.0\"}\n```\n\nOr pass query parameters for the URL:\n\n```elixir\n{:prefix, \"https://my-organization.com\", query_params: %{\"id\" => \"1234567\", \"token\" => \"abcd\"}}\n```\n\nYou can also use this to add an authorization header for files behind basic auth.\n\n```elixir\n{:prefix, \"http://my-organization.com/\", headers: [{\"Authorization\", \"Basic \"   System.get_env(\"BASIC_AUTH\")}}]}\n```","ref":"Nerves.Artifact.html#expand_sites/1"},{"type":"function","title":"Nerves.Artifact.ext/1","doc":"Determines the extension for an artifact based off its type.\nToolchains use xz compression.","ref":"Nerves.Artifact.html#ext/1"},{"type":"function","title":"Nerves.Artifact.host_tuple/1","doc":"Get the host_tuple for the package. Toolchains are specifically build to run\non a host for a target. Other packages are host agnostic for now. They are\nmarked as `portable`.","ref":"Nerves.Artifact.html#host_tuple/1"},{"type":"function","title":"Nerves.Artifact.name/1","doc":"Get the artifact name","ref":"Nerves.Artifact.html#name/1"},{"type":"function","title":"Nerves.Artifact.stale?/1","doc":"Determines if the artifact for a package is stale and needs to be rebuilt.","ref":"Nerves.Artifact.html#stale?/1"},{"type":"behaviour","title":"Nerves.Artifact.BuildRunner","doc":"Defines the Nerves build runner behaviour\n\nA build runner is a module that can take package source and produce\nartifacts.","ref":"Nerves.Artifact.BuildRunner.html"},{"type":"callback","title":"Nerves.Artifact.BuildRunner.archive/3","doc":"","ref":"Nerves.Artifact.BuildRunner.html#c:archive/3"},{"type":"callback","title":"Nerves.Artifact.BuildRunner.build/3","doc":"","ref":"Nerves.Artifact.BuildRunner.html#c:build/3"},{"type":"callback","title":"Nerves.Artifact.BuildRunner.clean/1","doc":"","ref":"Nerves.Artifact.BuildRunner.html#c:clean/1"},{"type":"type","title":"Nerves.Artifact.BuildRunner.archive_result/0","doc":"","ref":"Nerves.Artifact.BuildRunner.html#t:archive_result/0"},{"type":"type","title":"Nerves.Artifact.BuildRunner.build_result/0","doc":"","ref":"Nerves.Artifact.BuildRunner.html#t:build_result/0"},{"type":"type","title":"Nerves.Artifact.BuildRunner.clean_result/0","doc":"","ref":"Nerves.Artifact.BuildRunner.html#t:clean_result/0"},{"type":"module","title":"Nerves.Artifact.BuildRunners.Docker","doc":"Produce an artifact for a package using Docker.\n\nThe Nerves Docker artifact build_runner will use docker to create the artifact\nfor the package. The output in Mix will be limited to the headlines from the\nprocess and the full build log can be found in the file `build.log` located\nroot of the package path.","ref":"Nerves.Artifact.BuildRunners.Docker.html"},{"type":"module","title":"Images - Nerves.Artifact.BuildRunners.Docker","doc":"Docker containers will be created based off the image that is loaded.\nBy default, containers will use the default image\n`ghcr.io/nerves-project/nerves_system_br:latest`. Sometimes additional host tools\nare required to build a package. Therefore, packages can provide their own\nimages by specifying it in the package config under `:build_runner_config`.\nthe file is specified as a tuple `{\"path/to/Dockerfile\", tag_name}`.\n\nExample:\n\n    build_runner_config: [\n      docker: {\"Dockerfile\", \"my_system:0.1.0\"}\n    ]","ref":"Nerves.Artifact.BuildRunners.Docker.html#module-images"},{"type":"module","title":"Volumes and Cache - Nerves.Artifact.BuildRunners.Docker","doc":"Nerves will mount several volumes to the container for use in building\nthe artifact.\n\nMounted from the host:\n\n  * `/nerves/env/ ` - The package being built.\n  * `/nerves/env/platform` - The package platform package.\n  * `/nerves/host/artifacts` - The host artifact directory.\n\nNerves will also mount the host NERVES_DL_DIR to save downloaded assets the\nbuild platform requires for producing the artifact.\nThis is mounted at `/nerves/dl`. This volume can significantly reduce build\ntimes but has potential for corruption. If you suspect that your build is\nfailing due to a faulty downloaded cached data, you can manually mount\nthe offending container and remove the file from this location or delete the\nentire directory.\n\nNerves uses a docker volume to attach the build files. The volume name is\ndefined as the package name and a unique id that is stored at\n`ARTIFACT_DIR/.docker_id`. The build directory is mounted to the container at\n`/nerves/build` and is configured as the current working directory.","ref":"Nerves.Artifact.BuildRunners.Docker.html#module-volumes-and-cache"},{"type":"module","title":"Cleanup - Nerves.Artifact.BuildRunners.Docker","doc":"Periodically, you may want to destroy all unused volumes to clean up.\nPlease refer to the Docker documentation for more information on how to\ndo this.\n\nWhen the build_runner is finished, the artifact is decompressed on the host at\nthe packages defined artifact directory.","ref":"Nerves.Artifact.BuildRunners.Docker.html#module-cleanup"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Docker.build/3","doc":"Create an artifact for the package\n\nOpts:\n  `make_args:` - Extra arguments to be passed to make.\n\n  For example:\n\n  You can configure the number of parallel jobs that buildroot\n  can use for execution. This is useful for situations where you may\n  have a machine with a lot of CPUs but not enough ram.\n\n    # mix.exs\n    defp nerves_package do\n      [\n        # ...\n        build_runner_opts: [make_args: [\"PARALLEL_JOBS=8\"]],\n      ]\n    end","ref":"Nerves.Artifact.BuildRunners.Docker.html#build/3"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Docker.parse_docker_version/1","doc":"","ref":"Nerves.Artifact.BuildRunners.Docker.html#parse_docker_version/1"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Docker.system_shell/1","doc":"Connect to a system configuration shell in a Docker container","ref":"Nerves.Artifact.BuildRunners.Docker.html#system_shell/1"},{"type":"module","title":"Nerves.Artifact.BuildRunners.Local","doc":"Builds an artifact locally.\n\nThis build_runner will only function on certain Linux host configurations","ref":"Nerves.Artifact.BuildRunners.Local.html"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Local.archive/3","doc":"Builds an artifact locally.","ref":"Nerves.Artifact.BuildRunners.Local.html#archive/3"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Local.build/3","doc":"Builds an artifact locally.\n\nOpts:\n  `make_args:` - Extra arguments to be passed to make.\n\n  For example:\n\n  You can configure the number of parallel jobs that buildroot\n  can use for execution. This is useful for situations where you may\n  have a machine with a lot of CPUs but not enough ram.\n\n    # mix.exs\n    defp nerves_package do\n      [\n        # ...\n        build_runner_opts: [make_args: [\"PARALLEL_JOBS=8\"]],\n      ]\n    end","ref":"Nerves.Artifact.BuildRunners.Local.html#build/3"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Local.clean/1","doc":"Builds an artifact locally.","ref":"Nerves.Artifact.BuildRunners.Local.html#clean/1"},{"type":"function","title":"Nerves.Artifact.BuildRunners.Local.system_shell/1","doc":"Connect to a system configuration sub-shell","ref":"Nerves.Artifact.BuildRunners.Local.html#system_shell/1"},{"type":"module","title":"Nerves.Artifact.Resolvers.URI","doc":"Downloads an artifact from a remote http location.","ref":"Nerves.Artifact.Resolvers.URI.html"},{"type":"function","title":"Nerves.Artifact.Resolvers.URI.get/1","doc":"Download the artifact from an http location","ref":"Nerves.Artifact.Resolvers.URI.html#get/1"},{"type":"module","title":"Nerves.Env","doc":"Contains package info for Nerves dependencies\n\nThe Nerves Env is used to load information from dependencies that\ncontain a nerves.exs config file in the root of the dependency\npath. Nerves loads this config because it needs access to information\nabout Nerves compile time dependencies before any code is compiled.","ref":"Nerves.Env.html"},{"type":"function","title":"Nerves.Env.bootstrap/0","doc":"Export environment variables used by Elixir, Erlang, C/C++ and other tools\nso that they use Nerves toolchain parameters and not the host's.\n\nFor a comprehensive list of environment variables, see the documentation\nfor the package defining system_platform.","ref":"Nerves.Env.html#bootstrap/0"},{"type":"function","title":"Nerves.Env.change_target/1","doc":"Re evaluates the mix file under a different target.\n\nThis allows you to start in one target, like host, but then\nswitch to a different target.","ref":"Nerves.Env.html#change_target/1"},{"type":"function","title":"Nerves.Env.clean/1","doc":"Cleans the artifacts for the package build_runners of all specified packages.","ref":"Nerves.Env.html#clean/1"},{"type":"function","title":"Nerves.Env.data_dir/0","doc":"The location for storing global nerves data.\n\nThe base directory is normally set by the `XDG_DATA_HOME`\nenvironment variable (i.e. `$XDG_DATA_HOME/nerves/`).\nIf `XDG_DATA_HOME` is unset, the user's home directory\nis used (i.e. `$HOME/.nerves`).","ref":"Nerves.Env.html#data_dir/0"},{"type":"function","title":"Nerves.Env.disable/0","doc":"Disable the Nerves Env compilers","ref":"Nerves.Env.html#disable/0"},{"type":"function","title":"Nerves.Env.download_dir/0","doc":"The download location for artifact downloads.\n\nPlacing an artifact tar in this location will bypass the need for it to\nbe downloaded.","ref":"Nerves.Env.html#download_dir/0"},{"type":"function","title":"Nerves.Env.enable/0","doc":"Enable the Nerves Env compilers","ref":"Nerves.Env.html#enable/0"},{"type":"function","title":"Nerves.Env.enabled?/0","doc":"Check if the env compilers are disabled","ref":"Nerves.Env.html#enabled?/0"},{"type":"function","title":"Nerves.Env.ensure_loaded/2","doc":"Ensures that an application which contains a Nerves package config has\nbeen loaded into the environment agent.","ref":"Nerves.Env.html#ensure_loaded/2"},{"type":"function","title":"Options - Nerves.Env.ensure_loaded/2","doc":"* `app` - The atom of the app to load\n  * `path` - Optional path for the app","ref":"Nerves.Env.html#ensure_loaded/2-options"},{"type":"function","title":"Nerves.Env.export_package_env/1","doc":"","ref":"Nerves.Env.html#export_package_env/1"},{"type":"function","title":"Nerves.Env.firmware_path/1","doc":"The path to the firmware file","ref":"Nerves.Env.html#firmware_path/1"},{"type":"function","title":"Nerves.Env.host_arch/0","doc":"Returns the architecture for the host system.","ref":"Nerves.Env.html#host_arch/0"},{"type":"function","title":"Example return values - Nerves.Env.host_arch/0","doc":"\"x86_64\"\n  \"arm\"","ref":"Nerves.Env.html#host_arch/0-example-return-values"},{"type":"function","title":"Nerves.Env.host_os/0","doc":"Returns the os for the host system.","ref":"Nerves.Env.html#host_os/0"},{"type":"function","title":"Example return values - Nerves.Env.host_os/0","doc":"\"win\"\n  \"linux\"\n  \"darwin\"","ref":"Nerves.Env.html#host_os/0-example-return-values"},{"type":"function","title":"Nerves.Env.images_path/1","doc":"The path to where firmware build files are stored\nThis can be overridden in a Mix project by setting the `:images_path` key.\n\n  images_path: \"/some/other/location\"\n\nDefaults to (build_path)/nerves/images","ref":"Nerves.Env.html#images_path/1"},{"type":"function","title":"Nerves.Env.loaded?/0","doc":"Check if the Nerves.Env is loaded","ref":"Nerves.Env.html#loaded?/0"},{"type":"function","title":"Nerves.Env.package/1","doc":"Gets a package by app name.","ref":"Nerves.Env.html#package/1"},{"type":"function","title":"Nerves.Env.packages/0","doc":"Lists all Nerves packages loaded in the Nerves environment.","ref":"Nerves.Env.html#packages/0"},{"type":"function","title":"Nerves.Env.packages_by_type/2","doc":"Lists packages by package type.","ref":"Nerves.Env.html#packages_by_type/2"},{"type":"function","title":"Nerves.Env.start/0","doc":"Starts the Nerves environment agent and loads package information.\nIf the Nerves.Env is already started, the function returns\n`{:error, {:already_started, pid}}` with the pid of that process","ref":"Nerves.Env.html#start/0"},{"type":"function","title":"Nerves.Env.stop/0","doc":"Stop the Nerves environment agent.","ref":"Nerves.Env.html#stop/0"},{"type":"function","title":"Nerves.Env.system/0","doc":"Helper function for returning the system type package","ref":"Nerves.Env.html#system/0"},{"type":"function","title":"Nerves.Env.system_platform/0","doc":"Helper function for returning the system_platform type package","ref":"Nerves.Env.html#system_platform/0"},{"type":"function","title":"Nerves.Env.toolchain/0","doc":"Helper function for returning the toolchain type package","ref":"Nerves.Env.html#toolchain/0"},{"type":"function","title":"Nerves.Env.toolchain_platform/0","doc":"Helper function for returning the toolchain_platform type package","ref":"Nerves.Env.html#toolchain_platform/0"},{"type":"module","title":"Nerves.Erlinit","doc":"Decode and encode erlinit.config files\n\nThis module is used to decode, merge, and encode multiple erlinit.config\nfiles.","ref":"Nerves.Erlinit.html"},{"type":"function","title":"Nerves.Erlinit.decode_config/1","doc":"Decode the data from the config into a keyword list","ref":"Nerves.Erlinit.html#decode_config/1"},{"type":"function","title":"Nerves.Erlinit.encode_config/1","doc":"Encode the keyword list options into an erlinit.config file format","ref":"Nerves.Erlinit.html#encode_config/1"},{"type":"function","title":"Nerves.Erlinit.merge_opts/2","doc":"Merge keyword options","ref":"Nerves.Erlinit.html#merge_opts/2"},{"type":"function","title":"Nerves.Erlinit.system_config_file/1","doc":"Return the path to the erlinit.config file provided by the Nerves System","ref":"Nerves.Erlinit.html#system_config_file/1"},{"type":"type","title":"Nerves.Erlinit.option/0","doc":"","ref":"Nerves.Erlinit.html#t:option/0"},{"type":"type","title":"Nerves.Erlinit.t/0","doc":"","ref":"Nerves.Erlinit.html#t:t/0"},{"type":"module","title":"Nerves.Package","doc":"Defines a Nerves package struct and helper functions.\n\nA Nerves package is a Mix application that defines the configuration for a\nNerves system or Nerves toolchain. For more details, see the Nerves\n[system documentation](https://hexdocs.pm/nerves/systems.html#package-configuration)","ref":"Nerves.Package.html"},{"type":"function","title":"Nerves.Package.config/2","doc":"Get Mix.Project config for an application","ref":"Nerves.Package.html#config/2"},{"type":"function","title":"Nerves.Package.config_path/1","doc":"Takes the path to the package and returns the path to its package config.","ref":"Nerves.Package.html#config_path/1"},{"type":"function","title":"Nerves.Package.load_config/1","doc":"Loads the package config and parses it into a `%Package{}`","ref":"Nerves.Package.html#load_config/1"},{"type":"function","title":"Nerves.Package.shell/1","doc":"Starts an interactive shell with the working directory set\nto the package path","ref":"Nerves.Package.html#shell/1"},{"type":"type","title":"Nerves.Package.t/0","doc":"","ref":"Nerves.Package.html#t:t/0"},{"type":"behaviour","title":"Nerves.Package.Platform","doc":"Defines the Nerves package platform behaviour\n\nThis behaviour is implemented on a module that would be used to construct\nan artifact for a nerves package. Nerves packages are prioritized to be\ncompiled before any other dependencies, therefore, a package platform\nis useful for constructing host tools to be used during the elixir compile\nphase.\n\nYou can implement both `Nerves.Package.Platform` and `Nerves.Artifact.BuildRunner`\nin the same module with the using macro.\n\nHere is a simple example that touches a file in the `Artifact.build_path`\n\n```elixir\ndefmodule SystemPlatform do\n  use Nerves.Package.Platform\n\n  def bootstrap(_pkg) do\n    System.put_env(\"NERVES_BOOTSTRAP_SYSTEM\", \"1\")\n    :ok\n  end\n\n  def build(pkg, _toolchain, _opts) do\n    build_path = Artifact.build_path(pkg)\n    File.rm_rf!(build_path)\n    File.mkdir_p!(build_path)\n\n    build_path\n    |> Path.join(\"file\")\n    |> File.touch()\n\n    {:ok, build_path}\n  end\n\n  def build_path_link(pkg) do\n    Artifact.build_path(pkg)\n  end\n\n  def archive(pkg, _toolchain, _opts) do\n    build_path = Artifact.build_path(pkg)\n    name = Artifact.download_name(pkg)   Artifact.ext(pkg)\n    Nerves.Utils.File.tar(build_path, name)\n    {:ok, Path.join(File.cwd!, name)}\n  end\n\n  def clean(pkg) do\n    Artifact.build_path(pkg)\n    |> File.rm_rf()\n  end\nend\n\n```","ref":"Nerves.Package.Platform.html"},{"type":"callback","title":"Nerves.Package.Platform.bootstrap/1","doc":"Bootstrap is called as the final phase of loading the Nerves environment.\n It is used typically for setting / unsetting any system environment\n variables. For example, if we were building a C cross compiler, we would\n use the bootstrap phase to override CC to point to our compiler.","ref":"Nerves.Package.Platform.html#c:bootstrap/1"},{"type":"callback","title":"Nerves.Package.Platform.build_path_link/1","doc":"Build path link should return the location inside the `Artifact.build_path`\nthat represents the final artifact. This is used to symlink the global\nartifact to the local build_path location.","ref":"Nerves.Package.Platform.html#c:build_path_link/1"},{"type":"module","title":"Nerves.Port","doc":"The code from this file was copied in from MuonTrap\nhttps://github.com/fhunleth/muontrap","ref":"Nerves.Port.html"},{"type":"function","title":"Nerves.Port.cmd/3","doc":"Run a command in a similar way to System.cmd/3.","ref":"Nerves.Port.html#cmd/3"},{"type":"function","title":"Nerves.Port.exec_path/0","doc":"","ref":"Nerves.Port.html#exec_path/0"},{"type":"module","title":"Nerves.System.BR","doc":"Package builder for Buildroot-based Nerves systems","ref":"Nerves.System.BR.html"},{"type":"function","title":"Nerves.System.BR.archive/3","doc":"Create an archive of the artifact","ref":"Nerves.System.BR.html#archive/3"},{"type":"function","title":"Nerves.System.BR.bootstrap/1","doc":"Called as the last step of bootstrapping the Nerves env.","ref":"Nerves.System.BR.html#bootstrap/1"},{"type":"function","title":"Nerves.System.BR.build/3","doc":"Build the artifact","ref":"Nerves.System.BR.html#build/3"},{"type":"function","title":"Nerves.System.BR.build_path_link/1","doc":"Return the location in the build path to where the global artifact is linked.","ref":"Nerves.System.BR.html#build_path_link/1"},{"type":"function","title":"Nerves.System.BR.clean/1","doc":"Clean up all the build files","ref":"Nerves.System.BR.html#clean/1"},{"type":"module","title":"Nerves.Utils.WSL","doc":"This module contains utility functions to assist in detecting a Windows\nSubsystem for Linux environment as well as functions to convert paths between\nthe Windows host and Linux.","ref":"Nerves.Utils.WSL.html"},{"type":"function","title":"Nerves.Utils.WSL.admin_powershell_command/2","doc":"Returns a two item tuple where the first item is a command and the second is\nthe argument list to run a powershell command as administrator in Windows","ref":"Nerves.Utils.WSL.html#admin_powershell_command/2"},{"type":"function","title":"Nerves.Utils.WSL.cleanup_file/2","doc":"If the file was created in a temporary location, get the WSL path and delete it. Otherwise return `:ok`","ref":"Nerves.Utils.WSL.html#cleanup_file/2"},{"type":"function","title":"Nerves.Utils.WSL.execute_wslpath/2","doc":"Executes wslpath with the file and arguments.\n\nWhen a valid WSL path is passed through to `wslpath` asking for a\nvalid path an \"Invalid argument\" error is returned. This function\ncatches this error and returns the valid path.","ref":"Nerves.Utils.WSL.html#execute_wslpath/2"},{"type":"function","title":"Nerves.Utils.WSL.get_fwup_devices/0","doc":"Gets a list of fwup devices on a Windows host. This function can be run from\nwithin WSL, as it runs a powershell command to get the list and writes it to a\ntemporary file that WSL can access.","ref":"Nerves.Utils.WSL.html#get_fwup_devices/0"},{"type":"function","title":"Nerves.Utils.WSL.get_temp_file_location/1","doc":"Returns a path to the base file name a temporary location in Windows","ref":"Nerves.Utils.WSL.html#get_temp_file_location/1"},{"type":"function","title":"Nerves.Utils.WSL.get_wsl_paths/2","doc":"Returns a two item tuple containing the Windows host path for a file and its WSL counterpart.\n\nIf the path is not available in either Windows or WSL, nil will replace the item","ref":"Nerves.Utils.WSL.html#get_wsl_paths/2"},{"type":"function","title":"Examples - Nerves.Utils.WSL.get_wsl_paths/2","doc":"iex> Nerves.Utils.WSL.get_wsl_paths(\"mix.exs\", Nerves.Utils.WSL.has_wslpath?())\n    {\"C:\\Users\\username\\src\\nerves\\mix.exs\",\n    \"/mnt/c/Users/username/src/nerves/mix.exs\"}","ref":"Nerves.Utils.WSL.html#get_wsl_paths/2-examples"},{"type":"function","title":"Nerves.Utils.WSL.has_wslpath?/0","doc":"Returns true if the WSL utility `wslpath` is available","ref":"Nerves.Utils.WSL.html#has_wslpath?/0"},{"type":"function","title":"Nerves.Utils.WSL.make_file_accessible/3","doc":"Returns an item tuple with the Windows accessible path and whether the path is a temporary location or original location","ref":"Nerves.Utils.WSL.html#make_file_accessible/3"},{"type":"function","title":"Nerves.Utils.WSL.path_accessible_in_windows?/2","doc":"Returns true if the path is accessible in Windows","ref":"Nerves.Utils.WSL.html#path_accessible_in_windows?/2"},{"type":"function","title":"Nerves.Utils.WSL.running_on_wsl?/0","doc":"Returns true if inside a WSL shell environment","ref":"Nerves.Utils.WSL.html#running_on_wsl?/0"},{"type":"function","title":"Nerves.Utils.WSL.valid_windows_path?/1","doc":"Returns true when the path matches various kinds of Windows-specific paths, like:\n\n```\nC:\\\nC:\\projects\n\\\\myserver\\sharename\\\n\\\\wsl$\\Ubuntu-18.04\\home\\username\\my_project\\\n```","ref":"Nerves.Utils.WSL.html#valid_windows_path?/1"},{"type":"function","title":"Nerves.Utils.WSL.valid_wsl_path?/1","doc":"Returns true if the path is not a Windows path","ref":"Nerves.Utils.WSL.html#valid_wsl_path?/1"},{"type":"extras","title":"Installation","doc":"# Installation\n\nNerves requires a number of programs on your system to work. These include\nErlang, Elixir, and a few tools for packaging firmware images. Nerves is\nactively used on MacOS and various Linux distributions. For Windows users, some\npeople have had success running Linux in a virtual machine or using the Windows\nSubsystem for Linux available in Windows 10. If you have issues with any of the\ntooling after following the steps below, we recommend you reach out to us in\n[the #nerves channel on the Elixir\nSlack](https://elixir-slackin.herokuapp.com/).\n\nNerves requires that the Erlang version running on your development host be\ncompatible with the Erlang version on the embedded target and also depends on\nfeatures added in recent versions of Elixir (`~> 1.11`). Because it can be hard\nto manage these tool versions with sufficient granularity using operating system\npackages, it is recommended that you use [ASDF](https://github.com/asdf-vm/asdf)\nto manage Erlang and Elixir installations. This tool works the same on its\nsupported platforms, so you'll find more details in the All Platforms section\nbelow.","ref":"installation.html"},{"type":"extras","title":"MacOS - Installation","doc":"The easiest installation route on MacOS is to use [Homebrew](https://brew.sh).\nJust run the following:\n\n```bash\nbrew update\nbrew install fwup squashfs coreutils xz pkg-config\n```\n\nIf you've already installed Erlang & Elixir using Homebrew, you'll need to\nuninstall them to avoid clashes with the recommended ASDF installation.\n\n```bash\nbrew uninstall elixir\nbrew uninstall erlang\n```\n\nOptionally, if you want to build custom Nerves Systems, you'll also need to\ninstall [Docker for Mac](https://www.docker.com/docker-mac). After installing\nDocker for Mac, you will likely want to adjust the resource limits imposed on\nDocker, to allow it to successfully compile more complicated custom systems.\nClick the Docker icon in the top menu bar, then click Preferences > Advanced and\nallow Docker to use all of your CPUs and as much RAM as you think is reasonable\nfor your machine (at least 6 GB). The more resources it has access to, the\nfaster you can compile a custom Nerves system.\n\nNow skip to the instructions for all platforms below.","ref":"installation.html#macos"},{"type":"extras","title":"Windows - Installation","doc":"Nerves on Windows 10 requires version 18917 (or later) with Windows Subsystem\nfor Linux 2 (WSL2) installed. See the [WSL2 install\ninstructions](https://docs.microsoft.com/en-us/windows/wsl/wsl2-install) for\nmore information. Once you have WSL2 support enabled you will need to install an\ninstance of Linux. We recommend installing Ubuntu.\n\nNext, follow the instructions for Linux inside your WSL2 Linux installation to\nfinish setting up the environment.\n\nFinally, you'll need to install `fwup` using Chocolatey. See the [chocolatey\ninstall guide](https://chocolatey.org/install) for help installing Chocolatey on\nyour system. With Chocolatey installed, run the following from a Powershell:\n\n```powershell\nchoco install fwup /y\n```\n\nWhen running on WSL2, Nerves uses the Linux version of `fwup` for building the\nfirmware files and the Windows version of `fwup` for burning firmware to SD\ncards. It is important that you install `fwup ` in both environments.","ref":"installation.html#windows"},{"type":"extras","title":"Linux - Installation","doc":"#","ref":"installation.html#linux"},{"type":"extras","title":"Package manager installs - Installation","doc":"First, install a few packages using your package manager.\n\n##","ref":"installation.html#package-manager-installs"},{"type":"extras","title":"On Debian-based systems - Installation","doc":"```bash\nsudo apt install build-essential automake autoconf git squashfs-tools ssh-askpass pkg-config curl libmnl-dev\n```\n\n##","ref":"installation.html#on-debian-based-systems"},{"type":"extras","title":"On Arch-based systems - Installation","doc":"```bash\nyay -S base-devel ncurses5-compat-libs openssh-askpass git squashfs-tools curl\n```\n\nIf you're curious, `squashfs-tools` will be used by Nerves to create root\nfilesystems and `ssh-askpass` will be used to ask for passwords when writing to\nMicroSD cards. Some Fedora and Manjaro users have reported that they had to create a symlink\nfrom `/usr/bin/ssh-askpass` to `/usr/bin/qt4-ssh-askpass`.\n\n##","ref":"installation.html#on-arch-based-systems"},{"type":"extras","title":"On NixOS or with Nix package manager - Installation","doc":"Create a `shell.nix` file with the following contents:\n\n```nix\n{ pkgs ? import   {} }:\n\nwith pkgs;\n\nmkShell {\n  name = \"nervesShell\";\n  buildInputs = [\n    autoconf\n    automake\n    curl\n    erlangR25\n    fwup\n    git\n    pkgs.beam.packages.erlangR25.elixir\n    rebar3\n    squashfsTools\n    x11_ssh_askpass\n    pkg-config\n  ];\n  shellHook = ''\n    SUDO_ASKPASS=${pkgs.x11_ssh_askpass}/libexec/x11-ssh-askpass\n  '';\n}\n```\n\nUse `nix-shell shell.nix` to start a shell with all the Nerves dependencies\nneeded for building firmware.\n\nIf instead, you'd like to install the dependencies on your host system, you can\ninclude the same packages listed under `buildInputs` in the\n`environment.systemPackages` section of your NixOS `configuration.nix` file.\n\nPlease notes that you may need to adjust the `SUDO_ASKPASS` environment\nvariable to include the correct path to the askpass program of your choice. A\nknown, working alternative to `x11_ssh_askpass` is `lxqt.lxqt-openssh-askpass`\n\n\n#","ref":"installation.html#on-nixos-or-with-nix-package-manager"},{"type":"extras","title":"fwup - Installation","doc":"Next, install the `fwup` utility. Nerves uses `fwup` to create, distribute, and\ninstall firmware images. You can install `fwup` using the instructions found at\n[Installation Page](https://github.com/fwup-home/fwup#installing). Installing the\npre-built `.deb` or `.rpm` files is recommended.\n\nIf you want to build custom Nerves Systems, you need a few more build tools. If\nyou skip this step, you'll get an error message with instructions if you ever\nneed to build a custom system. On Debian and Ubuntu, run the following:\n\n```bash\nsudo apt install libssl-dev libncurses5-dev bc m4 unzip cmake python\n```\n\n#","ref":"installation.html#fwup"},{"type":"extras","title":"Other Linux distributions - Installation","doc":"For other distributions, try adapting one of the sections above.\n\nWhen you have it working, please consider [sending us an improvement to this\npage](https://github.com/nerves-project/nerves/blob/main/docs/Installation.md).","ref":"installation.html#other-linux-distributions"},{"type":"extras","title":"All platforms - Installation","doc":"First, install the required versions of Erlang/OTP and Elixir. We highly\nrecommend using ASDF since the versions in use will be under your control. See\nthe [ASDF docs](https://asdf-vm.com/#/core-manage-asdf) for official\ndocumentation.\n\nIMPORTANT: Elixir 1.11.0 and 1.11.1 do not work with Nerves. Elixir 1.11.2 and\nlater are fine.\n\nHere's a summary of the install process:\n\n```bash\ngit clone https://github.com/asdf-vm/asdf.git ~/.asdf --branch v0.11.0\n\n# The following steps are for bash. If you’re using something else, do the\n# equivalent for your shell.\necho -e '\\n. $HOME/.asdf/asdf.sh' >> ~/.bashrc\necho -e '\\n. $HOME/.asdf/completions/asdf.bash' >> ~/.bashrc # optional\nsource ~/.bashrc\n\n# For zsh based systems run the following\necho -e '\\n. $HOME/.asdf/asdf.sh' >> ~/.zshrc\n# Add complete command used by asdf.bash\necho -e 'autoload -U +X bashcompinit && bashcompinit' >> ~/.zshrc\necho -e 'autoload -U +X compinit && compinit' >> ~/.zshrc\necho -e '\\n. $HOME/.asdf/completions/asdf.bash' >> ~/.zshrc\nsource ~/.zshrc\n\nasdf plugin-add erlang\nasdf plugin-add elixir\n\n# Note #1:\n# If on Debian or Ubuntu, you'll want to install wx before running the next line:\n# For Ubuntu versions before 20.04 run the next line:\n# sudo apt install libwxgtk3.0-dev\n# For Ubuntu 20.04 and up run the next line:\n# sudo apt install libwxgtk3.0-gtk3-dev\n# for arch based systems run the next line:\n# yay -S wxgtk2 fop jdk-openjdk unzip\n\n\n# Note #2:\n# It's possible to use different Erlang and Elixir versions with Nerves. The\n# latest official Nerves systems are compatible with the versions below. In\n# general, differences in patch releases are harmless. Nerves detects\n# configurations that might not work at compile time.\nasdf install erlang 26.0.2\nasdf install elixir 1.15.4-otp-26\nasdf global erlang 26.0.2\nasdf global elixir 1.15.4-otp-26\n```\n\nIt is important to update the versions of `hex` and `rebar` used by Elixir,\n**even if you already had Elixir installed**.\n\n```bash\nmix local.hex\nmix local.rebar\n```\n\nIf you have your own version of `rebar` in your path, be sure that it is\nup-to-date.\n\nYou can now add the `nerves_bootstrap` archive to your Mix environment. This\narchive allows Nerves to bootstrap the Mix environment, ensuring that your code\nis properly compiled using the right cross-compiler for the target. The\n`nerves_bootstrap` archive also includes a project generator, which you can use\nto create new Nerves projects. To install the `nerves_bootstrap` archive:\n\n```bash\nmix archive.install hex nerves_bootstrap\n```\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"installation.html#all-platforms"},{"type":"extras","title":"Getting Started","doc":"# Getting Started","ref":"getting-started.html"},{"type":"extras","title":"Introduction - Getting Started","doc":"Nerves defines a new way to build embedded systems using [Elixir](https://elixir-lang.org/). It is\nspecifically designed for embedded systems, not desktop or server systems.  You\ncan think of Nerves as containing three parts:\n\n- **Platform** - a customized, minimal [Buildroot](https://buildroot.org)-derived Linux that boots directly to the [BEAM VM](https://en.wikipedia.org/wiki/BEAM_(Erlang_virtual_machine)).\n- **Framework** - ready-to-go library of Elixir modules to get you up and running quickly.\n- **Tooling** - powerful command-line tools to manage builds, update firmware, configure devices, and more.\n\nTaken together, the Nerves platform, framework, and tooling provide a highly specialized environment for using Elixir to build advanced embedded devices.","ref":"getting-started.html#introduction"},{"type":"extras","title":"Common terms - Getting Started","doc":"In the following guides, support channels, and forums, you may hear the following terms being used.\n\nTerm | Definition\n--- | ---\nhost | The computer on which you are editing source code, compiling, and assembling firmware\ntarget | The platform for which your firmware is built (for example, Raspberry Pi Zero W, Raspberry Pi 4, or Beaglebone Black)\ntoolchain | The tools required to build code for the target, such as compilers, linkers, binutils, and C runtime\nsystem | A lean Buildroot-based Linux distribution that has been customized and cross-compiled for a particular target\nassemble | The process of combining system, application, and configuration into a firmware bundle\nfirmware bundle | A single file that contains an assembled version of everything needed to burn firmware\nfirmware image | Built from a firmware bundle and contains the partition table, partitions, bootloader, etc.","ref":"getting-started.html#common-terms"},{"type":"extras","title":"Creating a new Nerves app - Getting Started","doc":"Before you start using Nerves, it is important that you take a minute to read\nthe [Installation Guide](installation.html).  It will help you get your machine\nconfigured for running Nerves.\n\nLet's create a new project.  The `nerves.new` project generator can be called\nfrom anywhere and can take either an absolute path or a relative path.\n\n``` bash\nmix nerves.new hello_nerves\n```\n\nNerves will generate the required files and directory structure for your\napplication. If you chose not to fetch dependencies during project generation, you will need\nto do that yourself.\n\nAs described by the project generator, the next step is to change to the project\ndirectory, choose a target, and fetch the target-specific dependencies.\n\n> ##","ref":"getting-started.html#creating-a-new-nerves-app"},{"type":"extras","title":"What is my device's _MIX_TARGET_? {: .tip} - Getting Started","doc":">\n> Visit the [Targets Page](targets.html) for information on what target name to\n> use for each of the boards that Nerves supports. The default target is `host`\n> unless you specify a different target in your environment.\n\nThe target is chosen using a shell environment variable, so if you use the\n`export` command, it will remain in effect as long as you leave that window\nopen.\n\n``` bash\ncd hello_nerves\nexport MIX_TARGET=rpi0\nmix deps.get\n```\n\nAlternatively, you can prefix each command with the environment variable.\nWe find that it's easiest to have two shell windows open: one remaining\ndefaulted to the `host` target and one with the desired `MIX_TARGET` variable\nset.\n\n```bash\ncd hello_nerves\nMIX_TARGET=rpi0 mix deps.get\n```\n\nThis allows you quick access to use host-based tooling in the former and\ndeploy updated firmware from the latter, all without having to modify the\n`MIX_TARGET` variable in your shell.","ref":"getting-started.html#what-is-my-device-s-_mix_target_-tip"},{"type":"extras","title":"Building and deploying firmware - Getting Started","doc":"Once the dependencies are fetched, you can build a Nerves Firmware (a bundle\nthat contains a minimal Linux platform and your application, packaged as an OTP\nrelease).  The first time you ask any dependencies or your application to\ncompile, Nerves will fetch the System and Toolchain from one of our cache\nmirrors.  These artifacts are cached locally in `~/.nerves/artifacts` so they\ncan be shared across projects.\n\nFor remote deployment information, see \"How do I push firmware updates\nremotely?\" in the [FAQ](FAQ.md#how-do-i-push-firmware-updates-remotely).\n\n> ##","ref":"getting-started.html#building-and-deploying-firmware"},{"type":"extras","title":"Deleting cached artifacts {: .tip} - Getting Started","doc":">\n> It is always OK to `rm -fr ~/.nerves`. The consequence is that the archives\n> that you're using will need to be re-downloaded when you run `mix deps.get`.\n\n#","ref":"getting-started.html#deleting-cached-artifacts-tip"},{"type":"extras","title":"Create the firmware bundle - Getting Started","doc":"You can create the firmware bundle with the following command:\n\n```bash\nmix firmware\n```\n\nor\n\n```bash\nMIX_TARGET=rpi0 mix firmware\n```\n\nThis will result in a `hello_nerves.fw` firmware bundle file.\n\n#","ref":"getting-started.html#create-the-firmware-bundle"},{"type":"extras","title":"Create a bootable SD card - Getting Started","doc":"To create a bootable SD card, use the following command:\n\n```bash\nmix firmware.burn\n```\n\nor\n\n```bash\nMIX_TARGET=rpi0 mix firmware.burn\n```\n\nThis command will attempt to automatically discover the SD card inserted in your\nhost.\n\n> ##","ref":"getting-started.html#create-a-bootable-sd-card"},{"type":"extras","title":"More than one SD cards or disk images? {: .tip} - Getting Started","doc":">\n> `mix firmware.burn` may fail to correctly detect your SD card, for example,\n> if you have more than one SD card inserted or you have disk images mounted.\n> If this happens, you can specify the intended device by passing the\n> `-d  ` argument to the command. For example\n> `mix firmware.burn -d /dev/rdisk3`\n>\n> You can alse use `-d  ` to specify an output file that is a raw\n> image of the SD card. This binary image can be burned to an SD card using\n> [Raspberry Pi Imager](https://www.raspberrypi.com/software/), [Etcher](https://www.balena.io/etcher/), `dd`, `Win32DiskImager`, or other image copying utilities.\n\nFor more options, refer to the `mix firmware.burn` documentation.\n\nNow that you have your SD card burned, you can insert it into your device and\nboot it up.","ref":"getting-started.html#more-than-one-sd-cards-or-disk-images-tip"},{"type":"extras","title":"Connecting to your Nerves target - Getting Started","doc":"There are multiple ways to connect to your Nerves target device and different\ntarget may support different connection methods:\n\n- USB to TTL serial cable (aka FTDI cable)\n- HDMI cable\n- USB data cable\n- Ethernet\n- WiFi\n\nWhen connecting with a USB to TTL serial cable or an HDMI cable before booting\nup your device, you can see your device booting to the IEx console.\n\nFor more info, refer to [Connecting to Nerves Target page](connecting-to-nerves-target.html).\n\n> ##","ref":"getting-started.html#connecting-to-your-nerves-target"},{"type":"extras","title":"What features does Nerves support for my device? {: .tip} - Getting Started","doc":">\n> Refer to the documentation of `nerves_system_ ` projects for their\n> supported features. As an example, when your target is `rpi0`,\n> visit https://hexdocs.pm/nerves_system_rpi0.","ref":"getting-started.html#what-features-does-nerves-support-for-my-device-tip"},{"type":"extras","title":"Inspecting your target in `IEx` - Getting Started","doc":"Once you are connected to your target device, an `IEx` prompt will appear with\n[`NervesMOTD`](https://hexdocs.pm/nerves_motd/readme.html).\n`IEx` is your main entry point to interacting with Elixir, your program, and hardware.\n\n```bash\nssh nerves.local\n\nInteractive Elixir (1.13.4) - press Ctrl+C to exit (type h() ENTER for help)\n████▄▄    ▐███\n█▌  ▀▀██▄▄  ▐█\n█▌  ▄▄  ▀▀  ▐█   N  E  R  V  E  S\n█▌  ▀▀██▄▄  ▐█\n███▌    ▀▀████\nhello_nerves 0.2.0 (40705268-3e85-52b6-7c7a-05ffd33a31b8) arm rpi0\n  Uptime       : 1 days, 3 hours, 6 minutes and 29 seconds\n  Clock        : 2022-08-11 21:44:09 EDT\n\n  Firmware     : Valid (B)               Applications : 57 started\n  Memory usage : 87 MB (28%)             Part usage   : 2 MB (0%)\n  Hostname     : nerves-mn02             Load average : 0.15 0.12 0.14\n\n  wlan0        : 10.0.0.25/24, 2601:14d:8602:2a0:ba27:ebff:fecb:222a/64, fe80::ba27:ebff:fecb:222a/64\n  usb0         : 172.31.36.97/30, fe80::3c43:59ff:fec9:6716/64\n\nNerves CLI help: https://hexdocs.pm/nerves/iex-with-nerves.html\n\nToolshed imported. Run h(Toolshed) for more info.\niex(nerves@nerves.local)1>\n```\n\nThe [Toolshed](https://hexdocs.pm/toolshed/Toolshed.html) package contains\nmany useful commands. Enter the following command to display the help for the\n[Toolshed](https://hexdocs.pm/toolshed/Toolshed.html) package.\n\n```elixir\nh Toolshed\n```\n\nGo ahead and try them out to explore your target's runtime environment.\n\nFor more info on Nerves-specific use of the IEx prompt, refer to\n[IEx with Nerves Page](https://hexdocs.pm/nerves/iex-with-nerves.html).","ref":"getting-started.html#inspecting-your-target-in-iex"},{"type":"extras","title":"Nerves Livebook - Getting Started","doc":"The [Nerves Livebook firmware](https://github.com/nerves-livebook/nerves_livebook)\nlets you try out the Nerves projects on real hardware without needing to build\nanything. Within minutes, you'll have a Raspberry Pi or Beaglebone running\nNerves. You'll be able to run code in [Livebook](https://livebook.dev/) and\nwork through Nerves tutorials from the comfort of your browser.\n\nLooking for a quick demo first? Click below for\n[Underjord](https://www.youtube.com/c/Underjord)'s Nerves Quickstart video.\n\n[![Install video](https://github.com/nerves-livebook/nerves_livebook/raw/main/assets/video.jpg)](https://www.youtube.com/watch?v=-b5TPb_MwQE)","ref":"getting-started.html#nerves-livebook"},{"type":"extras","title":"Nerves examples - Getting Started","doc":"To get up and running quickly, you can check out our [collection of example\nprojects](https://github.com/nerves-project/nerves_examples).  Be sure to set\nyour `MIX_TARGET` environment variable appropriately for the target hardware you\nhave.  Visit the [Targets Page](targets.html) for more information on what\ntarget name to use for the boards that Nerves supports.\n\nThe `nerves_examples` repository contains several example projects to get you\nstarted.  The simplest example is Blinky, known as the \"Hello World\" of hardware\nbecause all it does is blink an LED indefinitely.  If you are ever curious about\nproject structuring or can't get something running, check out Blinky and run it\non your target to confirm that it works in the simplest case.\n\n```bash\ngit clone https://github.com/nerves-project/nerves_examples\nexport MIX_TARGET=rpi0\ncd nerves_examples/blinky\nmix do deps.get, firmware, firmware.burn\n```","ref":"getting-started.html#nerves-examples"},{"type":"extras","title":"Nerves communities - Getting Started","doc":"- [Elixir Slack #nerves channel](https://elixir-slackin.herokuapp.com/)\n- [Nerves Forum](https://elixirforum.com/c/elixir-framework-forums/nerves-forum/74)\n- [Nerves Meetup](https://www.meetup.com/nerves)\n- [Nerves Newsletter](https://underjord.io/nerves-newsletter.html)\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"getting-started.html#nerves-communities"},{"type":"extras","title":"Connecting to Nerves Target","doc":"# Connecting to Nerves Target\n\nThere are multiple ways to connect to your Nerves target device and different\ntarget may support different connection methods.\n\nThe default features are different depending on Nerves targets. For example,\nsome Nerves targets support a UART serial console by default; others,\nHDMI and USB keyboard instead.\n\n> ##","ref":"connecting-to-nerves-target.html"},{"type":"extras","title":"What features does Nerves support for my device? {: .tip} - Connecting to Nerves Target","doc":">\n> Refer to the documentation of `nerves_system_ ` projects for their\n> supported features. As an example, when your target is `rpi0`,\n> visit https://hexdocs.pm/nerves_system_rpi0.","ref":"connecting-to-nerves-target.html#what-features-does-nerves-support-for-my-device-tip"},{"type":"extras","title":"USB to TTL serial cable (UART) - Connecting to Nerves Target","doc":"A target device can be accessed via a serial connection with a USB to TTL serial\ncable, which is connected between the host USB port and a couple of header pins\non the target.\n\nThis connection method allows you to interact with the console of the target\ndevice using a terminal emulator program on your development host. It is useful\nfor debugging networking or the boot process and for advanced development\nworkflows.\n\nFirst of all, locate the documentation of the Nerve system that corresponds to\nyour target device, and find out how your Nerves system supports the IEx\nterminal feature.\n\nAs an example, as of this writing, the documentation of\n[nerves_system_rpi0] (a Nerves system for [Raspberry Pi Zero]) says the system\nsupports one UART port named `ttyAMA0` available for IEx terminal.\nIt is `/dev/ttyAMA0` in the file system.\n\n![](https://user-images.githubusercontent.com/7563926/181918220-00733048-8706-4b40-957d-b621d308fc2f.png)\n\nIt is configured [here](https://github.com/nerves-project/nerves_system_rpi0/blob/ddb128989cf9bb28dd78f4467992d00b89828f02/rootfs_overlay/etc/erlinit.config#L12)\nin the `nerves_system_rpi0` source code.\n\nOn the Raspberry Pi Zero, the UART that is known as `UART0` in the hardware\ndescriptions is routed to pins 8 and 10.\n\nOn Linux on the Raspberry Pi Zero, `UART0` is exposed as the device file\n `/dev/ttyAMA0`.\n\n> ##","ref":"connecting-to-nerves-target.html#usb-to-ttl-serial-cable-uart"},{"type":"extras","title":"Enabling USB serial console {: .info} - Connecting to Nerves Target","doc":">\n> Depending on your target's default settings, you may need to modify your\n> Nerves configuration as described in the\n> [Using a USB Serial Console](faq.html#using-a-usb-serial-console)\n> FAQ topic.\n\n[raspberry pi zero]: https://www.raspberrypi.com/products/raspberry-pi-zero-w\n[raspberry pi zero w]: https://www.raspberrypi.com/products/raspberry-pi-zero-w\n[nerves_system_rpi0]: https://hexdocs.pm/nerves_system_rpi0\n\n#","ref":"connecting-to-nerves-target.html#enabling-usb-serial-console-info"},{"type":"extras","title":"Get a USB-to-TTL serial cable - Connecting to Nerves Target","doc":"We've had good luck with [this cable](https://www.adafruit.com/product/954) if\nyou haven't already found one.\n\nYou may need to install to your host machine the driver software for the cable.\nIf you use the above-mentioned cable, Adafruits provides [this guide][usb-to-ttl serial cable - software installation].\n\n[usb-to-ttl serial cable - software installation]: https://learn.adafruit.com/adafruits-raspberry-pi-lesson-5-using-a-console-cable/software-installation-mac\n\n#","ref":"connecting-to-nerves-target.html#get-a-usb-to-ttl-serial-cable"},{"type":"extras","title":"Connect the leads - Connecting to Nerves Target","doc":"| Raspberry Pi             | USB-to-TTL Serial Cable |\n| ------------------------ | ----------------------- |\n| `TX0` (pin 8 / GPIO 14)  | `RX`                    |\n| `RX0` (pin 10 / GPIO 15) | `TX`                    |\n| `GND`                    | `GND`                   |\n\n![](https://user-images.githubusercontent.com/7563926/181919087-03649fb1-b7c5-4601-bbb4-994fb07ea39e.png)\n\nImage credit: https://pinout.xyz\n\n> ##","ref":"connecting-to-nerves-target.html#connect-the-leads"},{"type":"extras","title":"Tips {: .tip} - Connecting to Nerves Target","doc":">\n> Most likely you don't need the power line since your purpose here is the\n> serial data communication.\n>\n> `TX` (transmit) and `RX` (receive) are relative terms. What is `TX` for one\n> is `RX` for the other.\n\nFor visual learners, [Adafruit's Raspberry Pi Lesson](https://learn.adafruit.com/adafruits-raspberry-pi-lesson-5-using-a-console-cable/connect-the-lead)\nhas some helpful images.\n\n#","ref":"connecting-to-nerves-target.html#tips-tip"},{"type":"extras","title":"Run a terminal emulation program - Connecting to Nerves Target","doc":"The USB-to-TTL serial cable converts the text into a standard serial USB port.\nThere are multiple open source terminal emulator programs out there that\nsupport the serial console.\n\n- [picocom](https://github.com/npat-efault/picocom)\n- [bootterm](https://github.com/wtarreau/bootterm)\n- [screen](https://en.wikipedia.org/wiki/GNU_Screen)\n- [tio](https://github.com/tio/tio)\n\nAs an example,  on a macOS host machine, you can open a terminal and try these\ncommands.\n\n##","ref":"connecting-to-nerves-target.html#run-a-terminal-emulation-program"},{"type":"extras","title":"List TTY devices available - Connecting to Nerves Target","doc":"```bash\nls /dev/tty*\n```\n\n##","ref":"connecting-to-nerves-target.html#list-tty-devices-available"},{"type":"extras","title":"Start communication with the Raspberry Pi using `picocom` - Connecting to Nerves Target","doc":"```bash\npicocom -b 115200 /dev/ttyUSB0\n```\n\nReplace `ttyUSB0` with the TTY device that has the USB-to-TTL serial cable. They\nusually have the letters \"USB\" somewhere in the name.\n\nYou should be at an `iex(1)>` prompt. If not, try pressing `Enter` a few times.\n\n> ##","ref":"connecting-to-nerves-target.html#start-communication-with-the-raspberry-pi-using-picocom"},{"type":"extras","title":"Linux USB gadget mode {: .info} - Connecting to Nerves Target","doc":">\n> Linux USB gadget mode also supplies a virtual serial connection for some\n> Nerves targets.\n\n#","ref":"connecting-to-nerves-target.html#linux-usb-gadget-mode-info"},{"type":"extras","title":"Troubleshooting - Connecting to Nerves Target","doc":"##","ref":"connecting-to-nerves-target.html#troubleshooting"},{"type":"extras","title":"First boot shows error messages - Connecting to Nerves Target","doc":"First boot shows error messages due to the file system not being formatted.\nSeems like something is wrong even though it isn't. This is visible if you\nattach to the UART and watch the messages the very first time that you boot off\na MicroSD card.\n\n##","ref":"connecting-to-nerves-target.html#first-boot-shows-error-messages"},{"type":"extras","title":"Toolshed's `exit` not working in the serial console - Connecting to Nerves Target","doc":"It works, but Erlang doesn't automatically restart the shell. You should be\nable to type CTRL-G to get the Erlang job menu.\n\n#### **\"could not find a PTY\" Error when running `screen` command**\n\nUnplug the USB connector and re-plug it.","ref":"connecting-to-nerves-target.html#toolshed-s-exit-not-working-in-the-serial-console"},{"type":"extras","title":"HDMI cable - Connecting to Nerves Target","doc":"On some Raspberry Pi family of targets such as `rpi3` and `rpi4`, the `IEx`\nconsole is displayed on the screen attached to the HDMI port by default. You\ncan simply connect your target device to a monitor or TV.\n\nFor troubleshooting start-up issues and for more advanced development\nworkflows, it's desirable to connect from your development host to the\ntarget using a UART serial cable.\n\nHere is how to override the default, for `rpi3` as an example:\n\n1. Look in the README of your target's system's documentation for a UART port name. For example, [`nerves_system_rpi3`](https://hexdocs.pm/nerves_system_rpi3/readme.html)\n1. Locate your project's `erlinit` configuration which is normally in your project's `config/target.exs` file\n1. Add a `ctty` option with the UART port name as a value\n\n```diff\n config :nerves,\n   erlinit: [\n+    ctty: \"ttyAMA0\",\n     hostname_pattern: \"nerves-%s\"\n   ]\n```","ref":"connecting-to-nerves-target.html#hdmi-cable"},{"type":"extras","title":"USB data cable - Connecting to Nerves Target","doc":"Some Nerves targets can operate in Linux USB gadget mode, which means a network\nconnection can be made with a USB cable between your host and target. The USB\ncable provides both power and network connectivity. This can be a convenient way\nto work with your target device.\n\n> ##","ref":"connecting-to-nerves-target.html#usb-data-cable"},{"type":"extras","title":"Use correct USB port {: .warning} - Connecting to Nerves Target","doc":">\n> Make sure to plug the USB cable into the USB OTG port. For example, the\n> Raspberry Pi Zero has two USB ports. The OTG one is the \"middle\" one. The\n> other one is power-only.\n\n> ##","ref":"connecting-to-nerves-target.html#use-correct-usb-port-warning"},{"type":"extras","title":"Use correct USB cable {: .warning} - Connecting to Nerves Target","doc":">\n> Make sure your USB cable supports data transfer. Generally there are two types\n> of USB cables:\n> - charging only\n> - charging and data transfer\n\n#","ref":"connecting-to-nerves-target.html#use-correct-usb-cable-warning"},{"type":"extras","title":"Test the connection - Connecting to Nerves Target","doc":"Once the target is powered up, test the connection from your host:\n\n```bash\nping nerves.local\n```\n\n#","ref":"connecting-to-nerves-target.html#test-the-connection"},{"type":"extras","title":"Make the network connection - Connecting to Nerves Target","doc":"To make a connection via the Linux USB gadget mode virtual Ethernet interface:\n\n```bash\nssh nerves.local\n```\n\nYou should find yourself at the `iex(hello_nerves@nerves.local)1>` prompt.\n\nTo end your ssh connection type `exit`, or you can use the `ssh` command\n` ~.`\n\n> ##","ref":"connecting-to-nerves-target.html#make-the-network-connection"},{"type":"extras","title":"_nerves.local_ is an mDNS address {: .info} - Connecting to Nerves Target","doc":">\n> Most examples in this page are done with a macOS host, which has mDNS enabled\n> by default. Linux and Windows hosts may have to enable mDNS networking.\n\n#","ref":"connecting-to-nerves-target.html#_nerves-local_-is-an-mdns-address-info"},{"type":"extras","title":"Gadget-mode virtual serial connection - Connecting to Nerves Target","doc":"USB gadget mode also supplies a virtual serial connection. Use it with any\nterminal emulator like `screen` or `picocom`:\n\n```bash\npicocom -b 115200 /dev/ttyUSB0\n```\n\n> ##","ref":"connecting-to-nerves-target.html#gadget-mode-virtual-serial-connection"},{"type":"extras","title":"Windows _Device Manager / Network adapters_ has no _USB Ethernet/RNDIS Gadget_ device? {: .info} - Connecting to Nerves Target","doc":">\n> It might be caused by\n> [this](https://www.ghacks.net/2020/09/28/should-you-install-windows-10s-optional-driver-updates),\n> so install the optional `USB Ethernet/RNDIS Gadget` driver to fix it.","ref":"connecting-to-nerves-target.html#windows-_device-manager-network-adapters_-has-no-_usb-ethernet-rndis-gadget_-device-info"},{"type":"extras","title":"Wireless and wired Ethernet connections - Connecting to Nerves Target","doc":"The `config/config.exs` generated in a new Nerves project will set up\nconnections for USB and Ethernet by default.\n\nThe [`nerves_pack`] dependency simplifies the network setup and configuration\nprocess. At runtime, `nerves_pack` will detect all available interfaces that\nhave not been configured and apply defaults for `usb*` and `eth*` interfaces.\n\n- For `eth*` interfaces, the device attempts to connect to the network\nwith DHCP using `ipv4` addressing.\n- For `usb*` interfaces, it uses [`vintage_net_direct`] to run a simple DHCP\nserver on the device and assign the host an IP address over a USB cable.\n\nIf you want to use some other network configuration, such as wired or wireless\nEthernet, refer to the [`nerves_pack`] documentation and the underlying\n[`vintage_net`] documentation as needed.\n\n[`nerves_pack`]: https://hexdocs.pm/nerves_pack\n[`vintage_net_wifi`]: https://hexdocs.pm/vintage_net_wifi\n[`vintage_net_direct`]: https://hexdocs.pm/vintage_net_direct\n[`nerves_pack`]: https://hexdocs.pm/nerves_pack\n[`vintage_net`]: https://hexdocs.pm/vintage_net","ref":"connecting-to-nerves-target.html#wireless-and-wired-ethernet-connections"},{"type":"extras","title":"IEx with Nerves","doc":"# IEx with Nerves\n\nNerves greets you with a prompt for Elixir's interactive shell (IEx). This\nprompt is your main entry point to interacting with Elixir, your program, and\nhardware. This chapter focuses on Nerves-specific use of the IEx prompt.","ref":"iex-with-nerves.html"},{"type":"extras","title":"Viewing log messages - IEx with Nerves","doc":"#","ref":"iex-with-nerves.html#viewing-log-messages"},{"type":"extras","title":"Attaching to the logger - IEx with Nerves","doc":"The [`Elixir console\nlogger`](https://hexdocs.pm/logger/master/Logger.Backends.Console.html) is\nnormally disabled so log messages don't print to the terminal. Instead, run\n`log_attach` to see log messages:\n\n```elixir\niex> log_attach\n{:ok, #PID }\niex> Logger.info(\"hello\")\n\n02:23:34.863 [info]  hello\n:ok\n```\n\nTo stop log messages from being printed, run `log_detach`.\n\n> ##","ref":"iex-with-nerves.html#attaching-to-the-logger"},{"type":"extras","title":"_undefined function log_attach/0_ {: .warning} - IEx with Nerves","doc":">\n> `log_attach` is a function of [`Toolshed`](#toolshed) and might not be imported\n> by default. If you get an undefined function error, run `use Toolshed` in your\n> IEx session and try again. See [`Toolshed`](#toolshed) for more details.\n\n#","ref":"iex-with-nerves.html#_undefined-function-log_attach-0_-warning"},{"type":"extras","title":"RingLogger - IEx with Nerves","doc":"You'll frequently want to see log messages that occurred in the past. The Nerves\nnew project generator creates projects with\n[`RingLogger`](https://hex.pm/packages/ring_logger) to support this.\n`RingLogger` is an [Elixir logger\nbackend](https://hexdocs.pm/logger/master/Logger.html#module-backends) that\nstores logs completely in memory. This is nice for embedded systems where you\ndon't want to wear out Flash storage by writing to it. The drawbacks are\nRingLogger discards old messages and doesn't save them across reboots.\n\nTo view log messages, run `RingLogger.next` at the IEx prompt. Repeated calls\nprint newly received log messages. `RingLogger.reset` lets you start at the\noldest message again.\n\nSee the [`RingLogger`](https://hexdocs.pm/ring_logger) docs for more information\non tuning log levels, filtering by module, and grep'ing for keywords.\n\n#","ref":"iex-with-nerves.html#ringlogger"},{"type":"extras","title":"Dmesg - IEx with Nerves","doc":"Nerves routes Linux kernel log messages and\n[syslog](https://linux.die.net/man/8/syslogd) messages to the Elixir Logger.\nThis means Elixir logger backends have a complete picture of the log messages\nsent by the kernel, C, and BEAM  programs. Sometimes, though, it's useful to\nfocus on the kernel messages in isolation. The `dmesg` helper lets you do this:\n\n```elixir\niex> dmesg\n[    0.000000] Booting Linux on physical CPU 0x0\n[    0.000000] Linux version 5.10.41 (buildroot@buildroot) (armv7-nerves-linux-gnueabihf-gcc (crosstool-NG 1.24.0.299_6729a76) 10.2.0, GNU ld (crosstool-NG 1.24.0.299_6729a76) 2.36.1) #1 PREEMPT Fri Aug 20 01:26:27 UTC 2021\n[    0.000000] CPU: ARMv7 Processor [413fc082] revision 2 (ARMv7), cr=10c5387d\n[    0.000000] CPU: PIPT / VIPT nonaliasing data cache, VIPT aliasing instruction cache\n```\n\n> ##","ref":"iex-with-nerves.html#dmesg"},{"type":"extras","title":"_undefined function dmesg/0_ {: .warning} - IEx with Nerves","doc":">\n> `dmesg` is a function of [`Toolshed`](#toolshed) and might not be imported\n> by default. If you get an undefined function error, run `use Toolshed` in your\n> IEx session and try again. See [`Toolshed`](#toolshed) for more details.\n\n#","ref":"iex-with-nerves.html#_undefined-function-dmesg-0_-warning"},{"type":"extras","title":"RamoopsLogger - IEx with Nerves","doc":"The [`RamoopsLogger`](https://hex.pm/packages/ramoops_logger) is an Elixir\nlogger backend that records messages to a special memory region using Linux's\n`pstore` driver. This memory region survives reboots so it's useful for\ncapturing log messages that happen just before an unexpected reboot. Even if\nyou've configured a file-backed logger backend, the `RamoopsLogger` can\nsometimes capture messages that would have been lost to disk caching.\n\nThis driver is enabled in most official Nerves systems. However,\n`:ramoops_logger` is not added to Nerves projects by default. See the\n[documentation](https://hexdocs.pm/ramoops_logger) for registering it with the\nElixir Logger.","ref":"iex-with-nerves.html#ramoopslogger"},{"type":"extras","title":"Other loggers - IEx with Nerves","doc":"Pretty much any logger backend in Elixir can be used with Nerves. The caveat is\nthat Nerves does not guarantee the following:\n\n1. Networking always works\n  * If you're using a network-based logger, check that it handles network outages\n    gracefully.\n\n2. The application data partition (`/data`) is mounted\n  * The application data partition is almost always available. However, on the\n    first boot and if severely corrupted, it will be reformatted. This partition\n    is also technically optional and a system can choose to omit it. Since the\n    Elixir Logger starts very early in the boot process, it's possible for log\n    messages to be received before `/data` is ready. This is a temporary\n    situation, but it is important that the Logger backend not give up.","ref":"iex-with-nerves.html#other-loggers"},{"type":"extras","title":"Networking - IEx with Nerves","doc":"Most Nerves projects use the [`VintageNet`](https://hex.pm/packages/vintage_net)\nlibrary for configuring the network. To get a quick overview of network\nconfiguration and status, run `VintageNet.info`:\n\n```elixir\niex> VintageNet.info\nAll interfaces:       [\"eth0\", \"lo\", \"wlan0\", \"wwan0\"]\nAvailable interfaces: [\"wlan0\", \"wwan0\"]\n\nInterface eth0\n  Type: VintageNetEthernet\n  Present: true\n  State: :configured (1 days, 14:59:09)\n  Connection: :disconnected (1 days, 14:59:09)\n  Configuration:\n    %{type: VintageNetEthernet, ipv4: %{method: :dhcp}}\n\nInterface wlan0\n  Type: VintageNetWiFi\n  Present: true\n  State: :configured (1 days, 14:59:05)\n  Connection: :internet (5:02:35)\n  Addresses: 192.168.99.81/24, fe80::9a48:27ff:fedd:a10e/64\n  Configuration:\n    %{\n      type: VintageNetWiFi,\n      ipv4: %{method: :dhcp},\n      vintage_net_wifi: ...\n    }\n\nInterface wwan0\n  Type: VintageNetQMI\n  Power: On (watchdog timeout in 59969 ms)\n  Present: true\n  State: :configured (14:44:50)\n  Connection: :internet (14:43:51)\n  Addresses: 100.101.32.76/29, fe80::8eb:885f:3fce:d37d/64\n  Configuration:\n    %{ ...\n    }\n```\n\nIf your muscle memory types `ifconfig`, that works too:\n\n```elixir\niex(2)> ifconfig\nlo: flags=[:up, :loopback, :running]\n    inet 127.0.0.1  netmask 255.0.0.0\n    inet ::1  netmask ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff\n    hwaddr 00:00:00:00:00:00\n\neth0: flags=[:up, :broadcast, :running, :multicast]\n    hwaddr 60:64:05:4e:fb:ef\n\nwlan0: flags=[:up, :broadcast, :running, :multicast]\n    inet 192.168.99.81  netmask 255.255.255.0  broadcast 192.168.99.255\n    inet fe80::9a48:27ff:fedd:a10e  netmask ffff:ffff:ffff:ffff::\n    hwaddr 98:48:27:dd:a1:0e\n\nwwan0: flags=[:up, :pointtopoint, :running, :multicast]\n    inet 100.101.32.76  netmask 255.255.255.248\n    inet fe80::8eb:885f:3fce:d37d  netmask ffff:ffff:ffff:ffff::\n```\n\n> ##","ref":"iex-with-nerves.html#networking"},{"type":"extras","title":"_undefined function ifconfig/0_ {: .warning} - IEx with Nerves","doc":">\n> `ifconfig` is a function of [`Toolshed`](#toolshed) and might not be imported\n> by default. If you get an undefined function error, run `use Toolshed` in your\n> IEx session and try again. See [`Toolshed`](#toolshed) for more details.\n\nAnother option is to run [`ip(8)`](https://linux.die.net/man/8/ip).\nNerves provides a trimmed down Busybox version of `ip`. For example:\n\n```elixir\niex> cmd(\"ip route\")\ndefault via 192.168.99.1 dev wlan0  metric 20\ndefault via 100.101.32.77 dev wwan0  metric 30\n100.101.32.72/29 dev wwan0 scope link  src 100.101.32.76  metric 30\n192.168.99.0/24 dev wlan0 scope link  src 192.168.99.81  metric 20\n```\n\nSee the [`VintageNet` documentation](https://hexdocs.pm/vintage_net/readme.html)\nfor more tips on debugging and adjusting network configurations.","ref":"iex-with-nerves.html#_undefined-function-ifconfig-0_-warning"},{"type":"extras","title":"Toolshed - IEx with Nerves","doc":"[`Toolshed`](https://hex.pm/packages/toolshed) is a library of [IEx\nhelpers](https://hexdocs.pm/iex/IEx.Helpers.html) that augments the ones that\nElixir provides. It's included by the Nerves new project generator (see\n[Customizing the IEx session](#customizing-the-iex-session) section for more\ndetails).\n\nThe helpers should be available by default, but if not, run:\n\n```elixir\niex> use Toolshed\nToolshed imported. Run h(Toolshed) for more info.\n:ok\n```\n\nIf you're used to the Linux commandline, many `Toolshed` helpers will seem\nfamiliar except with an Elixir twist. One difference is that you need to add\ndouble quotes around filenames and IP addresses. The names are similar, though,\nlike `uname`, `ping`, `uptime`, `date`, `lsof` and more.\n\nToolshed also simplifies running shell commands. Keeping in mind that Nerves\nprovides a limited Linux userland, you can still run simple shell scripts and\ncommandline applications using `cmd`. For example,\n\n```elixir\niex> cmd(\"ls -las /\")\n     0 drwxr-xr-x    3 root     root            97 Mar 12  2020 var\n     0 drwxr-xr-x    7 root     root            88 Mar 12  2020 usr\n     0 drwxrwxrwt    3 root     root           180 Sep  2 21:05 tmp\n     0 dr-xr-xr-x   12 root     root             0 Jan  1  1970 sys\n...\n```\n\nAnother useful command for checking Internet-connectivity is `weather`. This\nsends an HTTP request to Igor Chubin's super useful [wttr.in\nservice](https://github.com/chubin/wttr.in).","ref":"iex-with-nerves.html#toolshed"},{"type":"extras","title":"Linux shell commands - IEx with Nerves","doc":"> ##","ref":"iex-with-nerves.html#linux-shell-commands"},{"type":"extras","title":"Maybe Erlang? {: .tip} - IEx with Nerves","doc":">\n> Erlang contains an amazing amount of functionality, so before reaching\n> for Linux utilities, we highly recommend checking the [Erlang\n> documentation](https://erlang.org/doc/search/).\n\nNerves includes a minimal version of [`busybox`](https://www.busybox.net/) to\nsupport running simple shell scripts and access network configuration utilities\nthat do not have analogs in Erlang/OTP.\n\nTo see what's available, run `busybox` without arguments:\n\n```elixir\niex> cmd(\"busybox\")\nBusyBox v1.33.1 () multi-call binary.\nBusyBox is copyrighted by many authors between 1998-2015.\nLicensed under GPLv2. See source distribution for detailed\ncopyright notices.\n\nUsage: busybox [function [arguments]...]\n   or: busybox --list\n   or: busybox --show SCRIPT\n   or: function [arguments]...\n\n\tBusyBox is a multi-call binary that combines many common Unix\n\tutilities into a single executable.  Most people will create a\n\tlink to busybox for each function they wish to use and BusyBox\n\twill act like whatever it was invoked as.\n\nCurrently defined functions:\n\t[, [[, ash, base32, basename, brctl, cat, cp, cut, date, dd, devmem,\n\tdf, dirname, dmesg, dnsd, expr, find, free, grep, halt, id, ifconfig,\n\tinstall, ip, ipaddr, iplink, ipneigh, iproute, iprule, iptunnel, kill,\n\tkillall, ls, lsmod, mim, mkdir, mknod, mktemp, modinfo, modprobe,\n\tmount, mv, ntpd, pidof, ping, ping6, poweroff, ps, pwd, reboot, rm,\n\trmdir, rmmod, sed, sh, sha256sum, sleep, sysctl, tail, touch, udhcpc,\n\tudhcpd, uevent, umount, unzip\n```\n\n> ##","ref":"iex-with-nerves.html#maybe-erlang-tip"},{"type":"extras","title":"Where's Bash? {: .info} - IEx with Nerves","doc":"> \n> Everyone asks this and it's come up since almost day one. It is probably the\n> most visible distinction of what it means that Nerves uses the Linux kernel but\n> very little of the standard Linux userland.\n> \n> Since Nerves provides only a few Linux utilities, the shell prompt is not as\n> useful as you would expect. The projects that once provided a shell prompt have\n> been abandoned due to this.\n> \n> Our recommendation is to spend some time working at the `iex>` prompt and if\n> you're missing a utility, check if Elixir or Erlang/OTP provide it. If they do\n> and it just needs an IEx helper to make it ergonomic, then please consider\n> contributing a new helper to [`Toolshed`](https://github.com/elixir-toolshed/toolshed).\n> \n> If having a proper Unix shell and Linux userland is critical to your\n> application, it may be better not to use Nerves.\n> [Buildroot](https://buildroot.org/), [Yocto](https://www.yoctoproject.org/),\n> [Raspberry Pi OS](https://www.raspberrypi.org/), and other embedded Linux\n> projects run Erlang and Elixir too and many Nerves-related libraries also\n> work well outside of Nerves.","ref":"iex-with-nerves.html#where-s-bash-info"},{"type":"extras","title":"Customizing the IEx session - IEx with Nerves","doc":"The Nerves new project generator creates a default `iex.exs` for setting up the\nprompt. You can find it in `rootfs_overlay/etc/iex.exs`.\n\nThe default `iex.exs` prints a message of the day (from\n[`NervesMOTD`](https://hexdocs.pm/nerves_motd)) and loads the [`Toolshed`](#toolshed)\nhelpers. See the [IEx .iex.exs docs](https://hexdocs.pm/iex/IEx.html#module-the-iex-exs-file) for\nmore information on what can be done.\n\nKeep the following in mind:\n\n1. Elixir evaluates the `iex.exs` file for the console very early in the boot\n   process. It's likely that networking and your OTP applications have not\n   started, so you may get runtime exceptions\n2. A common sign that a typo broke the `iex.exs` is that the Toolshed helpers\n   are not available. You can still run `use Toolshed` at the prompt.\n3. The `iex.exs` is stored in a read-only location so you can't update it on the\n   device. You can create `/root/.iex.exs` and customize it. Use `sftp` to\n   update or erase it if you mess it up.","ref":"iex-with-nerves.html#customizing-the-iex-session"},{"type":"extras","title":"Changing the IEx console output - IEx with Nerves","doc":"Depending on the platform, Nerves sends the IEx console to an attached\ndisplay or UART. If you find yourself taking pictures of the display to capture\nerror log messages, you probably want to start using the UART. That requires a\nUSB-to-UART cable (often called an FTDI cable) and you'll need a serial\ncommunications program on your computer.\n\n[`erlinit`](https://github.com/nerves-project/erlinit) sets up the console\nbefore starting Erlang. The `/etc/erlinit.config` files in the official Nerves\nsystems have comments about where the console output goes. Here's an example:\n\n```text\n Specify where erlinit should send the IEx prompt. Only one may be enabled at\n# a time.\n-c ttyAMA0     # UART pins on the GPIO connector\n# -c tty1      # HDMI output\n```\n\nThe easiest way of changing the console location is in your `config.exs`. For example,\nspecify the following to use `tty1`:\n\n```elixir\nconfig :nerves, :erlinit,\n  ctty: \"tty1\"\n```\n\nWhen you ship a Nerves device for production, you may want to disable the\nconsole completely. To disable, set the `ctty` to `null`:\n\n```elixir\nconfig :nerves, :erlinit,\n  ctty: \"null\",\n  alternate_exec: \"/usr/bin/run_erl /tmp/ /tmp exec\"\n```\n\nThe `:alternate_exec` key is optional here. It calls\n[`run_erl`](https://erlang.org/doc/man/run_erl.html) to log console output to\na file in `/tmp`. This is useful if code calls `IO.puts` rather than `Logger`.","ref":"iex-with-nerves.html#changing-the-iex-console-output"},{"type":"extras","title":"Remote console access - IEx with Nerves","doc":"The Nerves new generator sets up [`NervesSSH`](http://hexdocs.pm/nerves_ssh) by\ndefault allowing you to remotely connect with `ssh nerves.local` (or via the IP\naddress or another hostname you may have set)\n\nIf `NervesSSH` is not an option, the [`extty`](https://hex.pm/packages/extty)\nlibrary may be useful for connecting an IEx prompt to the transport of your\nchoice.\n\n> ##","ref":"iex-with-nerves.html#remote-console-access"},{"type":"extras","title":"Exiting SSH sessions {: .tip} - IEx with Nerves","doc":"> \n> If you're using `Toolshed`, type `exit` at the IEx prompt. Otherwise, use\n> `ssh`'s magic exit sequence: ` ~.`. Run ` ?` to see all the\n> available SSH magic sequences","ref":"iex-with-nerves.html#exiting-ssh-sessions-tip"},{"type":"extras","title":"Erlang and LFE prompts - IEx with Nerves","doc":"While Nerves definitely has a lot of Elixir in it now, it has always been the\nintention to support other BEAM languages.\n\nThe boot console is configured using your project's `vm.args`. The console\nsupplied over SSH connections is set though the application environment for\n`:nerves_ssh`:\n\n```elixir\nconfig :nerves_ssh,\n  shell: :lfe\n```\n\nSee the [Nerves Examples](https://github.com/nerves-project/nerves-examples) for\nsmall Erlang and LFE programs.\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"iex-with-nerves.html#erlang-and-lfe-prompts"},{"type":"extras","title":"Frequently-Asked Questions","doc":"# Frequently-Asked Questions\n\nThis is a collection of questions that often come up as people are getting started with Nerves.\nIf you tried to go through the [Getting Started guide](https://hexdocs.pm/nerves/getting-started.html) or some of the [example projects](https://github.com/nerves-project/nerves_examples) and got stuck, hopefully one of the following answers will help.\nIf not, please let us know in the #nerves channel on [the Elixir-Lang Slack](https://elixir-slackin.herokuapp.com/), or [create an Issue or Pull Request to improve this documentation](https://github.com/nerves-project/nerves/tree/main/docs).","ref":"faq.html"},{"type":"extras","title":"Where can persistent data be stored? - Frequently-Asked Questions","doc":"For most use cases, the `/data` partition is the right place to store data.  It\nis initialized on first boot and is not overwritten when new firmware is pushed\nto the device.\n\nThe `mix firmware.burn` task clears it out so that partition is guaranteed to be\nempty when the device boots. This is useful to ensure that the device is known\nstate. There's a pattern for implementing a \"Reset to factory defaults\" feature\nby erasing the partition and rebooting.\n\nIf you're updating firmware regularly by writing to a MicroSD card, try running\n`mix firmware.burn --task upgrade`. This won't reset the application data\npartition.\n\nSome Elixir libraries write to their `priv` directory by default. This won't\nwork since all code and the `priv` directories are stored in a read-only file\npartition. Usually there's a way to override this default choice and specify a\npath to `/data` for that library to use.\n\nFactory calibration and other provisioning data is either stored in a custom\nfile partition or in the U-Boot environment block. The latter is accessible via\n`Nerves.Runtime.KV` functions.","ref":"faq.html#where-can-persistent-data-be-stored"},{"type":"extras","title":"How can I apply a firmware update manually? - Frequently-Asked Questions","doc":"Assuming that you have already put a known good firmware inside \"/data/known_good.fw\" (perhaps with sftp) then you can run the following commands\n\n```elixir\niex> cmd(\"fwup -i /data/known_good.fw --apply --task upgrade \"  \n  \"--no-unmount -d #{Nerves.Runtime.KV.get(\"nerves_fw_devpath\")}\")\niex> reboot\n```","ref":"faq.html#how-can-i-apply-a-firmware-update-manually"},{"type":"extras","title":"How do I push firmware updates remotely? - Frequently-Asked Questions","doc":"SSH is a good default for local development and is enabled by default (via `mix nerves.new`) with https://github.com/nerves-project/nerves_ssh (note: previously https://github.com/nerves-project/nerves_firmware_ssh was enabled by default)\n\nFor production environments you might also want to look at https://www.nerves-hub.org/ (either hosted or self-hosted)","ref":"faq.html#how-do-i-push-firmware-updates-remotely"},{"type":"extras","title":"Change Behavior on BEAM Failure - Frequently-Asked Questions","doc":"Similar to the previous question, we have chosen to have the device default to halting on certain kinds of failures that cause the Erlang VM to crash.\nThis allows you to more easily read the error and diagnose the problem during development.\n\nFor a production deployment, it's recommended that you change the behavior to restart on failure instead.\nThat way, in the unlikely event that your application crashes, the entire device will reload in a known-good state and continue to operate.\n\nThis setting is also configured using the `erlinit.config` file described above.\nTo have the device restart instead of hang on failure, make a copy of the `erlinit.config` file and make sure the `--hang-on-exit` option is commented out.\n\n```bash\n# Uncomment to hang the board rather than rebooting when Erlang exits\n#--hang-on-exit\n```\n\nYou can also have the device drop into a shell when the Erlang VM crashes, allowing you to troubleshoot at the Linux OS level.\n\n```bash\n# Optionally run a program if the Erlang VM exits\n#--run-on-exit /bin/sh\n```","ref":"faq.html#change-behavior-on-beam-failure"},{"type":"extras","title":"Platform-Specific Hardware Support - Frequently-Asked Questions","doc":"Some target hardware has particular features that can be used from your\napplication, but they're not covered in the general Nerves documentation.  In\ngeneral, platform-specific features will be documented in the target's system\ndocumentation.  You may also find what you need by searching\n[hex.pm](https://hex.pm) for libraries that use that feature.\n\nIf you still don't see what you're looking for, please let us know in the #nerves channel on [the Elixir-Lang Slack](https://elixir-slackin.herokuapp.com/), or create an Issue or Pull Request to the [relevant `nerves_system- ` repository](https://github.com/nerves-project?query=nerves_system_).\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"faq.html#platform-specific-hardware-support"},{"type":"extras","title":"Targets","doc":"# Targets\n\nNerves supports a variety of hardware. These are called targets and are\nidentified by short tag names. Examples of tag names are `rpi0`, `bbb`, etc.\n\nWhen building a Nerves project, set the `MIX_TARGET` environment variable to the\ntag name. This controls which dependencies and configuration settings are used\nwhen building your project. See the [Mix\nTargets](https://hexdocs.pm/mix/Mix.html#module-targets) documentation for\nfurther information on this concept.\n\nIn Nerves, the term _system_ refers to the library (usually posted to hex.pm) that\nprovides the bootloader, Linux kernel, C libraries, and more for a device.\nSystems have names like `nerves_system_rpi0`. Since it's possible to create\nfirmware for more than one hardware device, Nerves uses the Mix target feature\nto select the desired system in your project's `mix.exs`.\n\nThe naming of target tags is arbitrary. You can choose tags however makes the\nmost sense for your project. Nerves uses the convention of naming the target tag\nafter the system that it uses. For example, when using the Nerves new project\ngenerator, it will set up the `mix.exs` to use the tag `rpi0` to select the\n`nerves_system_rpi0` library for building for a Raspberry Pi Zero.","ref":"targets.html"},{"type":"extras","title":"Supported Targets and Systems - Targets","doc":"The following table summarize officially supported hardware, the associated\nsystem and the `$MIX_TARGET` tag to use.\n\nTarget | System | Tag\n------ | ------ | ---\nRaspberry Pi A+, B, B+ | [nerves_system_rpi](https://github.com/nerves-project/nerves_system_rpi) | `rpi`\nRaspberry Pi Zero and Zero W | [nerves_system_rpi0](https://github.com/nerves-project/nerves_system_rpi0) | `rpi0`\nRaspberry Pi 2 | [nerves_system_rpi2](https://github.com/nerves-project/nerves_system_rpi2) | `rpi2`\nRaspberry Pi 3A and Zero 2 W | [nerves_system_rpi3a](https://github.com/nerves-project/nerves_system_rpi3a) | `rpi3a`\nRaspberry Pi 3 B, B+ | [nerves_system_rpi3](https://github.com/nerves-project/nerves_system_rpi3) | `rpi3`\nRaspberry Pi 4 | [nerves_system_rpi4](https://github.com/nerves-project/nerves_system_rpi4) | `rpi4`\nBeagleBone Black, BeagleBone Green, BeagleBone Green Wireless, and PocketBeagle. | [nerves_system_bbb](https://github.com/nerves-project/nerves_system_bbb) | `bbb`\nGeneric x86_64 | [nerves_system_x86_64](https://github.com/nerves-project/nerves_system_x86_64) | `x86_64`\nOSD32MP1 | [nerves_system_osd32mp1](https://github.com/nerves-project/nerves_system_osd32mp1) | `osd32mp1`\nGRiSP 2 | [nerves_system_grisp2](https://github.com/nerves-project/nerves_system_grisp2) | `grisp2`\nMangoPi MQ Pro | [nerves_system_mangopi_mq_pro](https://github.com/nerves-project/nerves_system_mangopi_mq_pro | `mangopi_mq_pro`\nWhile the Nerves core team only officially supports the above hardware, the\ncommunity has added support for other boards. See [Nerves Systems on\nhex.pm](https://hex.pm/packages?search=depends:nerves_system_br)","ref":"targets.html#supported-targets-and-systems"},{"type":"extras","title":"Supporting New Target Hardware - Targets","doc":"If you're trying to support a new Target, there may be quite a bit more work\ninvolved, depending on how mature the support for that hardware is in the\nBuildroot community.  If you're not familiar with\n[Buildroot](https://buildroot.org/), you should learn about that first, using\nthe excellent training materials on their website.\n\nIf you can find an existing Buildroot configuration for your intended hardware\nand you want to get it working with Nerves, you will need to make a custom\nSystem as follows:\n\n1. Follow their procedure and confirm your target boots (independent of Nerves).\n\n2. Figure out how to get everything working with the version of Buildroot Nerves uses.\n    See the [`NERVES_BR_VERSION` variable in `create-build.sh`](https://github.com/nerves-project/nerves_system_br/blob/main/create-build.sh).\n\n  * Look for packages and board configs can need to be copied into your System.\n  * Look for patches to existing packages that are needed.\n\n3. Create a defconfig that mimics the one from step 1, and get `nerves_system_br` to build it.\n   See the section in the [System](systems.html) documentation about customizing Nerves Systems.\n\n> NOTE: You probably want to disable any userland packages that may be included\n> by default to avoid distraction.\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"targets.html#supporting-new-target-hardware"},{"type":"extras","title":"Systems","doc":"# Systems","ref":"systems.html"},{"type":"extras","title":"Using a Nerves System - Systems","doc":"When you generate a new Nerves project using the `mix nerves.new` task, you will\nend up with something like the following in your `mix.exs` configuration:\n\n```elixir\n  # ...\n  @target System.get_env(\"MIX_TARGET\") || \"host\"\n  # ...\n  defp deps do\n    [\n      {:nerves, \"~> 1.3\", runtime: false},\n      {:shoehorn, \"~> 0.4\"},\n      {:ring_logger, \"~> 0.4\"}\n    ] ++ deps(@target)\n  end\n\n  defp deps(\"host\"), do: []\n\n  defp deps(target) do\n    [\n      {:nerves_runtime, \"~> 0.6\"}\n    ] ++ system(target)\n  end\n\n  def system(\"rpi\"), do: {:nerves_system_rpi, \"~> 1.0\", runtime: false}\n  def system(\"rpi0\"), do: {:nerves_system_rpi0, \"~> 1.0\", runtime: false}\n  # ...\n  def system(target), do: Mix.raise \"Unknown MIX_TARGET: #{target}\"\n```\n\nThis allows Nerves to load one or more target-specific dependencies when a\n`MIX_TARGET` system environment variable is specified. The official\n`nerves_system-*` dependencies contain the standard Buildroot configuration for\nthe Nerves platform on a given hardware target and have a dependency on the\nappropriate toolchain for that target. The system and toolchain also reference a\npre-compiled version of the relevant artifact so that Mix can simply download\nthem instead of having to compile them (which takes quite a while).","ref":"systems.html#using-a-nerves-system"},{"type":"extras","title":"Compatibility - Systems","doc":"The Nerves System (`nerves_system_*`) dependency determines the OTP version\nrunning on the target. It is possible that a recent update to the Nerves\nSystem pulled in a new version of Erlang/OTP. If you are using an official\nNerves System, you can verify this by reviewing the chart below or\n[Changelog](CHANGELOG.md) that comes with the release.\n\n \n  nerves_system_bbb     bbb  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      2.18.0  26.0  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.10    2.17.2  25.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.10    2.17.1  25.2.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.10    2.17.0  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.10    2.16.2  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.10    2.16.1  25.1.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.10    2.16.0  25.1.1  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.10.120    2.15.3  25.0.4  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.10.120    2.15.2  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.10.120    2.15.1  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.10.120    2.15.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15.44    2.14.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10.100    2.13.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10.100    2.13.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10.87    2.13.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10.87    2.13.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.3  2021.11  5.10.65    2.13.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.2  2021.11  5.10.65    2.12.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.4  2021.08.2  5.4.52    2.12.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.3  2021.08.1  5.4.52    2.12.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.1  2021.08.1  5.4.52    2.12.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.0  2021.08  5.4.52    2.11.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.4  2021.05.1  5.4.52    2.11.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.1  2021.05  5.4.52    2.11.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.0  2021.05  5.4.52    2.10.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.1  2021.02.1  5.4.52    2.10.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.0  2021.02  5.4.52    2.9.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.14.4  2020.11.2  5.4.52    2.8.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4.52    2.8.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4.52    2.8.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4.52    2.8.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19.120    2.7.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19.120    2.7.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19.120    2.7.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19.120    2.6.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19.103    2.6.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19.103    2.6.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19.103    2.5.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19.72    2.5.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19.72    2.5.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19.72    2.4.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19.50    2.4.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19.50    2.4.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19.50    2.3.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19.50    2.3.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19.37    2.3.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19.37    2.2.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19.26    2.2.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19.26    2.2.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19.26    2.1.3  21.2.6  ~&gt; 1.3  1.6.8  2018.11.1  4.19.10     \n\n  nerves_system_rpi     rpi  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.15    1.22.2  25.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.15    1.22.1  25.2.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.15    1.22.0  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.15    1.21.2  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.15    1.21.1  25.1.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.15    1.21.0  25.1.1  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.15    1.20.2  25.0.4  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.15    1.20.1  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.15    1.20.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.3  2021.11  5.10    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.2  2021.11  5.10    1.17.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.4  2021.08.2  5.10    1.17.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.3  2021.08.1  5.10    1.17.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.1  2021.08.1  5.4    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.0  2021.08  5.4    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.4  2021.05.1  5.4    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.1  2021.05  5.4    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.0  2021.05  5.4    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.1  2021.02.1  5.4    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.0  2021.02  5.4    1.14.1  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.14.4  2020.11.2  5.4    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.14.4  2020.11.2  5.4    1.13.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.11.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19    1.11.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.10.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19    1.10.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19    1.10.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19    1.9.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19    1.9.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19    1.9.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19    1.8.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19    1.8.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19    1.8.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19    1.7.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19    1.7.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19    1.7.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19    1.6.3  21.2.6  ~&gt; 1.3  1.6.8  2018.11.1  4.14     \n\n  nerves_system_rpi0     rpi0  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.15    1.22.2  25.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.15    1.22.1  25.2.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.15    1.22.0  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.15    1.21.2  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.15    1.21.1  25.1.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.15    1.21.0  25.1.1  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.15    1.20.2  25.0.4  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.15    1.20.1  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.15    1.20.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.3  2021.11  5.10    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.2  2021.11  5.10    1.17.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.4  2021.08.2  5.10    1.17.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.3  2021.08.1  5.10    1.17.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.1  2021.08.1  5.4    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.0  2021.08  5.4    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.4  2021.05.1  5.4    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.1  2021.05  5.4    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.0  2021.05  5.4    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.1  2021.02.1  5.4    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.0  2021.02  5.4    1.14.1  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.14.4  2020.11.2  5.4    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.14.4  2020.11.2  5.4    1.13.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.11.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19    1.11.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.10.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19    1.10.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19    1.10.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19    1.9.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19    1.9.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19    1.9.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19    1.8.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19    1.8.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19    1.8.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19    1.7.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19    1.7.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19    1.7.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19    1.6.3  21.2.6  ~&gt; 1.3  1.6.8  2018.11.1  4.14     \n\n  nerves_system_rpi2     rpi2  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.15    1.22.2  25.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.15    1.22.1  25.2.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.15    1.22.0  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.15    1.21.2  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.15    1.21.1  25.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.15    1.21.0  25.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.15    1.20.2  25.0.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.15    1.20.1  25.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.15    1.20.0  25.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.3  2021.11  5.10    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.2  2021.11  5.10    1.17.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.4  2021.08.2  5.10    1.17.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.3  2021.08.1  5.10    1.17.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.1  2021.08.1  5.4    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.0  2021.08  5.4    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.4  2021.05.1  5.4    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.1  2021.05  5.4    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.0  2021.05  5.4    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.1  2021.02.1  5.4    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.0  2021.02  5.4    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.14.4  2020.11.2  5.4    1.13.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.11.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19    1.11.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.10.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19    1.10.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19    1.10.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19    1.9.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19    1.9.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19    1.9.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19    1.8.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19    1.8.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19    1.8.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19    1.7.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19    1.7.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19    1.7.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19    1.6.3  21.2.6  ~&gt; 1.3  1.6.8  2018.11.1  4.14    1.6.2  21.2.4  ~&gt; 1.3  1.6.6  2018.11.1  4.14     \n\n  nerves_system_rpi3     rpi3  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.15    1.22.2  25.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.15    1.22.1  25.2.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.15    1.22.0  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.15    1.21.2  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.15    1.21.1  25.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.15    1.21.0  25.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.15    1.20.2  25.0.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.15    1.20.1  25.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.15    1.20.0  25.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.3  2021.11  5.10    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.2  2021.11  5.10    1.17.4  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.4  2021.08.2  5.10    1.17.3  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.3  2021.08.1  5.10    1.17.2  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.1  2021.08.1  5.4    1.17.1  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.0  2021.08  5.4    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.0  2021.08  5.4    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.4  2021.05.1  5.4    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.1  2021.05  5.4    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.0  2021.05  5.4    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.1  2021.02.1  5.4    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.0  2021.02  5.4    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.14.4  2020.11.2  5.4    1.13.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.11.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19    1.11.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.10.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19    1.10.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19    1.10.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19    1.9.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19    1.9.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19    1.9.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19    1.8.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19    1.8.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19    1.8.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19    1.7.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19    1.7.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19    1.7.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19    1.6.3  21.2.6  ~&gt; 1.3  1.6.8  2018.11.1  4.14     \n\n  nerves_system_rpi3a     rpi3a  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.15    1.22.2  25.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.15    1.22.1  25.2.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.15    1.22.0  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.15    1.21.2  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.15    1.21.1  25.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.15    1.21.0  25.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.15    1.20.2  25.0.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.15    1.20.1  25.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.15    1.20.0  25.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.3  2021.11  5.10    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.2  2021.11  5.10    1.17.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.4  2021.08.2  5.10    1.17.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.3  2021.08.1  5.10    1.17.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.1  2021.08.1  5.4    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.0  2021.08  5.4    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.4  2021.05.1  5.4    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.1  2021.05  5.4    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.0  2021.05  5.4    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.1  2021.02.1  5.4    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.0  2021.02  5.4    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.14.4  2020.11.2  5.4    1.13.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.11.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19    1.11.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.10.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19    1.10.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19    1.10.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19    1.9.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19    1.9.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19    1.9.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19    1.8.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19    1.8.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19    1.8.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19    1.7.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19    1.7.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19    1.7.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19    1.6.3  21.2.6  ~&gt; 1.3  1.6.8  2018.11.1  4.14    1.6.2  21.2.4  ~&gt; 1.3  1.6.6  2018.11.1  4.14     \n\n  nerves_system_rpi4     rpi4  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  6.1    1.22.2  25.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.15    1.22.1  25.2.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.15    1.22.0  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.15    1.21.2  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.15    1.21.1  25.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.15    1.21.0  25.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.15    1.20.2  25.0.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.15    1.20.1  25.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.15    1.20.0  25.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.15    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.3  2021.11  5.10    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.18.2  2021.11  5.10    1.17.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.4  2021.08.2  5.10    1.17.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.3  2021.08.1  5.10    1.17.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.1  2021.08.1  5.4    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.17.0  2021.08  5.4    1.16.3  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.5  2021.05.1  5.4    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.4  2021.05.1  5.4    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.1  2021.05  5.4    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.16.0  2021.05  5.4    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.1  2021.02.1  5.4    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.15.0  2021.02  5.4    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.3  1.14.4  2020.11.2  5.4    1.13.5  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19    1.11.3  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19    1.11.2  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19    1.11.1  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19    1.10.2  22.2.4  ~&gt; 1.5  1.10.2  2019.11.1  4.19    1.10.1  22.2.2  ~&gt; 1.5  1.10.1  2019.11.1  4.19    1.10.0  22.1.5  ~&gt; 1.5  1.10.0  2019.11  4.19    1.9.2  22.1.5  ~&gt; 1.5  1.9.5  2019.08.2  4.19    1.9.1  22.1.1  ~&gt; 1.5  1.9.4  2019.08.1  4.19    1.9.0  22.0.7  ~&gt; 1.5  1.9.2  2019.08  4.19    1.8.2  22.0.7  ~&gt; 1.5  1.8.5  2019.05.1  4.19    1.8.1  22.0.7  ~&gt; 1.5  1.8.4  2019.05.1  4.19     \n\n  nerves_system_osd32mp1     osd32mp1  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      0.14.0  26.0  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.4    0.13.2  25.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.4    0.13.1  25.2.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.4    0.13.0  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.4    0.12.2  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.4    0.12.1  25.1.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.4    0.12.0  25.1.1  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.4.41    0.11.2  25.0.4  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.4.41    0.11.1  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.4.41    0.11.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.4.41    0.10.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.4.41    0.9.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.4.41    0.9.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.4.41    0.9.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.4.41    0.9.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.3  2021.11  5.4.41    0.9.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.2  2021.11  5.4.41    0.8.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.4  2021.08.2  5.4.41    0.8.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.3  2021.08.1  5.4.41    0.8.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.1  2021.08.1  5.4.41    0.8.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.0  2021.08  5.4.41    0.7.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.4  2021.05.1  5.4.41    0.7.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.1  2021.05  5.4.41    0.7.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.0  2021.05  5.4.41    0.6.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.1  2021.02.1  5.4.41    0.6.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.0  2021.02  5.4.41    0.5.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.14.4  2020.11.2  5.4.41    0.4.3  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4.41    0.4.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4.41    0.4.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4.41    0.4.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  5.4.41    0.3.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  5.4.41    0.3.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  5.4.41    0.3.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  5.4.41    0.2.0  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  5.4.41    0.1.0  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  5.4.41     \n\n  nerves_system_x86_64     x86_64  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      1.23.0  26.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.4    1.22.2  25.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.4    1.22.1  25.2.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.4    1.22.0  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.4    1.21.2  25.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.4    1.21.1  25.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.4    1.21.0  25.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.4.204    1.20.3  25.0.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.4.204    1.20.2  25.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.4.204    1.20.1  25.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.4.204    1.20.0  25.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.4.51    1.19.0  25.0  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.4.51    1.18.4  24.3.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.4.51    1.18.3  24.2.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.4.51    1.18.2  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.4.51    1.18.1  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.3  2021.11  5.4.51    1.18.0  24.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.18.2  2021.11  5.4.51    1.17.3  24.1.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.4  2021.08.2  5.4.51    1.17.2  24.1.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.3  2021.08.1  5.4.51    1.17.1  24.1.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.1  2021.08.1  5.4.51    1.17.0  24.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.17.0  2021.08  5.4.51    1.16.2  24.0.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.4  2021.05.1  5.4.51    1.16.1  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.1  2021.05  5.4.51    1.16.0  24.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.16.0  2021.05  5.4.51    1.15.1  23.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.1  2021.02.1  5.4.51    1.15.0  23.2.7  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.15.0  2021.02  5.4.51    1.14.0  23.2.4  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.4  1.14.4  2020.11.2  5.4.51    1.13.4  23.1.5  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.7  2020.08.2  5.4.51    1.13.3  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.5  2020.08.2  5.4.51    1.13.2  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4.51    1.13.1  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.4  2020.08.1  5.4.51    1.13.0  23.1.1  ~&gt; 1.5.4 or ~&gt; 1.6.0 or ~&gt; 1.7.0  1.13.2  2020.08  4.19.108    1.12.2  23.0.3  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.4  2020.05.1  4.19.108    1.12.1  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19.108    1.12.0  23.0.2  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.12.0  2020.05  4.19.108    1.11.2  22.3.4  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.4  2020.02.1  4.19.108    1.11.1  22.3.1  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.2  2020.02  4.19.108    1.11.0  22.2.8  ~&gt; 1.5.4 or ~&gt; 1.6.0  1.11.0  2020.02  4.19.108    1.10.2  22.2.4  ~&gt; 1.5.0  1.10.2  2019.11.1  4.19.87    1.10.1  22.2.2  ~&gt; 1.5.0  1.10.1  2019.11.1  4.19.87    1.10.0  22.1.5  ~&gt; 1.5.0  1.10.0  2019.11  4.19.87    1.9.2  22.1.5  ~&gt; 1.5.0  1.9.5  2019.08.2  4.19.43    1.9.1  22.1.1  ~&gt; 1.5.0  1.9.4  2019.08.1  4.19.43    1.9.0  22.0.7  ~&gt; 1.5.0  1.9.2  2019.08  4.19.43    1.8.2  22.0.7  ~&gt; 1.5.0  1.8.5  2019.05.1  4.19.43    1.8.1  22.0.7  ~&gt; 1.5.0  1.8.4  2019.05.1  4.19.43    1.8.0  22.0.3  ~&gt; 1.4  1.8.2  2019.05  4.19.43    1.7.2  21.3.6  ~&gt; 1.3  1.7.2  2019.02  4.19.29    1.7.1  21.2.7  ~&gt; 1.3  1.7.1  2019.02  4.19.29    1.7.0  21.2.7  ~&gt; 1.3  1.7.0  2019.02  4.19.29     \n\n  nerves_system_grisp2     grisp2  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      0.7.0  26.0  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  5.10    0.6.2  25.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  5.10    0.6.1  25.2.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  5.10    0.6.0  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  5.10    0.5.2  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.10    0.5.1  25.1.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.10    0.5.0  25.1.1  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.10    0.4.2  25.0.4  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.10    0.4.1  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.10    0.4.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.10    0.3.0  25.0  ~&gt; 1.6.0 or ~&gt; 1.7.15  1.19.0  2022.02.1  5.10    0.2.3  24.3.2  ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.6  2021.11.2  5.10    0.2.2  24.2.2  ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    0.2.1  24.2.2  ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.5  2021.11.2  5.10    0.2.0  24.2  ~&gt; 1.6.0 or ~&gt; 1.7.15  1.18.4  2021.11.1  5.10     \n\n  nerves_system_mangopi_mq_pro     mangopi_mq_pro  Erlang/OTP  Nerves  Nerves System BR  Buildroot  Linux      0.5.0  26.0  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.23.1  2023.02.2  6.1    0.4.3  25.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.5  2022.11.3  6.1    0.4.2  25.2.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.3  2022.11.1  6.1    0.4.1  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  6.1    0.4.0  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.22.1  2022.11  6.1    0.3.2  25.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.6  2022.08.3  5.19    0.3.1  25.1.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.2  2022.08.1  5.19    0.3.0  25.1.1  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.21.1  2022.08.1  5.19    0.2.5  25.0.4  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.6  2022.05.2  5.19    0.2.4  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8  1.20.4  2022.05  5.19    0.2.3  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.19    0.2.2  25.0.3  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.4  2022.05  5.19    0.2.1  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.19    0.2.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.18    0.1.1  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.3  2022.05  5.14    0.1.0  25.0.2  ~&gt; 1.6.0 or ~&gt; 1.7.15 or ~&gt; 1.8.0  1.20.2  2022.05  5.14     \n \n\nRun `mix deps` to see the Nerves System version and go to that system's\nrepository on https://github.com/nerves-project.\n\nIf you need to run a particular version of Erlang/OTP on your target, you can\neither lock the `nerves_system_*` dependency in your `mix.exs` to an older\nversion. Note that this route prevents you from receiving security updates\nfrom the official systems. The other option is to build a custom Nerves\nsystem. See the Nerves documentation for building a custom system and then\nrun `make menuconfig` and look for the Erlang options.","ref":"systems.html#compatibility"},{"type":"extras","title":"Anatomy of a Nerves System - Systems","doc":"Nerves system dependencies are a collection of configurations to be fed into\nthe system build platform. Currently, Nerves systems are all built using the\nBuildroot platform. The project structure of a Nerves system is as follows:\n\n```plain\nnerves_system_rpi3\n├── LICENSE\n├── README.md\n├── VERSION\n├── cmdline.txt\n├── config.txt\n├── fwup.conf\n├── linux-4.4.defconfig\n├── mix.exs\n├── nerves_defconfig\n├── post-createfs.sh\n└── rootfs-overlay\n    └── etc\n        └── erlinit.config\n        └── fw_env.config\n```\n\nThe `mix.exs` defines the toolchain and build platform, for example:\n\n```elixir\ndef project do\n  [ # ...\n   nerves_package: nerves_package(),\n   compilers: Mix.compilers ++ [:nerves_package],\n   aliases: [loadconfig: [&bootstrap/1]]]\nend\n# ...\ndef nerves_package do\n  [\n    type: :system,\n    artifact_sites: [\n      {:github_releases, \"nerves-project/#{@app}\",\n    ],\n    platform: Nerves.System.BR,\n    platform_config: [\n      defconfig: \"nerves_defconfig\"\n    ],\n    checksum: [\n      \"nerves_defconfig\",\n      \"rootfs_overlay\",\n      \"linux-4.4.defconfig\",\n      \"fwup.conf\",\n      \"cmdline.txt\",\n      \"config.txt\",\n      \"post-createfs.sh\",\n      \"VERSION\"\n    ]\n  ]\nend\n# ...\ndefp deps do\n  [\n    {:nerves, \"~> 1.0\", runtime: false},\n    {:nerves_system_br, \"~> 1.0\", runtime: false},\n    {:nerves_toolchain_arm_unknown_linux_gnueabihf, \"~> 1.0\", runtime: false}\n  ]\nend\n# ...\ndefp package do\n [ # ...\n  files: [\"LICENSE\", \"mix.exs\", \" \"],\n  licenses: [\"Apache 2.0\"],\n  links: %{\"Github\" => \"https://github.com/nerves-project/nerves_system_rpi3\"}]\nend\n```\n\nNerves systems have a few requirements in the mix file:\n\n1. The `compilers` must include `:nerves_package` compiler after `Mix.compilers`.\n2. There must be a dependency for the toolchain and the build platform.\n3. The `package` must specify all the required `files` so they are present when\n   downloading from Hex.\n4. The `nerves_package` key should contain nerves package configuration metadata as\n   described in the next section.","ref":"systems.html#anatomy-of-a-nerves-system"},{"type":"extras","title":"Nerves Package Configuration - Systems","doc":"The `mix.exs` project configuration contains a special configuration key `nerves_package`. This key\ncontains configuration information that Nerves loads before any application or\ndependency code is compiled. It is used to store metadata about a package. Here\nis an example from the `mix.exs` file for `nerves_system_rpi3`:\n\n```elixir\n# ...\ndef project do\n  [ # ...\n   nerves_package: nerves_package(),\n    # ...\n  ]\nend\n# ....\ndefp nerves_package do\n  [\n    type: :system,\n    artifact_sites: [\n      {:github_releases, \"nerves-project/#{@app}\"}\n    ],\n    platform: Nerves.System.BR,\n    platform_config: [\n      defconfig: \"nerves_defconfig\"\n    ],\n    checksum: package_files()\n  ]\nend\n```\n\nThe following keys are supported:\n\n1. `type`: The type of Nerves Package.\n\n    Options are: `system`, `system_compiler`, `system_platform`,\n    `system_package`, `toolchain`, `toolchain_compiler`, `toolchain_platform`.\n\n2. `artifact_sites` (optional): Artifacts for Nerves systems and toolchains are\n    too large for most package managers and must be stored externally.\n    Artifact sites specify how to download artifacts and are attempted in order\n    until one is successfully downloaded.\n\n    Supported artifact sites:\n\n    ```elixir\n    {:github_releases, \"organization/project\"}\n    {:github_api, \"organization/project\", username: System.get_env(\"GITHUB_USER\"), token: System.get_env(\"GITHUB_TOKEN\"), tag: @version}\n    {:prefix, \"http://myserver.com/artifacts\"}\n    {:prefix, \"file:///my_artifacts/\"}\n    {:prefix, \"/users/my_user/artifacts/\"}\n    {:prefix, \"http://myserver.com/artifacts\", headers: [{\"Authorization\", \"Basic 12345\"}]}\n    {:prefix, \"http://myserver.com/artifacts\", query_params: %{\"id\" => \"1234\"}}\n    ```\n\n    For official Nerves systems and toolchains, we upload the artifacts to\n    GitHub Releases.\n\n    For an artifact site that uses GitHub Releases in a private repo, [create a\n    personal access token](https://help.github.com/en/articles/creating-a-personal-access-token-for-the-command-line)\n    and use `:github_api` with `username`, `token`, and `tag` options:\n\n    ```elixir\n    {:github_api, \"owner/repo\", username: \"skroob\", token: \"1234567\", tag: \"v0.1.0\"}\n    ```\n\n    Artifact sites can pass options as a third parameter for adding headers\n    or query string parameters.\n\n    ```elixir\n    {:prefix, \"https://my-organization.com\",\n      query_params: %{\"id\" => \"1234567\", \"token\" => \"abcd\"},\n      headers: [{\"Content-Type\", \"application/octet-stream\"}]\n    }\n    ```\n\n    You can also use this to add an authorization header for files behind basic auth.\n\n    ```elixir\n    {:prefix, \"http://my-organization.com/\", headers: [{\"Authorization\", \"Basic \"   System.get_env(\"BASIC_AUTH\")}}]}\n    ```\n\n3. `platform`: The build platform to use for the system or toolchain.\n\n4. `platform_config`: Configuration options for the build platform.\n\n    In this example, the `defconfig` option for the `Nerves.System.BR`\n    platform points to the Buildroot defconfig fragment file used to build the\n    system.\n\n5. `build_runner`: Optional - The build_runner that should be used to build the artifact.\n\n    If this key is not defined, Nerves will choose a default build_runner\n    that should be used to build the artifact based on information about the host\n    computer that you are building on. For example, Mac OS will use\n    `Nerves.Artifact.BuildRunners.Docker` where as Linux will use\n    `Nerves.Artifact.BuildRunners.Local`. Specifying a build_runner module in\n    the package config could be used to force the build_runner.\n\n6. `build_runner_opts`: Optional - A keyword list of options to pass to the build_runner module.\n\n    `make_args:` - Extra arguments to be passed to make.\n\n    For example:\n\n    You can configure the number of parallel jobs that Buildroot\n    can use for execution. This is useful for situations where you may\n    have a machine with a lot of CPUs but not enough ram.\n\n    ```elixir\n    defp nerves_package do\n      [\n        # ...\n        build_runner_opts: [make_args: [\"PARALLEL_JOBS=8\"]],\n      ]\n    end\n    ```\n\n7. `checksum`: The list of files for which checksums are calculated and stored\n    in the artifact cache.\n\n    This checksum is used to match the cached Nerves artifact on disk with its\n    source files, so that it will be re-compiled instead of using the cache if\n    the source files no longer match.","ref":"systems.html#nerves-package-configuration"},{"type":"extras","title":"Customizing Your Own Nerves System - Systems","doc":"[This document has been moved](https://hexdocs.pm/nerves/customizing-systems.html)\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"systems.html#customizing-your-own-nerves-system"},{"type":"extras","title":"User Interfaces","doc":"# User Interfaces","ref":"user-interfaces.html"},{"type":"extras","title":"Phoenix web interface - User Interfaces","doc":"The [Phoenix] web framework makes an excellent companion to [Nerves]-based devices\nthat need to serve content over HTTP directly from the device. For example, a\ndevice with no display might provide administration and configuration\ninterfaces intended to be accessed from a computer or mobile device.\n[Hello Phoenix] is an example of structuring a project as described here.\n\n[Nerves]: https://www.nerves-project.org/\n[Phoenix]: http://www.phoenixframework.org/\n[Hello Phoenix]: https://github.com/nerves-project/nerves_examples/tree/main/hello_phoenix\n\n#","ref":"user-interfaces.html#phoenix-web-interface"},{"type":"extras","title":"Choosing a project structure - User Interfaces","doc":"There are two commonly used project structures for Nerves-based devices that uses\nPhoenix web interface:\n\n- [poncho project structure]\n- [umbrella project structure]\n\nAlthough Nerves supports both, the preferred project structure is what we call\nponcho project structure. For the reasoning behind this, please see the original\n[blog post describing poncho projects]. The following steps assume that we use\nthe poncho project structure.\n\nUsing the poncho project structure, we simply use separate [Mix projects],\nside-by-side with path dependencies between them, in the same source code repository.\n\n[blog post describing poncho projects]: https://embedded-elixir.com/post/2017-05-19-poncho-projects/\n[poncho project structure]: http://embedded-elixir.com/post/2017-05-19-poncho-projects/\n[umbrella project structure]: https://elixir-lang.org/getting-started/mix-otp/dependencies-and-umbrella-projects.html\n[Mix projects]: https://hexdocs.pm/mix/Mix.html\n\n#","ref":"user-interfaces.html#choosing-a-project-structure"},{"type":"extras","title":"Create a poncho project - User Interfaces","doc":"First, we generate the two new Mix projects in a containing directory:\n\n```bash\n# Create a container directory called \"my_app\"\nmkdir my_app && cd my_app\n\n# Create a Nerves firmware project called \"my_app_firmware\"\nmix nerves.new my_app_firmware\n\n# Create a Phoenix 1.6 UI project called \"my_app_ui\"\nmix phx.new my_app_ui --no-ecto --no-mailer\n```\n\nNow, we add the Phoenix-based `my_app_ui` project to the `my_app_firmware`\nproject as a dependency, because we want to use the `my_app_firmware` project\nas a deployment wrapper around the `my_app_ui` project.\n\n```elixir\n# my_app/my_app_firmware/mix.exs\n\n# ...\n  defp deps do\n    [\n      # Dependencies for all targets\n      {:nerves, \"~> 1.7.0\", runtime: false},\n      # ...\n      {:my_app_ui, path: \"../my_app_ui\", targets: @all_targets, env: Mix.env()},\n      # ...\n    ]\n  end\n# ...\n```\n\nWe need a few adjustments to the UI project's `mix.exs`.  By default when `MIX_ENV`\nis `dev`, the default Phoenix setup runs: \n- `phoenix_live_reload` to reload code changes\n- [`esbuild`] to rebuild assets as needed\n- `tailwindcss` to optimize css (Phoenix 1.7+)\n\nThis doesn't work on target device, so we need to limit it to only run on the\nhost:\n\n```elixir\n# my_app/my_app_ui/mix.exs\n\n  defp deps do\n    [\n      {:phoenix, \"~> 1.6.0\"},\n      # ...\n      {:phoenix_live_reload, \"~> 1.2\", only: :dev && Mix.target() == :host},\n      # ...\n      {:esbuild, \"~> 0.5\", runtime: Mix.env() == :dev && Mix.target() == :host},\n      {:tailwind, \"~> 0.1.8\", runtime: Mix.env() == :dev && Mix.target() == :host},\n      # ...\n    ]\n  end\n```\n\n[`esbuild`]: https://hexdocs.pm/esbuild/Esbuild.html\n\n#","ref":"user-interfaces.html#create-a-poncho-project"},{"type":"extras","title":"Configure networking - User Interfaces","doc":"Refer to the [Connecting to Nerves Target page](connecting-to-nerves-target.html).\n\n#","ref":"user-interfaces.html#configure-networking"},{"type":"extras","title":"Configure Phoenix - User Interfaces","doc":"In order to deploy the `my_app/my_app_ui` Phoenix-based project along with the\nNerves-based `my_app/my_app_firmware` project, we need to configure our [`Phoenix.Endpoint`]\nusing appropriate settings for deployment on an embedded device. If\nwe're using a poncho project structure, we'll need to keep in mind that the\n`my_app/my_app_ui` configuration won't be applied automatically, so we should either\n`import` it from there or duplicate the required configuration.\n\nOur configuration might look like this (as of Phoenix 1.6.2):\n\n```elixir\n# my_app_/my_app_firmware/config/target.exs\n\nconfig :my_app_ui, MyAppUiWeb.Endpoint,\n  url: [host: \"nerves.local\"],\n  http: [port: 80],\n  cache_static_manifest: \"priv/static/cache_manifest.json\",\n  secret_key_base: \"HEY05EB1dFVSu6KykKHuS4rQPQzSHv4F7mGVB/gnDLrIu75wE/ytBXy2TaL3A6RA\",\n  live_view: [signing_salt: \"AAAABjEyERMkxgDh\"],\n  check_origin: false,\n  render_errors: [view: MyAppUiWeb.ErrorView, accepts: ~w(html json), layout: false],\n  pubsub_server: Ui.PubSub,\n  # Start the server since we're running in a release instead of through `mix`\n  server: true,\n  # Nerves root filesystem is read-only, so disable the code reloader\n  code_reloader: false\n\n# Use Jason for JSON parsing in Phoenix\nconfig :phoenix, :json_library, Jason\n```\n\nThere we have it! A Phoenix-based web application is now ready to run on our\nNerves-based embedded device. By separating the Phoenix-based project from the\nNerves-based project, we enable teams to work on the core functionality and\nuser interface code even without having physical hardware. We also minimize the\nhardware/software integration effort by managing both the core software and the\nfirmware deployment infrastructure in a single poncho project.\n\n[`Phoenix.Endpoint`]: https://hexdocs.pm/phoenix/Phoenix.Endpoint.html\n\n#","ref":"user-interfaces.html#configure-phoenix"},{"type":"extras","title":"Develop the UI - User Interfaces","doc":"When developing the UI, we can simply run the Phoenix server from the\n`my_app_ui` project directory:\n\n```bash\ncd path/to/my_app_ui\niex -S mix phx.server\n```\n\n#","ref":"user-interfaces.html#develop-the-ui"},{"type":"extras","title":"Deploy the firmware - User Interfaces","doc":"First we build our assets in the `my_app_ui` project directory and prepare them\nfor deployment to the firmware:\n\n```bash\ncd path/to/my_app_ui\n\n# We want to build assets on our host machine.\nexport MIX_TARGET=host\nexport MIX_ENV=dev\n\n# This needs to be repeated when you change dependencies for the UI.\nmix deps.get\n\n# This needs to be repeated when you change JS or CSS files.\nmix assets.deploy\n```\n\nWhen it's time to deploy firmware to our hardware, we can do it from the\n`my_app_firmware` project directory:\n\n```bash\ncd path/to/my_app_firmware\n\n# Specify our target device.\nexport MIX_TARGET=rpi3\nexport MIX_ENV=dev\n\nmix deps.get\nmix firmware\n# (Connect the SD card)\nmix firmware.burn\n```","ref":"user-interfaces.html#deploy-the-firmware"},{"type":"extras","title":"Scenic - User Interfaces","doc":"Scenic is 2D UI framework written in Elixir that's designed with\nembedded systems in mind and works well with Nerves on screens like the\n[Raspberry Pi Touch Display](https://www.raspberrypi.com/products/raspberry-pi-touch-display/)\nor HDMI connected screens.\n\nHelpful links:\n* [Scenic: Getting Start with Nerves doc](https://hexdocs.pm/scenic/getting_started_nerves.html)\n* [Scenic Forum](https://elixirforum.com/c/elixir-framework-forums/scenic-forum/107)\n* [ElixirConf 2018 - Introducing Scenic A Functional UI Framework - Boyd Multerer](https://www.youtube.com/watch?v=1QNxLNMq3Uw)\n* [Scenic Now and Looking Ahead - Boyd Multerer | ElixirConfEU Virtual 20](https://www.youtube.com/watch?v=tej-SyhZrqk)","ref":"user-interfaces.html#scenic"},{"type":"extras","title":"eInk displays - User Interfaces","doc":"Some initial work has been done to support eInk displays like the Pimoroni Inky\n[pHAT](https://shop.pimoroni.com/products/inky-phat) and\n[wHAT](https://shop.pimoroni.com/products/inky-what) models. Look at the\n[`:inky` repo](https://github.com/pappersverk/inky) for more info.","ref":"user-interfaces.html#eink-displays"},{"type":"extras","title":"OLED - User Interfaces","doc":"Basic work has been done to support small OLED screens with the SSD1306 chip which\nare usually smaller screens a few inches wide. More info in the [`:oled` docs](https://hexdocs.pm/oled)","ref":"user-interfaces.html#oled"},{"type":"extras","title":"Web Kiosks - User Interfaces","doc":"Several companies have integrated web browsers with Nerves for kiosk applications.\nUnfortunately, public repositories are currently unmaintained. If this is of interest to\nyou, take a look at the repos in the [Nerves Web Kiosks](https://github.com/nerves-web-kiosk)\norg and consider helping maintain them.\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"user-interfaces.html#web-kiosks"},{"type":"extras","title":"Environment variables","doc":"# Environment variables\n\nNerves uses environment variables to control the build process and pass\noptions to cross-compilers.","ref":"environment-variables.html"},{"type":"extras","title":"Overridable variables - Environment variables","doc":"Set these variables if you would like to adjust how Nerves builds\ndevice-specific code.\n\n| Name                            | Description |\n| ------------------------------- | ----------- |\n| XDG_DATA_HOME                   | If set, uses `$XDG_DATA_HOME/nerves` as the data directory. Defaults to `~/.nerves` if unset |\n| NERVES_DL_DIR                   | Path where compressed Nerves system and toolchain artifacts are downloaded during `mix deps.get`. Defaults to `$XDG_DATA_HOME/nerves/dl` |\n| NERVES_ARTIFACTS_DIR            | Path where Nerves system and toolchain artifacts are decompressed (from `$NERVES_DL_DIR/ `) and cached for use with compilation. Defaults to `$XDG_DATA_HOME/nerves/artifacts` |\n| NERVES_ENV_DISABLED             | Set to `1` to disable the nerves_package compiler |\n| NERVES_DEBUG                    | Set to `1` to print out debug info during compilation |\n| NERVES_LOG_DISABLE_PROGRESS_BAR | Set to `1` to disable progress bar output when fetching artifacts (typically for CI) |\n| SOURCE_DATE_EPOCH               | Used for [reproducable builds](https://reproducible-builds.org). Can also be set via `config :nerves, source_date_epoch: val` |","ref":"environment-variables.html#overridable-variables"},{"type":"extras","title":"Nerves-provided environment variables - Environment variables","doc":"Nerves sets the environment variables in this section to control compilation.\nMost variables affect the compilation of C and C++ code so that they use the\nright crosscompiler, flags, and directories. These environment variables are\navailable to `mix`, `rebar3` and any code invoked from them. For example,\nthese are frequently used in the `Makefiles` invoked by\n[`elixir_make`](https://hex.pm/packages/elixir_make).\n\nName                   | Min `nerves_system_br` version | Description\n---------------------- | ------------------------------ | -----------\nAR_FOR_BUILD           | `v1.13.1`                      | The host's `ar`\nAS_FOR_BUILD           | `v1.13.1`                      | The host's `as`\nCC                     | All                            | The path to `gcc` for crosscompiling to the target\nCC_FOR_BUILD           | `v1.13.1`                      | The host's `cc`\nCFLAGS                 | All                            | Recommended C compilation flags\nCFLAGS_FOR_BUILD       | `v1.13.1`                      | Recommended C compiler flags for the host\nCMAKE_TOOLCHAIN_FILE   | `v1.18.3`                      | To build CMake projects, configure CMake with `-DCMAKE_TOOLCHAIN_FILE=\"$(CMAKE_TOOLCHAIN_FILE)\"`\nCPPFLAGS               | `v1.14.5`                      | Recommended C preprocessor flags\nCPPFLAGS_FOR_BUILD     | `v1.13.1`                      | Recommended C preprocessor flags for the host\nCROSSCOMPILE           | All                            | The path and prefix for the crosscompilers (e.g., \"$CROSSCOMPILE-gcc\" is the path to gcc)\nCXX                    | All                            | The path to `g++` for crosscompiling to the target\nCXX_FOR_BUILD          | `v1.13.1`                      | The host's `g++`\nCXXFLAGS               | All                            | Recommended C++ compilation flags\nCXXFLAGS_FOR_BUILD     | `v1.13.1`                      | Recommended C++ compiler flags for the host\nERL_CFLAGS             | All                            | Additional compilation flags for Erlang NIFs and ports\nERL_EI_INCLUDE_DIR     | All                            | Rebar variable for finding erl interface include files\nERL_EI_LIBDIR          | All                            | Rebar variable for finding erl interface libraries\nERL_LDFLAGS            | All                            | Additional linker flags for Erlang NIFs and ports\nERTS_INCLUDE_DIR       | All                            | erlang.mk variable for finding erts include files\nGCC_FOR_BUILD          | `v1.13.1`                      | The host's `gcc`\nLD_FOR_BUILD           | `v1.13.1`                      | The host's `ld`\nLDFLAGS                | All                            | Recommended linker flags\nLDFLAGS_FOR_BUILD      | `v1.13.1`                      | Recommended linker flags for the host\nPKG_CONFIG_SYSROOT_DIR | `v1.8.5`                       | Sysroot for using `pkg-config` to find libraries in the Nerves system\nPKG_CONFIG_LIBDIR      | `v1.8.5`                       | Metadata for `pkg-config` on the target\nQMAKESPEC              | `v1.4.0`                       | If Qt is available, this points to the spec file\nREBAR_TARGET_ARCH      | All                            | Set to the binutils prefix (e.g., `arm-linux-gnueabi`) for [rebar2](https://github.com/rebar/rebar)\nSTRIP                  | All                            | The path to `strip` for target binaries (Nerves strips binaries by default)\nNERVES_APP             | All                            | Current Nerves project root path\nNERVES_SYSTEM          | All                            | Path to target Nerves system to use (`$NERVES_ARTIFACTS_DIR/ `)\nNERVES_TOOLCHAIN       | All                            | Path to target Nerves toolchain to use (`$NERVES_ARTIFACTS_DIR/ `)\nNERVES_SDK_IMAGES      | All                            | Path to Nerves system images directory (`$NERVES_SYSTEM/images`)\nNERVES_SDK_SYSROOT     | All                            | Path to Nerves system sysroot directory (`$NERVES_SYSTEM/staging`)\nTARGET_ABI             | See below                      | The target ABI (e.g., `gnueabihf`, `musl`)\nTARGET_ARCH            | See below                      | The target CPU architecture (e.g., `arm`, `aarch64`, `mipsel`, `x86_64`, `riscv64`)\nTARGET_CPU             | See below                      | The target CPU (e.g., `cortex_a7`)\nTARGET_GCC_FLAGS       | See below                      | Additional options to be passed to `gcc`. For example, enable CPU-specific features or force ASLR or stack smash protections\nTARGET_OS              | See below                      | The target OS. Always `linux` for Nerves.\n\nAlso see the [`elixir_make`\ndocumentation](https://hexdocs.pm/elixir_make/Mix.Tasks.Compile.ElixirMake.html#module-default-environment-variables)\nfor additional environment variables that may be useful.","ref":"environment-variables.html#nerves-provided-environment-variables"},{"type":"extras","title":"Target CPU, ARCH, OS, and ABI - Environment variables","doc":"The `TARGET_*` variables are optionally set by the Nerves system. All official\nNerves systems set them, but it is not mandatory for forks. These variables are\nuseful for guiding compilation of LLVM-based tools.\n\nThe current way of deriving their values is to use [`zig`](https://ziglang.org/)\nand to select the combination that makes most sense for the target. To view the\noptions, install zig and run:\n\n```sh\nzig targets | less\n```\n\nThese variables are defined as custom environment variables in the Nerves\nsystem's `mix.exs`.  For example, the following is the definition for the\nRaspberry Pi Zero:\n\n```elixir\n  defp nerves_package do\n    [\n      type: :system,\n      ...\n      env: [\n        {\"TARGET_ARCH\", \"arm\"},\n        {\"TARGET_CPU\", \"arm1176jzf_s\"},\n        {\"TARGET_OS\", \"linux\"},\n        {\"TARGET_ABI\", \"gnueabihf\"}\n      ]\n      ...\n    ]\n  end\n```\n\nWhile the `TARGET_*` environment variables are mostly geared for non-gcc\ncompilers, it's useful to add custom flags to gcc invocations as well. The\n`TARGET_GCC_FLAGS` option supports this. The Nerves tooling will prepend the\ncontents of `TARGET_GCC_FLAGS` to the `CFLAGS` and `CXXFLAGS` used when\ncompiling NIFs and ports. This can be used to enable features like ARM NEON\nsupport that would otherwise be off when using crosscompiler toolchain defaults.\nMost users don't need to concern themselves with `TARGET_GCC_FLAGS`. If you are\ncreating a custom system, not setting `TARGET_GCC_FLAGS` is almost always fine,\nbut will result in NIFs and ports being built with generic compiler options.","ref":"environment-variables.html#target-cpu-arch-os-and-abi"},{"type":"extras","title":"Compiling Non-BEAM Code","doc":"# Compiling Non-BEAM Code\n\nIt's almost guaranteed that you'll have some code in your project that won't be\nwritten in Elixir, Erlang, or another BEAM language. Nerves provides multiple\nways of integrating this code and the one you choose depends on many things.\n\nHere are rules of thumb:\n\n1. Build large and complicated C and C++ projects using Buildroot by creating a\n   [Custom system](https://hexdocs.pm/nerves/customizing-systems.html)\n2. Build small C and C++ projects using\n   [`elixir_make`](https://hex.pm/packages/elixir_make)\n3. Look for libraries like [`zigler`](https://hex.pm/packages/zigler) for\n   specific languages\n4. When hope is lost, compile the programs outside of Nerves and include the\n   binaries in a `priv` directory. Static linking is recommended.\n\nIn a perfect world, it would be easy to use whatever language you wanted and\nadding a program would be as simple as adding a reference to it to your `mix\ndeps`. Sadly, that's not the case for embedded systems and sometimes an inferior\nlibrary may be preferable just because it carries fewer dependencies or is\neasier to build.\n\nBe aware of the following caveats with Nerves:\n\n1. Nerves does not use the embedded Linux init systems like `systemd` or\n   `BusyBox init`. Initialization is done in either an\n   [Application.start callback](https://hexdocs.pm/elixir/Application.html#module-the-application-callback-module)\n   or in a `GenServer` so that it can be supervised.\n2. D-Bus is not normally enabled on Nerves. It may be enabled in a custom\n   system.\n3. X Windows is not used. Again, it may be enabled, but it is far more common to\n   have UI applications be fullscreen and not use a window manager.\n4. Only a few commands are available to shell scripts. You're encouraged to\n   use Elixir instead, but if that's not feasible, it's possible to add missing\n   commands by enabling them in Busybox in a custom system.\n\n> ##","ref":"compiling-non-beam-code.html"},{"type":"extras","title":"Tip {: .tip} - Compiling Non-BEAM Code","doc":">\n> If you require a long running process from a provided exectuable and need\n> similar startup and supervision management of `systemd`, you can also use\n> [`:muontrap`](https://hexdocs.pm/muontrap/readme.html) to start it in your\n> application supervision. See [this talk](https://youtu.be/BtUmxoccZGE?t=1559)\n> for more information\n\nBefore you even start, experience has shown that searching the [Erlang/OTP\ndocs](http://erlang.org/doc/index.html) three times and skimming the\n[Erlang source](https://github.com/erlang/otp) lead to all kinds of amazing\ndiscoveries that may not require you to port any code at all. If you do need to\nport code, keep in mind that while Nerves uses the Linux kernel, it highly\nfavors Erlang/OTP ways of building systems and not embedded Linux ways. If you\nfind yourself continually fighting Nerves and missing embedded Linux, your use\ncase may be better met by installing Elixir on embedded Linux rather than trying\nto make Nerves look more like embedded Linux. Many embedded Elixir libraries\nwork fine on both Nerves and embedded Linux.\n\nRefer to [Environment Variables](Environment Variables.md) for sources available\nduring compilation if needed.","ref":"compiling-non-beam-code.html#tip-tip"},{"type":"extras","title":"Library recommendations - Compiling Non-BEAM Code","doc":"In general, most Elixir and Erlang libraries that include\n[NIFs](http://erlang.org/doc/tutorial/nif.html) and\n[ports](http://erlang.org/doc/tutorial/c_port.html) can be made to work with\nNerves. Nerves is, however, less forgiving than normal compilation.\n\nThree recommendations cannot be stressed enough:\n\n1. Always compile under `_build`\n   * While it's much easier to compile in the source directory, this always\n     leads to errors where an executable compiled for one architecture (the\n     host) ends up being put on the target. Nerves will fail with an [`ERROR:\n     Unexpected executable format`](https://github.com/nerves-project/nerves_system_br/blob/v1.18.6/scripts/scrub-otp-release.sh#L136-L174)\n     error when this happens, but it causes a lot of confusion.\n\n2. Do not have a `priv` directory in your source tree\n   * While Elixir provides a shortcut for copying files from a source `priv`\n     directory to the build output `priv` directory, experience has been that\n     this feature causes confusion when building native code. If you do have\n     static assets that you want in the output `priv` directory, add a line to\n     your `Makefile` or `mix.exs` to copy them.\n\n3. Prefer ports over NIFs to interface with external code with Erlang VM (if\n   the choice is available)\n   * Ports offer the benefit of safety since they run in an OS process. In\n     other words, if the port crashes, Linux cleans up the mess. If a NIF\n     crashes on Nerves, the BEAM crashes and Nerves reboots the device.\n\nThe Internet has many examples of how to write\n[NIFs](http://erlang.org/doc/tutorial/nif.html). For an example `Makefile` that\nworks well with Nerves and embedded Linux, see the [circuits_i2c\nMakefile](https://github.com/elixir-circuits/circuits_i2c/blob/main/Makefile)\nor watch [this clip](https://youtu.be/BtUmxoccZGE?t=1827) about\ncross-compilation and Makefiles with Nerves.\n\n> ##","ref":"compiling-non-beam-code.html#library-recommendations"},{"type":"extras","title":"Tip {: .tip} - Compiling Non-BEAM Code","doc":">\n> Consider [zigler](https://github.com/ityonemo/zigler) for a safer\n> alternative to C and C++ that works with Nerves.\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"compiling-non-beam-code.html#tip-tip"},{"type":"extras","title":"Advanced Configuration","doc":"# Advanced Configuration","ref":"advanced-configuration.html"},{"type":"extras","title":"Target-Specific Configuration - Advanced Configuration","doc":"Different target boards have different layouts for GPIO, LEDs, and more. Often,\nthis requires that configurations be specified per-target. In this example, we\nwill be looking at how to configure the LEDs for two different targets. First,\nlet's start by modifying our `config.exs` to include configs for each target.\n\n```elixir\n# config/config.exs\n\nimport_config \"#{Mix.Project.config[:target]}.exs\"\n```\n\nThis will load a different Mix config for each target. Let's say we plan to\nsupport targets `rpi3` and `bbb`. These target devices have different numbers of\nuser-controlled LEDs and we want each to blink all of its LEDs. The\nconfiguration files would look like this:\n\n```elixir\n# config/rpi3.exs\n\nconfig :blinky, led_list: [ :green ]\nconfig :nerves_leds, names: [ green: \"led0\" ]\n```\n\n```elixir\n# config/bbb.exs\n\nconfig :blinky, led_list: [ :led0, :led1, :led2, :led3 ]\n\nconfig :nerves_leds, names: [\n  led0: \"beaglebone:green:usr0\",\n  led1: \"beaglebone:green:usr1\",\n  led2: \"beaglebone:green:usr2\",\n  led3: \"beaglebone:green:usr3\"\n]\n```","ref":"advanced-configuration.html#target-specific-configuration"},{"type":"extras","title":"Root Filesystem Overlays - Advanced Configuration","doc":"Sometimes, you want to ship additional files and configurations with your\nfirmware. This is done by telling the firmware assembler where to find a\ndirectory to use as an overlay on the root mount point:\n\n```elixir\n# config/config.exs\n\nconfig :nerves, :firmware,\n  rootfs_overlay: \"rootfs_overlay\"\n```\n\nThis declares that the contents of the folder at `rootfs_overlay` in your\nproject root directory will be merged into the root filesystem when `mix\nfirmware` is called. You can also specify a different `rootfs_overlay` for each\ntarget, as shown in the previous section.\n\n#","ref":"advanced-configuration.html#root-filesystem-overlays"},{"type":"extras","title":"Overwriting Files in the Root Filesystem - Advanced Configuration","doc":"Any files in the `rootfs_overlay` directory will overwrite those present in the\nunderlying filesystem. This can be useful if you want to change the contents of\nincluded files in the underlying Nerves system. Let's say, for example, that you\nwant to change the behavior of `erlinit`. You can include your own\n`erlinit.config`:\n\n```bash\n# rootfs_overlay/etc/erlinit.config\n\n# Uncomment to hang the board rather than rebooting when Erlang exits\n#--hang-on-exit\n\n# Enable UTF-8 filename handling in Erlang and custom inet configuration\n-e LANG=en_US.UTF-8;LANGUAGE=en;ERL_INETRC=/etc/erl_inetrc;ERL_CRASH_DUMP=/root/crash.dump\n\n# Mount the application partition\n-m /dev/mmcblk0p3:/root:ext4::\n\n# Erlang release search path\n-r /srv/erlang\n\n# Hostname\n-d \"/usr/bin/boardid -b bbb -n 4\"\n-n nerves-%.4s\n```\n\nIt is important to note that the entire file is replaced when you apply an\noverlay, rather than merging the contents. Therefore, you should first obtain\nand modify the original file. A trick for doing this is to expand the\n`rootfs.squashfs`. You can do this using `unsquashfs`:\n\n```bash\nunsquashfs ~/.nerves/artifacts/ /images/rootfs.squashfs\n```\n\nIt will be expanded into the current directory under `squashfs-root`\n\n#","ref":"advanced-configuration.html#overwriting-files-in-the-root-filesystem"},{"type":"extras","title":"Overwriting Files in the Boot Partition - Advanced Configuration","doc":"Different targets have different boot partition contents. To overwrite files in\nthe boot partition, you will need to use your own `fwup.conf` file:\n\n##","ref":"advanced-configuration.html#overwriting-files-in-the-boot-partition"},{"type":"extras","title":"Copy `fwup.conf` to Your `config/` Directory - Advanced Configuration","doc":"```bash\n# Locate the fwup.conf files available in your deps directory\nfind deps -name fwup.conf\n# Copy the one that matches your target to the config directory.\ncp deps/nerves_system_rpi0/fwup.conf config/\n# Also copy cmdline.txt as you'll need it below.\ncp deps/nerves_system_rpi0/cmdline.txt config/\n```\n\n##","ref":"advanced-configuration.html#copy-fwup-conf-to-your-config-directory"},{"type":"extras","title":"Configure Your System to Use the Copied `fwup.conf` - Advanced Configuration","doc":"```elixir\n# config/config.exs\n\nconfig :nerves, :firmware,\n  fwup_conf: \"config/fwup.conf\"\n```\n\n##","ref":"advanced-configuration.html#configure-your-system-to-use-the-copied-fwup-conf"},{"type":"extras","title":"Make Your Changes - Advanced Configuration","doc":"In your included `fwup.conf` file, you can use absolute paths or environment\nvariables to point to the location of included files.\n\nLet's say you have a Raspberry Pi and you want to change the contents of the\n`cmdline.txt` file. You can do this by editing the `fwup.conf` as follows:\n\n```bash\n# fwup.conf\n\nfile-resource cmdline.txt {\n    host-path = \"${NERVES_APP}/config/cmdline.txt\"\n}\n```\n\nYou can use the `NERVES_APP` environment variable to point to the root of your\nElixir app. This variable is automatically managed for you by\n`nerves_bootstrap`.\n\n#","ref":"advanced-configuration.html#make-your-changes"},{"type":"extras","title":"Device Tree Overlays - Advanced Configuration","doc":"To add a device tree overlay for your hardware, first define a file-resource for\nthe dtbo file inside `fwup.conf`. As with other file overlays, you can use\nabsolute paths or environment variables to point to the file location. For\nexample, to add support for a Bosch BMP280 I2C sensor on a Raspberry Pi, your new\nfile resource will be:\n\n```bash\n# fwup.conf\n\nfile-resource i2c-sensor.dtbo {\n    host-path = \"${NERVES_SYSTEM}/images/rpi-firmware/overlays/i2c-sensor.dtbo\"\n}\n```\n\nNext you need make sure the dtbo file is written to the destination media on\nbuild and update of your firmware. Add a new `on-resource` declaration for each\nof the three firmware tasks:\n\n```bash\n# fwup.conf\n\ntask complete{\n    # ... look for where `on-resource` directives are already defined and add:\n    on-resource i2c-sensor.dtbo {\n        fat_write(${BOOT_A_PART_OFFSET}, \"overlays/i2c-sensor.dtbo\")\n    }\n}\n\ntask upgrade.a {\n    # ...\n    on-resource i2c-sensor.dtbo {\n        fat_write(${BOOT_A_PART_OFFSET}, \"overlays/i2c-sensor.dtbo\")\n    }\n}\n\ntask upgrade.b {\n    # ...\n    on-resource i2c-sensor.dtbo {\n        fat_write(${BOOT_B_PART_OFFSET}, \"overlays/i2c-sensor.dtbo\")\n    }\n}\n```\n\nNote that the `BOOT_x_PART_OFFSET` variable must match the partition being\nwritten to for each task.\n\nIn order to load your new overlay, you will need to create your own\n`config.txt` and use it instead of the default. Copy `config.txt` from your\ntarget Nerves system and place it inside your project at `config/config.txt`.\n\n`fwup.conf` now needs to be updated to use this new file. There should already be a\n`file-resource` directive for `config.txt`. Find it and change the `host-path`\nto point at the new location inside you project:\n\n```bash\n# fwup.conf\n\nfile-resource config.txt {\n    host-path = \"${NERVES_APP}/config/config.txt\"\n}\n```\n\nAt this point the overlay will be available to load inside `config/config.txt`\non boot. Follow the documentation for your hardware. For the Bosch BMP280 in our\nexample, the configuration will be:\n\n```bash\n# config.txt\n\ndtoverlay=i2c-sensor,bmp280\n```","ref":"advanced-configuration.html#device-tree-overlays"},{"type":"extras","title":"Partitions - Advanced Configuration","doc":"Nerves firmware uses Master Boot Record (MBR) partition layout, which only\nsupports 4 primary partitions. By default, the root filesystem partition is\nmounted in read-only mode. This prevents corruption of the root filesystem due\nto \"improper shutdowns\". With embedded systems, it is assumed that power can be\nremoved from the device at any time. This could be problematic if you are\nperforming a write operation on the filesystem. Because the root filesystem is\nread-only, we also add a read/write partition by default, called `app_data` and\nmounted at `/data` (the `root` user's home directory). These settings are\ndefined in `etc/erlinit.config`.\n\n```plain\n +----------------------------+\n | MBR                        |\n +----------------------------+\n | Firmware configuration data|\n | (formatted as uboot env)   |\n +----------------------------+\n | p0*: Boot A        (FAT32) |\n | zImage, bootcode.bin,      |\n | config.txt, etc.           |\n +----------------------------+\n | p0*: Boot B        (FAT32) |\n +----------------------------+\n | p1*: Rootfs A   (squashfs) |\n +----------------------------+\n | p1*: Rootfs B   (squashfs) |\n +----------------------------+\n | p2: Application     (EXT4) |\n +----------------------------+\n```\n\nMore information about how the App Data partition is initialized and mounted can\nbe found in the documentation for `nerves_runtime` [Filesystem\nInitialization](https://hexdocs.pm/nerves_runtime/readme.html#filesystem-initialization)\n\n#","ref":"advanced-configuration.html#partitions"},{"type":"extras","title":"Adding a Partition - Advanced Configuration","doc":"You can enable and mount an additional read/write partition by modifying the\n`fwup.conf` file. This strategy is typically used to define two locations where\ndata can be written. Let's say you want to persist some infrequently-written\nconfiguration data and some frequently-written log data. These use-cases could\nbe segmented into separate partitions so that the important,\ninfrequently-written configuration data is not corrupted due to a loss of power\nwhile writing the more-frequent, but less-critical, log data.\n\nFirst, define a new space on the disk for the partition:\n\n```bash\n# fwup.conf\n\n# (Sizes are in 512 byte blocks)\ndefine(UBOOT_ENV_OFFSET, 16)\ndefine(UBOOT_ENV_COUNT, 16)  # 8 KB\n\ndefine(BOOT_A_PART_OFFSET, 63)\ndefine(BOOT_A_PART_COUNT, 38630)\ndefine-eval(BOOT_B_PART_OFFSET, \"${BOOT_A_PART_OFFSET} + ${BOOT_A_PART_COUNT}\")\ndefine(BOOT_B_PART_COUNT, ${BOOT_A_PART_COUNT})\n\n# Let the rootfs have room to grow up to 128 MiB and align it to the nearest 1\n# MB boundary\ndefine(ROOTFS_A_PART_OFFSET, 77324)\ndefine(ROOTFS_A_PART_COUNT, 289044)\ndefine-eval(ROOTFS_B_PART_OFFSET, \"${ROOTFS_A_PART_OFFSET} + ${ROOTFS_A_PART_COUNT}\")\ndefine(ROOTFS_B_PART_COUNT, ${ROOTFS_A_PART_COUNT})\n\n# Configuration partition\ndefine-eval(CONFIG_PART_OFFSET, \"${ROOTFS_B_PART_OFFSET} + ${ROOTFS_B_PART_COUNT}\")\ndefine(CONFIG_PART_COUNT, 1048576)\n\n# Log partition\ndefine-eval(LOG_PART_OFFSET, \"${CONFIG_PART_OFFSET} + ${CONFIG_PART_COUNT}\")\ndefine(CONFIG_PART_COUNT, 1048576)\n\n# ...\n```\n\nIn this example, we are changing the default `APP_PART` data partition to\n`CONFIG_PART` and adding `LOG_PART`.\n\nNext, we change the mapping to include these two new partitions:\n\n```bash\n# fwup.conf\n\n# ...\n\nmbr mbr-a {\n    partition 0 {\n        block-offset = ${BOOT_A_PART_OFFSET}\n        block-count = ${BOOT_A_PART_COUNT}\n        type = 0xc # FAT32\n        boot = true\n    }\n    partition 1 {\n        block-offset = ${ROOTFS_A_PART_OFFSET}\n        block-count = ${ROOTFS_A_PART_COUNT}\n        type = 0x83 # Linux\n    }\n    partition 2 {\n        block-offset = ${CONFIG_PART_OFFSET}\n        block-count = ${CONFIG_PART_COUNT}\n        type = 0x83 # Linux\n    }\n    partition 3 {\n        block-offset = ${LOG_PART_OFFSET}\n        block-count = ${LOG_PART_COUNT}\n        type = 0x83 # Linux\n    }\n}\n\nmbr mbr-b {\n    partition 0 {\n        block-offset = ${BOOT_B_PART_OFFSET}\n        block-count = ${BOOT_B_PART_COUNT}\n        type = 0xc # FAT32\n        boot = true\n    }\n    partition 1 {\n        block-offset = ${ROOTFS_B_PART_OFFSET}\n        block-count = ${ROOTFS_B_PART_COUNT}\n        type = 0x83 # Linux\n    }\n    partition 2 {\n        block-offset = ${CONFIG_PART_OFFSET}\n        block-count = ${CONFIG_PART_COUNT}\n        type = 0x83 # Linux\n    }\n    partition 3 {\n        block-offset = ${LOG_PART_OFFSET}\n        block-count = ${LOG_PART_COUNT}\n        type = 0x83 # Linux\n    }\n}\n\n# ...\n```\n\nThis layout defines our system as follows:\n\n```plain\n+----------------------------+\n| MBR                        |\n+----------------------------+\n| Firmware configuration data|\n| (formatted as uboot env)   |\n+----------------------------+\n| p0*: Boot A        (FAT32) |\n| zImage, bootcode.bin,      |\n| config.txt, etc.           |\n+----------------------------+\n| p0*: Boot B        (FAT32) |\n+----------------------------+\n| p1*: Rootfs A   (squashfs) |\n+----------------------------+\n| p1*: Rootfs B   (squashfs) |\n+----------------------------+\n| p2: Config          (EXT4) |\n+----------------------------+\n| p3: Log             (EXT4) |\n+----------------------------+\n```\n\n#","ref":"advanced-configuration.html#adding-a-partition"},{"type":"extras","title":"Mounting the Partition - Advanced Configuration","doc":"Mounting your new partition can either be handled by `erlinit` or by your Elixir\napplication. To have `erlinit` mount the partition for you, you will need to\nsupply your own `erlinit.config` file to set the required `-m` option:\n\n```bash\n# Mount the configdata and logdata partitions\n-m /dev/mmcblk0p3:/root:ext4::;/dev/mmcblk0p4:/mnt/log:ext4::\n```\n\nThe other option is to handle it in your Elixir code. This can be useful if you\nwant to scan the disk for corruption and reformat or seed it. `erlinit` can only\nattempt to mount the partition. You may want to see [how `nerves_runtime` does\nthis for the default application data\npartition](https://github.com/nerves-project/nerves_runtime/blob/main/lib/nerves_runtime/init.ex),\nextending it to meet your specific needs.\n\n#","ref":"advanced-configuration.html#mounting-the-partition"},{"type":"extras","title":"Overriding erlinit.config from Mix Config - Advanced Configuration","doc":"Options specified in the `erlinit.config` file can be overridden through the\nproject's Mix config. This can be helpful when you want to alter a couple\noptions without having to maintain a copy of the entire `erlinit.config`\nfrom the system. Here is an example of how you can change the `ctty` option\nfrom the `config/target.exs` file.\n\n```elixir\nconfig :nerves, :erlinit,\n  ctty: \"ttyAMA0\"\n```\n\nOptions that can only be specified once will overwrite the values specified in\nthe `erlinit.config` provided by the system. Options that can be specified\nmultiple times, such as `mount` and `env` will append to the original ones.\nIf an `erlinit.config` file is provided in the project's `rootfs_overlay` it\nwill override everything else.\n\nThe following is a list of all options that can be specified:\n\n```elixir\n[\n  boot: Path.t(),\n  ctty: String.t(),\n  uniqueid_exec: String.t(),\n  env: String.t(),\n  gid: non_neg_integer(),\n  graceful_shutdown_timeout: non_neg_integer(),\n  hang_on_exit: boolean(),\n  hang_on_fatal: boolean(),\n  mount: String.t(),\n  hostname_pattern: String.t(),\n  pre_run_exec: String.t(),\n  poweroff_on_exit: boolean(),\n  poweroff_on_fatal: boolean(),\n  reboot_on_fatal: boolean(),\n  release_path: String.t(),\n  run_on_exit: String.t(),\n  alternate_exec: binary(),\n  print_timing: boolean(),\n  uid: non_neg_integer(),\n  update_clock: boolean(),\n  verbose: boolean(),\n  warn_unused_tty: boolean(),\n  working_directory: Path.t(),\n  shutdown_report: Path.t()\n]\n```\n\nSee [erlinit](https://github.com/nerves-project/erlinit) for more information.","ref":"advanced-configuration.html#overriding-erlinit-config-from-mix-config"},{"type":"extras","title":"Kernel Parameters - Advanced Configuration","doc":"The `sysctl` command is used to modify kernel parameters at runtime. Nerves\nautomatically loads settings from `/etc/sysctl.conf` at startup when using\n`nerves_runtime` `v0.11.5` or later. The format and content of\n`/etc/sysctl.conf` follows that found in other Linux-based systems.\n\nDefault settings may be provided in your Nerves system. If a Nerves system uses\na recent enough version of\n[`nerves_sytem_br`](https://github.com/nerves-project/nerves_system_br), it will\nhave a minimal `/etc/sysctl.conf` file.\n\nYou can modify the kernel parameters for your application or custom Nerves\nsystem by copying the default `sysctl.conf` file to your `rootfs_overlay/etc`\ndirectory and making the desired changes. Use `System.cmd/3` to run `sysctl` to\nchange settings after initialization.\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"advanced-configuration.html#kernel-parameters"},{"type":"extras","title":"Updating Projects","doc":"# Updating Projects\n\nPlease review this guide before updating your projects. Help is available via\nthe #nerves channel on the elixir-lang slack and the Elixir forum. Please file\nbugs on GitHub.\n\nContents:\n\n* [Updating from v0.8 to v0.9](#updating-from-v0-8-to-v0-9)\n* [Updating from v0.9 to v1.0.0-rc.0](#updating-from-v0-9-to-v1-0-0-rc-0)\n* [Updating from v1.0.0-rc.0 to v1.0.0-rc.2](#updating-from-v1-0-0-rc-0-to-v1-0-0-rc-2)\n* [Updating from v1.0 to v1.3](#updating-from-v1-0-to-v1-3)\n* [Updating from v1.3 to v1.4](#updating-from-v1-3-to-v1-4)\n* [Updating from v1.4 to v1.5](#updating-from-v1-4-to-v1-5)\n* [Updating from v1.5 to v1.6](#updating-from-v1-5-to-v1-6)\n* [Updating from v1.6 to v1.7](#updating-from-v1-6-to-v1-7)","ref":"updating-projects.html"},{"type":"extras","title":"Updating from v0.8 to v0.9 - Updating Projects","doc":"Nerves v0.9.0 contains changes that require updates to existing projects. All\nusers are highly encouraged to update, but if you cannot, be sure to force the\nNerves version in your `mix.exs` dependencies.\n\n#","ref":"updating-projects.html#updating-from-v0-8-to-v0-9"},{"type":"extras","title":"Update Nerves Bootstrap to v0.8.1 - Updating Projects","doc":"Nerves Bootstrap is an Elixir archive that provides a new project generator and\nsome logic required for the Nerves integration into `mix`. Nerves v0.9 requires\nupdates to this archive.\n\nInstall the latest Nerves Bootstrap archive by running:\n\n```bash\nmix local.nerves\n```\n\nor\n\n```bash\nmix archive.install hex nerves_bootstrap\n```\n\n#","ref":"updating-projects.html#update-nerves-bootstrap-to-v0-8-1"},{"type":"extras","title":"Update mix.exs aliases (old) - Updating Projects","doc":"IMPORTANT: If you're upgrading to Nerves v1.0, this step has been superseded.\n\nNerves requires that you add aliases to your project's `mix.exs` to pull in the\nfirmware creation and compilation logic. Previously, you needed to know\nwhich aliases to override. Nerves v0.9 added a new alias. Rather than add this\nalias, we recommend using the new alias helper in your `mix.exs`. To do this,\nedit the target aliases function to look like this:\n\n```elixir\ndefp aliases(_target) do\n  [\n    # Add custom mix aliases here\n  ]\n  |> Nerves.Bootstrap.add_aliases()\nend\n```\n\nThis only works with `nerves_bootstrap` v0.7.0 and later, so if you get an\nerror, be sure to update your Nerves Bootstrap as described in the previous\nsection.\n\nFor those interested in more details, the reason behind this change was to move\nprecompiled artifact downloads from the `mix compile` step to the `mix deps.get`\nstep. That entailed adding additional logic to the `deps.get` step and hence an\nadditional alias.\n\n#","ref":"updating-projects.html#update-mix-exs-aliases-old"},{"type":"extras","title":"Replace Bootloader with Shoehorn - Updating Projects","doc":"During this release, we renamed one of our dependencies from `bootloader` to\n`shoehorn` to prevent overloading the term bootloader in the embedded space.\nThis requires a few updates:\n\nFirst, update the dependency by changing:\n\n```elixir\n{:bootloader, \"~> 0.1\"}\n```\n\nto\n\n```elixir\n{:shoehorn, \"~> 0.2\"}\n```\n\nNext, update the distillery release config in `rel/config.exs`. Look for the\nline near the end that looks like:\n\n```elixir\nplugin Bootloader.Plugin\n```\n\nor\n\n```elixir\nplugin Bootloader\n```\n\nand change it to\n\n```elixir\nplugin Shoehorn\n```\n\nFinally, change references to `bootloader` in your `config/config.exs` to\n`shoehorn`. For example, change:\n\n```elixir\nconfig :bootloader,\n  init: [:nerves_runtime],\n  app: :my_app\n```\n\nto\n\n```elixir\nconfig :shoehorn,\n  init: [:nerves_runtime],\n  app: :my_app\n```\n\n#","ref":"updating-projects.html#replace-bootloader-with-shoehorn"},{"type":"extras","title":"Artifact checksums - Updating Projects","doc":"Some Nerves dependencies reference a large precompiled version of their build\nproducts to significantly reduce compilation time. These are called artifacts\nand due to their size, they cannot be hosted on hex.pm. Nerves downloads these\nautomatically as part of the dependency resolution process. It is critical that\nthey match the corresponding source code and the previous method of checking\nversion numbers was insufficient. Nerves v0.9.0 now uses a checksum of the\nprojects source files. This works for all projects no matter what version\ncontrol system they use or how they are stored.\n\nIf you have created a custom Nerves system or toolchain, you will need to update\nyour project's `mix.exs` to ensure that the checksum covers the right files.\nThis is done using the `:checksum` key on the `nerves_package`. Since the files\nthat you checksum are likely identical to those published on hex.pm, we\nrecommend creating a `package_files/0` function that's used by both.\n\nHere's an example from `nerves-project/nerves_system_rpi0`:\n\n```elixir\n  def nerves_package do\n    [\n      # ... Other Options\n      checksum: package_files()\n    ]\n  end\n\n  defp package do\n    [\n      files: package_files(),\n      licenses: [\"Apache 2.0\"],\n      links: %{\"Github\" => \"https://github.com/nerves-project/#{@app}\"}\n    ]\n  end\n\n  defp package_files do\n    [\n      \"LICENSE\",\n      \"mix.exs\",\n      \"nerves_defconfig\",\n      \"README.md\",\n      \"VERSION\",\n      \"rootfs_overlay\",\n      \"fwup.conf\",\n      \"fwup-revert.conf\",\n      \"post-createfs.sh\",\n      \"post-build.sh\",\n      \"cmdline.txt\",\n      \"linux-4.4.defconfig\",\n      \"config.txt\"\n    ]\n  end\n```\n\n#","ref":"updating-projects.html#artifact-checksums"},{"type":"extras","title":"Easier artifact creation - Updating Projects","doc":"Prior to Nerves v0.9.0, creating artifacts for Nerves systems and toolchains\nrequired manual steps. Nerves v0.9.0 adds the `nerves.artifact` mix task to make\nthis easier. Please update your CI scripts or build instructions to use this new\nmethod.\n\nNerves makes it easier to predigest artifacts for systems and toolchains\nwith the added mix task `mix nerves.artifact  `. Omitting ` `\nwill default to the app name of the parent mix project. This is useful if\nyou are calling `mix nerves.artifact` from within a custom system or toolchain\nproject.\n\nFor example, lets say we have a custom `rpi0` system and we would like to\ncreate an artifact. `mix nerves.artifact custom_system_rpi0`\n\nThis will produce a file in the current working directory with a name of the format\n` - - -  `\n\nFor example,\n`custom_system_rpi0-portable-0.11.0-17C58821DE265AC241F28A0A722DB25C447A7B5FFF5648E4D0B99EF72EB3341F.tar.gz`\n\n#","ref":"updating-projects.html#easier-artifact-creation"},{"type":"extras","title":"Artifact sites - Updating Projects","doc":"Once you've created the artifact (or had CI create it for you),\nyou can then upload this to Github releases and instruct the artifact resolver\nto fetch this artifact following `deps.get`. Update the Nerves package config\nby editing the `:nerves_package` options of `Mix.project/0` for your custom\nsystem or toolchain to set the sites for which the artifact is available on.\n\nThis can be passed as\n`{:github_releases, \" / \"}`\nor specified as url / path prefixes\n`{:prefix, \"/path/to/artifact_dir\"}`\n`{:prefix, http://artifact_server.com/artifacts}`\n\n```elixir\ndef nerves_package do\n  [\n    # ... Other Options\n    artifact_sites: [\n      {:github_releases, \"nerves-project/custom_system_rpi0\"}\n    ]\n  ]\nend\n```\n\nThe artifact resolver will attempt to fetch from each site listed until it\nsuccessfully retrieves an artifact or it reaches the end of the list.","ref":"updating-projects.html#artifact-sites"},{"type":"extras","title":"Updating from v0.9 to v1.0.0-rc.0 - Updating Projects","doc":"#","ref":"updating-projects.html#updating-from-v0-9-to-v1-0-0-rc-0"},{"type":"extras","title":"Update to Nerves Bootstrap v1.0.0-rc.0 - Updating Projects","doc":"Nerves Bootstrap is an Elixir archive that provides a new project generator and\nsome logic required for the Nerves integration into `mix`. Nerves v1.0-rc\nrequires updates to this archive.\n\nInstall the latest Nerves Bootstrap archive by running:\n\n```bash\nmix local.nerves\n```\n\nor\n\n```bash\nmix archive.install hex nerves_bootstrap\n```\n\n#","ref":"updating-projects.html#update-to-nerves-bootstrap-v1-0-0-rc-0"},{"type":"extras","title":"Update project dependencies - Updating Projects","doc":"You will need to update the version string for `nerves` and `nerves_bootstrap`\nin your projects to enable the usage of `1.0-rc`. Open your `mix.exs` file and\nstart by updating the `nerves_bootstrap` archive:\n\n```elixir\n  # mix.exs\n\n  def project do\n    [\n      # ...\n      archives: [{:nerves_bootstrap, \"~> 1.0-rc\"}],\n    ]\n  end\n  ```\n\nThen update the nerves dep:\n\n```elixir\n\n  # Run \"mix help deps\" to learn about dependencies.\n  defp deps do\n    [{:nerves, \"~> 1.0-rc\", runtime: false}] ++ deps(@target)\n  end\n\n```\n\nYou may have to set `override: true` if you are using other Nerves packages that\nhave not been updated to depend on Nerves 1.0-rc yet\n\nIf you wish to revert, you lock to a specific version using `~> 0.8.0` or `= 0.8.0`\n\n#","ref":"updating-projects.html#update-project-dependencies"},{"type":"extras","title":"Update mix.exs aliases - Updating Projects","doc":"`nerves_bootstrap` 1.0-rc manages its own aliases on `Application.start/1` and\nis invoked by setting `MIX_TARGET` to value other then `host`. Update your\n`mix.exs` file to add the `bootstrap/1` function and change the aliases to\n`[loadconfig: [&bootstrap/1]]`:\n\n```elixir\n\n  # mix.exs\n\n  def project do\n    [\n      # ...\n      aliases: [loadconfig: [&bootstrap/1]],\n    ]\n  end\n\n  # Starting nerves_bootstrap pulls in the Nerves hooks to mix, but only\n  # if the MIX_TARGET environment variable is set.\n  defp bootstrap(args) do\n    Application.start(:nerves_bootstrap)\n    Mix.Task.run(\"loadconfig\", args)\n  end\n\n```","ref":"updating-projects.html#update-mix-exs-aliases"},{"type":"extras","title":"Updating from v1.0.0-rc.0 to v1.0.0-rc.2 - Updating Projects","doc":"#","ref":"updating-projects.html#updating-from-v1-0-0-rc-0-to-v1-0-0-rc-2"},{"type":"extras","title":"Updating Provider to BuildRunner - Updating Projects","doc":"**This only applies to custom systems and host tools**\n\nNerves v1.0.0-rc.2 renames the module `Nerves.Artifact.Provider` to\n`Nerves.Artifact.BuildRunner`.\n\nThe `nerves_package` config allowed the package to override\n`provider` and `provider_opts`. These keys have been renamed to\n`build_runner` and `build_runner_opts`\n\nFor example:\n\n```elixir\n  def nerves_package do\n    [\n      # ..\n      build_runner: Nerves.Artifact.BuildRunner.Docker,\n      # ..\n    ]\n  end\n```","ref":"updating-projects.html#updating-provider-to-buildrunner"},{"type":"extras","title":"Updating from v1.0 to v1.3 - Updating Projects","doc":"#","ref":"updating-projects.html#updating-from-v1-0-to-v1-3"},{"type":"extras","title":"Modify the release config - Updating Projects","doc":"Nerves now runs as a distillery plugin instead of inside the `rel/config.exs`.\n\nYou will need to change your `rel/config.exs`. Find the section near the bottom\nof the file that defines your application.\n\nChange this:\n\n```elixir\nrelease :my_app do\n  set version: current_version(:my_app)\n  plugin Shoehorn\n  if System.get_env(\"NERVES_SYSTEM\") do\n    set dev_mode: false\n    set include_src: false\n    set include_erts: System.get_env(\"ERL_LIB_DIR\")\n    set include_system_libs: System.get_env(\"ERL_SYSTEM_LIB_DIR\")\n    set vm_args: \"rel/vm.args\"\n  end\nend\n```\n\nTo this:\n\n```elixir\nrelease :my_app do\n  set version: current_version(:my_app)\n  plugin Shoehorn\n  plugin Nerves\nend\n```\n\n#","ref":"updating-projects.html#modify-the-release-config"},{"type":"extras","title":"Update shoehorn dependency - Updating Projects","doc":"You will need to update your version of shoehorn to `{:shoehorn, \"~> 0.4\"}`.","ref":"updating-projects.html#update-shoehorn-dependency"},{"type":"extras","title":"Updating from v1.3 to v1.4 - Updating Projects","doc":"Version v1.4.0 adds support for Elixir 1.8's new built-in support for mix\ntargets. In Nerves, the `MIX_TARGET` was used to select the appropriate set of\ndependencies for a device. This lets you switch between building for different\nboards and your host. Elixir 1.8 pulls this support into `mix` and lets you\nannotate dependencies for which targets they should be used.\n\n#","ref":"updating-projects.html#updating-from-v1-3-to-v1-4"},{"type":"extras","title":"Update your mix.exs file - Updating Projects","doc":"The `@target` is no longer used. Delete it and then add `@all_targets` like this:\n\n```elixir\n@target System.get_env(\"MIX_TARGET\") || \"host\"\n```\n\n```elixir\n@all_targets [:rpi0, :rpi3, :rpi]\n```\n\nThe `@all_targets` alias will be convenient when updating the dependencies in\nyour `mix.exs`. Set it to the target names that you use (in atom form). Like the\nprevious use of `MIX_TARGET`, it didn't matter what you called the targets. It\nonly mattered that you were consistent.\n\nThe `:host` target refers to compilation for your computer. It's the only\nspecial target and is used for running non-hardware-specific unit tests.\n\nNext, remove the following lines from the `project/0` callback (yay Elixir 1.8):\n\n```elixir\n  target: @target\n  deps_path: \"deps/#{@target}\"\n  build_path: \"_build/#{@target}\"\n  lockfile: \"mix.lock.#{@target}\"\n```\n\nChange `build_embedded` from\n\n```elixir\nbuild_embedded: @target != \"host\"\n```\n\nto\n\n```elixir\nbuild_embedded: Mix.target() != :host,\n```\n\nThe next step is to consolidate your dependencies to one `deps/0` function.\nNerves previously grouped dependencies and used pattern matches to pick the\nright ones for your device. Elixir 1.8 makes this unnecessary.\n\nNow Elixir can fetch and lock your dependencies for all targets. Previously, if\nyou'd switch targets, your dependencies might change versions. No more!\n\nElixir 1.8 adds the `:targets` option on dependencies. Here's an example:\n\nBefore:\n\n```elixir\n  # Run \"mix help deps\" to learn about dependencies.\n  # Dependencies for all targets\n  defp deps do\n    [\n      {:nerves, \"~> 1.3\", runtime: false},\n      {:shoehorn, \"~> 0.4\"},\n      {:ring_logger, \"~> 0.6\"},\n      {:toolshed, \"~> 0.2\"}\n    ] ++ deps(@target)\n  end\n\n  # Specify target specific dependencies\n  defp deps(\"host\"), do: []\n\n  # Dependencies for all targets except :host\n  defp deps(target) do\n    [\n      {:nerves_runtime, \"~> 0.6\"},\n      {:nerves_init_gadget, \"~> 0.4\"}\n    ] ++ system(target)\n  end\n\n  # Dependencies for specific targets\n  defp system(\"rpi\"), do: [{:nerves_system_rpi, \"~> 1.5\", runtime: false}]\n  defp system(\"rpi0\"), do: [{:nerves_system_rpi0, \"~> 1.5\", runtime: false}]\n  defp system(\"rpi2\"), do: [{:nerves_system_rpi2, \"~> 1.5\", runtime: false}]\n  defp system(\"rpi3\"), do: [{:nerves_system_rpi3, \"~> 1.5\", runtime: false}]\n  defp system(\"bbb\"), do: [{:nerves_system_bbb, \"~> 2.0\", runtime: false}]\n  defp system(\"x86_64\"), do: [{:nerves_system_x86_64, \"~> 1.5\", runtime: false}]\n  defp system(target), do: Mix.raise(\"Unknown MIX_TARGET: #{target}\")\n```\n\nAfter:\n\n```elixir\n  # Run \"mix help deps\" to learn about dependencies.\n  defp deps do\n    [\n      # Dependencies for all targets\n      {:nerves, \"~> 1.4\", runtime: false},\n      {:shoehorn, \"~> 0.4\"},\n      {:ring_logger, \"~> 0.6\"},\n      {:toolshed, \"~> 0.2\"},\n\n      # Dependencies for all targets except :host\n      {:nerves_runtime, \"~> 0.6\", targets: @all_targets},\n\n      # Dependencies for specific targets\n      {:nerves_system_rpi, \"~> 1.5\", runtime: false, targets: :rpi},\n      {:nerves_system_rpi0, \"~> 1.5\", runtime: false, targets: :rpi0},\n      {:nerves_system_rpi2, \"~> 1.5\", runtime: false, targets: :rpi2},\n      {:nerves_system_rpi3, \"~> 1.5\", runtime: false, targets: :rpi3},\n      {:nerves_system_rpi3a, \"~> 1.5\", runtime: false, targets: :rpi3a},\n      {:nerves_system_bbb, \"~> 2.0\", runtime: false, targets: :bbb},\n      {:nerves_system_x86_64, \"~> 1.5\", runtime: false, targets: :x86_64}\n    ]\n  end\n```\n\n#","ref":"updating-projects.html#update-your-mix-exs-file"},{"type":"extras","title":"Update config.exs - Updating Projects","doc":"Accessing the `MIX_TARGET` is done differently now. References in your\n`config.exs` to `Mix.Project.config[:target]` need to be `Mix.target()` now. For\nexample, change this:\n\n```elixir\nimport_config \"#{Mix.Project.config[:target]}.exs\n```\n\nto:\n\n```elixir\nimport_config \"#{Mix.target()}.exs\"\n```\n\n#","ref":"updating-projects.html#update-config-exs"},{"type":"extras","title":"Update application.ex - Updating Projects","doc":"Search your Elixir code for references to `Mix.Project.config()[:target]`. These\nneed to change as well. It's not uncommon to have these in your `application.ex`\nto decide what to start in your main supervision tree. For example, change this:\n\n```elixir\n@target Mix.Project.config()[:target]\n```\n\nto:\n\n```elixir\n@target Mix.target()\n```","ref":"updating-projects.html#update-application-ex"},{"type":"extras","title":"Updating from v1.4 to v1.5 - Updating Projects","doc":"Nerves v1.5 adds support for [Elixir 1.9+\nreleases](https://elixir-lang.org/blog/2019/06/24/elixir-v1-9-0-released/).\nPrevious versions of Nerves only supported\n[Distillery](https://github.com/bitwalker/distillery) for OTP release creation.\nNerves v1.5 still supports Distillery, but it is no longer included by default.\nNerves v1.5 also still supports previous Elixir versions, so there is no need to\nupdate to Elixir 1.9.\n\nThe most important part of the Nerves v1.5 upgrade process is to make sure that\nNerves knows whether you want to use Elixir 1.9 releases or Distillery. Please\nfind the subsections below that correspond to your environment.\n\n#","ref":"updating-projects.html#updating-from-v1-4-to-v1-5"},{"type":"extras","title":"Update nerves_bootstrap - Updating Projects","doc":"Nerves now requires `nerves_bootstrap` 1.5.1 and later. Assuming that you\nalready have it installed, run:\n\n```bash\nmix local.nerves\n```\n\n`nerves_bootstrap` v1.6.0 and later generate Elixir 1.9-based projects. This\nfunctionality does not affect existing projects if you are not updating your\nElixir version. However, if you cannot update Elixir and still want to create\nnew projects, force the `nerves_bootstrap` installation to `~> 1.5.0`:\n\n```bash\nmix archive.install hex nerves_bootstrap \"~> 1.5.0\"\n```\n\n#","ref":"updating-projects.html#update-nerves_bootstrap"},{"type":"extras","title":"Update Elixir < 1.9.0 projects - Updating Projects","doc":"If you're not updating to Elixir 1.9, then Distillery is your only option for\nOTP release creation and must be explicitly specified. The following steps will\nensure that your project has the appropriate updates:\n\nIn your `mix.exs`, add distillery as a dependency of your project:\n\n```elixir\n{:distillery, \"~> 2.1\"}\n```\n\nDistillery 2.1 moved code out of the `Mix.Releases` namespace. This requires a\nchange to your project's `rel/config.exs`. Open `rel/config.exs` and look for\nthe following line:\n\n```elixir\nuse Mix.Releases.Config\n```\n\nChange it to:\n\n```elixir\nuse Distillery.Releases.Config\n```\n\nFinally, check that the `:shoehorn` dependency is `~> 0.6`:\n\n```elixir\n{:shoehorn, \"~> 0.6\"}\n```\n\nRun `mix deps.get` and your project should continue to work.\n\nAt this point, consider updating your Nerves system to the latest to pull in\nLinux, Erlang, and other C library and application updates.\n\n#","ref":"updating-projects.html#update-elixir-1-9-0-projects"},{"type":"extras","title":"Update Elixir ~> 1.9 - Updating Projects","doc":"First verify that you have `nerves_bootstrap` 1.6.0 or later installed:\n\n```bash\n$ mix archive\n* hex-0.20.1\n* nerves_bootstrap-1.6.0\n```\n\nThe following instructions are for updating your project files to use Elixir 1.9\nreleases. If you must use Distillery, see the instructions above for Elixir `<\n1.9.0` projects.\n\n##","ref":"updating-projects.html#update-elixir-1-9"},{"type":"extras","title":"mix.exs updates - Updating Projects","doc":"In your project's `mix.exs`, make the following edits:\n\n1. Move the application name to a module attribute:\n\n    ```elixir\n    @app :my_app\n\n    def project do\n      [\n        app: @app\n        # ...\n      ]\n    end\n    ```\n\n2. Add release config to the project config:\n\n    ```elixir\n\n    def project do\n      [\n        # ...\n        releases: [{@app, release()}]\n      ]\n    end\n\n    def release do\n      [\n        overwrite: true,\n        cookie: \"#{@app}_cookie\",\n        include_erts: &Nerves.Release.erts/0,\n        steps: [&Nerves.Release.init/1, :assemble],\n        strip_beams: Mix.env() == :prod\n      ]\n    end\n    ```\n\n3. Update the nerves and shoehorn dependencies\n\n    ```elixir\n    def deps\n      [\n        {:nerves, \"~> 1.5.0\", runtime: false},\n        {:shoehorn, \"~> 0.6\"},\n        # ...\n      ]\n    end\n    ```\n\n4. Update the required archives:\n\n    ```elixir\n    def project do\n      [\n        # ...\n        archives: [nerves_bootstrap: \"~> 1.6\"],\n      ]\n    end\n    ```\n\n5. Add preferred CLI target to the project config:\n\n    ```elixir\n    def project do\n      [\n        # ...\n        preferred_cli_target: [run: :host, test: :host]\n      ]\n    end\n    ```\n\n##","ref":"updating-projects.html#mix-exs-updates"},{"type":"extras","title":"vm.args updates - Updating Projects","doc":"Next, rename `rel/vm.args` to `rel/vm.args.eex`\n\nThen update the line that sets the cookie to\n\n```elixir\n-setcookie  \n```\n\n##","ref":"updating-projects.html#vm-args-updates"},{"type":"extras","title":"Erase old Distillery files - Updating Projects","doc":"Since Distillery is no longer being used, erase any Distillery configuration\nfiles that are still around. For most Nerves users, run the following:\n\n```bash\nrm rel/config.exs\nrm rel/plugins/.gitignore\n```\n\n##","ref":"updating-projects.html#erase-old-distillery-files"},{"type":"extras","title":"Nerves system update - Updating Projects","doc":"Elixir 1.9+ releases are only compatible with systems that contain [`erlinit ~>\n1.5`](https://github.com/nerves-project/erlinit/releases/tag/v1.5.0).\n\nIf you are using an official Nerves system, then make sure that you are using\none of these versions:\n\n```text\nnerves_system_rpi:    ~> 1.8\nnerves_system_rpi2:   ~> 1.8\nnerves_system_rpi3:   ~> 1.8\nnerves_system_rpi3a:  ~> 1.8\nnerves_system_rpi0:   ~> 1.8\nnerves_system_x86_64: ~> 1.8\nnerves_system_bbb:    ~> 2.3\n```\n\nIf you are using a custom system, you will need to update `nerves_system_br` to\n a version that is >= `1.8.1`.\n\n##","ref":"updating-projects.html#nerves-system-update"},{"type":"extras","title":"config.exs updates - Updating Projects","doc":"Nerves has been improving support for \"host\" builds of firmware projects. This\nmakes it possible to unit test platform-independent code on your build machine.\nTo take advantage of this, it's important to separate out the target-dependent\nsections of the `config.exs`. Here's one way of doing this:\n\n1. Create a new file `config/target.exs`\n\n2. Move configs for applications that are only available on the target to the\n`target.exs` file.\n\n3. Update `config.exs` to import `target.exs` if the target is not `host`.\n\n    ```elixir\n    if Mix.target() != :host do\n      import_config \"target.exs\"\n    end\n    ```","ref":"updating-projects.html#config-exs-updates"},{"type":"extras","title":"Updating from v1.5 to v1.6 - Updating Projects","doc":"Nerves 1.6 adds support for Elixir 1.10. In truth, only the internals of the\nNerves tooling were changed. As a result of this change, we made the decision to\ndrop support for Elixir 1.6 and Erlang 20. If you are still using these older\nversions, you'll need to update to at least Elixir 1.7 and Erlang 21. Then\nupdate to Nerves 1.6.\n\nTo update your projects to use Nerves 1.6, bump the `:nerves` dependency in your\nproject's `mix.exs`:\n\n```elixir\n  defp deps do\n    [\n      ...\n      {:nerves, \"~> 1.6.0\", runtime: false},\n      ...\n    ]\n  end\n```\n\nRun `mix deps.get` and build as normal. You may also need to update your Nerves\nsystem to a newer official build. Many systems have dependency requirements on\nNerves 1.5 that can be updated to Nerves 1.6 without issue. Please review the\nNerves system release notes when you upgrade.","ref":"updating-projects.html#updating-from-v1-5-to-v1-6"},{"type":"extras","title":"Updating from v1.6 to v1.7 - Updating Projects","doc":"The only backwards incompatible change in Nerves 1.7 is to remove Distillery\nsupport. See [Updating from v1.4 to v1.5](#updating-from-v1-4-to-v1-5) for how\nto move to mix releases.\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"updating-projects.html#updating-from-v1-6-to-v1-7"},{"type":"extras","title":"Nerves Internals","doc":"# Nerves Internals\n\nThe nerves bootstrapping process has several steps.  Its goal is to locate\nthe \"system\", compile it, and use the compiled system to setup the cross\ncompile environment.","ref":"internals.html"},{"type":"extras","title":"Call Tree - Nerves Internals","doc":"Below is a brief sketch of the call tree for the bootstrap.  It is intended\nto be a \"10,000 ft\" overview.\n\n#","ref":"internals.html#call-tree"},{"type":"extras","title":"mix firmware - Nerves Internals","doc":"* alias\n  * nerves.precompile\n    * NERVES_PRECOMPILE = 1\n    * Mix.Tasks.Nerves.Env\n      * Mix.Tasks.Deps.Loadpaths.run [\"--no-compile\"]\n      * Mix.Tasks.Deps.Compile.run [\"nerves\", \"--include-children\"]\n      * Nerves.Env.start()\n        * load_packages()\n            * Mix.Project.deps_paths\n              * Package.config_path\n              * Package.load_config\n                * build_runner()\n              * validate_packages()\n    * Mix.Tasks.Deps.Compile Nerves.Env.system.app\n    * Mix.Tasks.Compile.run(--no-deps-check) Only if parent == system_app\n    * NERVES_PRECOMPILE = 0\n    * Mix.Tasks.Nerves.Loadpaths.run()\n      * Mix.task.run(nerves.env) Nerves.Env\n        * Nerves.Env.start() ?? See above\n      * Nerves.Env.bootstrap()\n        * system_path()\n          * Nerves.Env.system()\n            * Nerves.Artifact.dir()\n              * System.get_env(env_var(pkg)) NERVES_SYSTEM\n        * toolchain_path()\n          * Nerves.Env.toolchain()\n            * Nerves.Artifact.dir()\n              * System.get_env(env_var(pkg)) NERVES_TOOLCHAIN\n        * platform.bootstrap(pkg) Nerves.Env.system.platform ||Nerves.Env.system.config[:build_platform]\n          * nerves_env.exs Nerves.System.BR\n  * deps.precompile\n\n#","ref":"internals.html#mix-firmware"},{"type":"extras","title":"nerves_package - Nerves Internals","doc":"* Nerves.Env.start\n  * Nerves.Env.enabled? and Nerves.Artifact.stale?(package)\n    * Nerves.Package.artifact(package, toolchain)\n      * pkg.build_runner.artifact(pkg, toolchain, opts) [Nerves.Artifact.BuildRunners.HTTP, Nerves.Artifact.BuildRunners.Local]\n* firmware","ref":"internals.html#nerves_package"},{"type":"extras","title":"Key Files/Variables - Nerves Internals","doc":"The following are the key parts of the bootstrap.  Note that NERVES_SYSTEM and\nNERVES_TOOLCHAIN can be defined before running `mix firmware` to point to a\ntrusted decompressed system or toolchain. This is useful in situations where\nyou produce a system directly using Buildroot and want to force Nerves to use it.\n\n#","ref":"internals.html#key-files-variables"},{"type":"extras","title":"NERVES_SYSTEM - Nerves Internals","doc":"* Path to the `nerves_system_*` folder\n  * Has to be defined at Nerves.Env.bootstrap() or system blows up\n  * Exists only if the system dependency is being included from a source other than hex.\n    * When a system is being sourced from hex, it will attempt to place the uncompressed artifact in the global path located at ~/.nerves/artifacts or $NERVES_ARTIFACTS_DIR\n\n#","ref":"internals.html#nerves_system"},{"type":"extras","title":"NERVES_TOOLCHAIN - Nerves Internals","doc":"* Path to the toolchain\n  * Has to defined at Nerves.Env.bootstrap() or systems blows up\n\n#","ref":"internals.html#nerves_toolchain"},{"type":"extras","title":"nerves_env.exs - Nerves Internals","doc":"* Sets the cross compile flags\n  * NERVES_SYSTEM and NERVES_TOOLCHAIN must be defined prior\n  * Everything thing run after will try to cross compile\n\n#","ref":"internals.html#nerves_env-exs"},{"type":"extras","title":"nerves_system/.nerves/artifacts/nerves_system_* - Nerves Internals","doc":"* \"package\" directory\n   * Gets fetched from nerves_env.exs artifact_url\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"internals.html#nerves_system-nerves-artifacts-nerves_system_"},{"type":"extras","title":"Customizing Your Own Nerves System","doc":"# Customizing Your Own Nerves System\n\nBefore following this guide, you should probably read about\n[The Anatomy of a Nerves System](https://hexdocs.pm/nerves/systems.html)\n\nFor some applications, the pre-built Nerves Systems won't meet your needs. For\nexample, you may want to include additional Linux packages or run on hardware\nthat isn't in the list of [Nerves-supported\ntargets](https://hexdocs.pm/nerves/targets.html) yet. In order to make the build\nprocess consistent across host platforms, Nerves uses a Docker container behind\nthe scenes to perform the build on non-Linux hosts. This makes it possible for\nthe steps below to apply to whatever host platform you're using for development,\nas long as you have Docker for Mac or Docker for Windows installed on those\nplatforms.","ref":"customizing-systems.html"},{"type":"extras","title":"Getting Setup to Build a System - Customizing Your Own Nerves System","doc":"While you could design a system from scratch, it is easiest to copy and modify\nan existing one, renaming it to distinguish it from the official release. For\nexample, if you're targeting a Raspberry Pi 3 board, do the following:\n\nMake sure not to forget the `-b` flag. Cloning/Forking directly from `main` is\nnot considered stable.\n\n```bash\ngit clone https://github.com/nerves-project/nerves_system_rpi3.git custom_rpi3 -b v1.12.0\n```\n\nThe name of the system directory is up to you, but we will call it `custom_rpi3`\nin this example. It's recommended that you check your custom system into your\nversion control system before making changes. This makes it easier to merge in\nupstream changes from the official systems later. For example, assuming you're\nusing GitHub:\n\n```bash\n# After creating an empty custom_rpi3 repository in your GitHub account\n\ncd custom_rpi3\ngit remote rename origin upstream\ngit remote add origin git@github.com:YourGitHubUserName/custom_rpi3.git\ngit checkout -b main\ngit push origin main\n```\n\nNext, tweak the metadata of your Mix project by updating your `mix.exs` with the following:\n\n* The module name of the mix project at the top of the file\n* the value of `@app` to `custom_rpi3`\n* the value of `@github_organization` to your GitHub user name or organization\n\nSee the [Official Mix.Project](https://hexdocs.pm/mix/Mix.Project.html) document\nfor the structure of this file.\n\n```elixir\n# custom_rpi3/mix.exs\n\n# defmodule NervesSystemRpi3.MixProject do\ndefmodule CustomRpi3.MixProject do\n  #      =^^^^^^^^^^= Rename `NervesSystemRpi3` to `CustomRpi3`\n  use Mix.Project\n\n  # @github_organization \"nerves-project\"\n  @github_organization \"YourGitHubUserOrOrganizationName\"\n  #                    =^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^=\n  #                    Rename `\"nerves-project\"` here to your GitHub user or organization name\n\n  # @app :nerves_system_rpi3\n  @app :custom_rpi3\n  #    =^^^^^^^^^^^= Rename `nerves_system_rpi3` here to `custom_rpi3`\nend\n\n# =^^^= The rest of this file remains the same\n```","ref":"customizing-systems.html#getting-setup-to-build-a-system"},{"type":"extras","title":"Building the System - Customizing Your Own Nerves System","doc":"Now that the custom system directory is prepared, you just need to point to it\nfrom your project's `mix.exs`. In this example, we assume that your\n`custom_rpi3` system directory is in the same directory as your nerves firmware\nproject directory, like so:\n\n```plain\n~/projects\n├── custom_rpi3\n└── your_project\n```\n\nIf you are starting a new project, you can generate it to support just one\ntarget.  We will update `rpi3` to `custom_rpi3` next.\n\n```bash\nmix nerves.new your_project --target rpi3\n```\n\n```elixir\n  #=vvv= Update your_project/mix.exs to accept your new :custom_rpi3 target\n\n  # ...\n  @all_targets [:rpi3, :custom_rpi3]\n  #                    =^^^^^^^^^^=\n\n  defp deps do\n    [\n      # Dependencies for all targets\n      # ...\n\n      # Dependencies for specific targets\n      {:nerves_system_rpi3, \"~> 1.6\", runtime: false, targets: :rpi},\n\n      # Add the entry below vvv\n      {:custom_rpi3,\n       path: \"../custom_rpi3\",\n       runtime: false,\n       targets: :custom_rpi3,\n       nerves: [compile: true]},\n    ]\n  end\n```\n\n> NOTE: Including the `nerves: [compile: true]` option in your dependency will cause the system to be compiled\n> automatically. If you don't want this behavior, remove this option and you will need to manually compile the\n> system via the `mix compile` task before building firmware with it\n\nSet your `MIX_TARGET` to refer to your custom system and build your firmware.\n\n```bash\ncd ~/projects/your_project\nexport MIX_TARGET=custom_rpi3\nmix deps.get\nmix firmware\n```\n\nThis process will take quite a bit longer than a normal firmware build (15 to 30\nminutes) the first time. When it finishes, you will have confirmed that you can\nsuccessfully build an equivalent of the official `rpi3` system. After your\ncustom system has been built, you can modify your application and re-build\nfirmware normally. The custom system will only re-build if you make changes to\nthe system source project itself.","ref":"customizing-systems.html#building-the-system"},{"type":"extras","title":"Buildroot Package Configuration - Customizing Your Own Nerves System","doc":"Because Buildroot can only be used from Linux, Nerves provides an abstraction\nlayer called the Nerves system configuration shell that allows the same\nprocedure to be used on Linux and non-Linux development hosts by using a\nLinux-based Docker container on non-Linux platforms. To access this environment,\nrun the `mix nerves.system.shell` task from the custom system source directory.\n\n```bash\n$ mix deps.get\nMix environment\n MIX_TARGET:   custom_rpi3\n MIX_ENV:      dev\n\nRunning dependency resolution...\nDependency resolution completed:\n#  \n* Getting nerves (Hex package)\n Checking package (https://repo.hex.pm/tarballs/nerves-1.3.0.tar)\n#  \n\n$ mix nerves.system.shell\nMix environment\n MIX_TARGET:   custom_rpi3\n MIX_ENV:      dev\n\n==> nerves\nCompiling 25 files (.ex)\nGenerated nerves app\n\n Preparing Nerves Shell\n\nCreating build directory...\nCleaning up...\nNerves  /nerves/build >\n```\n\nOnce at the `Nerves  /nerves/build >` shell prompt, the workflow for customizing\na Nerves system is the same as when using Buildroot outside of Nerves, using\n`make menuconfig` and `make savedefconfig`. Remember that this is effectively a\nsub-shell on both Linux and non-Linux platforms, so when you're finished\nupdating the configuration and optionally re-building the system \"manually\", you\ncan get back to your normal shell by typing `exit` or pressing `CTRL+D`.\n\nThe main package configuration workflows are divided into three categories,\ndepending on what you want to configure:\n\n1. Select base packages by running `make menuconfig`\n2. Modify the Linux kernel and kernel modules with `make linux-menuconfig`\n3. Enable more command line utilities using `make busybox-menuconfig`\n\n> NOTE: You can build the system \"manually\" using `make` from inside the system\nconfiguration shell if you want to iterate quickly while trying out different\nchanges. When you're ready to try out the system in your project, exit the shell\nand have `mix firmware` take care of the re-build for you from your project\ndirectory. Please be aware that Buildroot does not handle incremental\ncompilation well, so it's recommended that you always run `make clean` before\n`make` unless you're experienced with Buildroot and understand when you can skip\nthe `make clean` step.\n\n> ##","ref":"customizing-systems.html#buildroot-package-configuration"},{"type":"extras","title":"Quick searching menu {: .tip} - Customizing Your Own Nerves System","doc":">\n> Use `/` when in a config menu for quick search. Press the key of the number\n> shown in the results to quickly jump to that option\n> ![quick-search](assets/menu-search-tip.gif)\n\nWhen you quit from the `menuconfig` interface, the changes are stored\ntemporarily. To save them back to your system source directory, follow the\nappropriate steps below:\n\n1. After `make menuconfig`:\n\n    Run `make savedefconfig` to update the `nerves_defconfig` in your System.\n\n2. After `make linux-menuconfig`:\n\n    Once done with configuring the kernel, you can save the Linux config to the\n    default configuration file using `make linux-update-defconfig`. The destination\n    file is `linux-4.9.defconfig` in your project's root (or whatever the kernel\n    version is you're working with).\n\n    > NOTE: If your system doesn't contain a custom Linux configuration yet,\n    you'll need to update the Buildroot configuration (using `make menuconfig`)\n    to point to the new Linux defconfig in your system directory. The path is\n    usually something like `$(NERVES_DEFCONFIG_DIR)/linux-x.y_defconfig`.\n\n3. After `make busybox-menuconfig`:\n\n    Unfortunately, there's not currently an easy way to save a BusyBox defconfig.\n    What you have to do instead is save the full BusyBox config and configure it\n    to be included in your `nerves_defconfig`.\n\n    Assuming you're using the Nerves System Shell via Docker on a non-Linux host\n    and your custom system source directory is called `custom_rpi3`, you'll need\n    to do something like the following (the version identifiers might be\n    different for you).\n\n    ```bash\n    cp build/busybox-1.27.2/.config /nerves/env/custom_rpi3/busybox_defconfig\n    ```\n\n    Like the Linux configuration, the Buildroot configuration will need to be\n    updated to point to the custom config if it isn't already. This can be done\n    via `make menuconfig` and navigating to **Target Packages** and finding the\n    **Additional BusyBox configuration fragment files** option under the\n    **BusyBox** package, which should already be enabled and already have a base\n    configuration specified. If you're following along with this example, the\n    correct configuration value should look like this:\n\n    ```bash\n    ${NERVES_DEFCONFIG_DIR}/busybox_defconfig\n    ```\n\nThe [Buildroot user manual](http://nightly.buildroot.org/manual.html) can be\nvery helpful, especially if you need to add a package. The various Nerves system\nrepositories have examples of many common use cases, so check them out as well.","ref":"customizing-systems.html#quick-searching-menu-tip"},{"type":"extras","title":"Adding a custom Buildroot Package - Customizing Your Own Nerves System","doc":"If you have a non-Elixir program that's too complicated to compile with\n[elixir_make](https://github.com/elixir-lang/elixir_make) and not included in\nBuildroot, you'll need to add instructions for how to build it to your system.\nThis is called a \"custom Buildroot package\" and the process to add one in a\nNerves System is nearly the same as in Buildroot. This is documented in the\n[Adding new package](http://nightly.buildroot.org/manual.html#adding-packages)\nchapter of the Buildroot manual. The main difference with Nerves is the\ndirectory.\n\nAs you go through this process, please consider whether it makes sense to\ncontributor your package upstream to Buildroot.\n\nA Nerves System will need the following files in the root of the custom system\ndirectory:\n\n1. `Config.in` - Includes each package's `Config.in` file\n2. `external.mk` - Includes each package's ` .mk` file\n3. `packages` - Directory containing your custom package directories\n\nEach directory _inside_ the `packages` directory should contain two things:\n\n1. `Config.in` - Defines package information\n2. ` .mk` - Defines how a package is built.\n\nSo if you wanted to build a package `libfoo`, first create the `Config.in` and\n`external.mk` files at the base directory of your system.\n\n`/Config.in`:\n\n```plain\nmenu \"Custom Packages\"\n\nsource \"$NERVES_DEFCONFIG_DIR/packages/libfoo/Config.in\"\n\nendmenu\n```\n\n`/external.mk`:\n\n```make\ninclude $(sort $(wildcard $(NERVES_DEFCONFIG_DIR)/packages/*/*.mk))\n```\n\nThen create the package directory and package files:\n\n```bash\nmkdir -p packages/libfoo\ntouch packages/libfoo/Config.in\ntouch packages/libfoo/libfoo.mk\n```\n\nAt this point, you should follow the Official Buildroot documentation for what\nshould be added to these files. Often the easiest route is to find a similar\npackage in Buildroot and copy/paste the contains with appropriate renaming.","ref":"customizing-systems.html#adding-a-custom-buildroot-package"},{"type":"extras","title":"Creating an Artifact - Customizing Your Own Nerves System","doc":"Building a Nerves system can require a lot of system resources and often takes a\nlong time to complete. Once you are satisfied with the configuration of your\nNerves system and you are ready to make a release, you can create an artifact.\nAn artifact is a pre-compiled version of your Nerves system that can be\nretrieved when calling `mix deps.get`. \n\nThese are typically 100MB± in size which is usually over the size limit of most\npackage manager systems, like https://hex.pm. Because of this, you must store\nyour pre-compiled artifact externally and provide instructions for how to\nretrieve it in the `artifacts_sites` list of the `nerves_pacakge` config.\n\nThere are currently three different artifact site helpers:\n\n* `{:github_releases, \"organization/repo\"}`\n* `{:github_api, \"organization/repo\", username: \"\", token: \"\", tag: \"\"}`\n* `{:prefix, \"url\", opts \\\\ []}`\n\n> ##","ref":"customizing-systems.html#creating-an-artifact"},{"type":"extras","title":"Nerves Package Configuration {: .info} - Customizing Your Own Nerves System","doc":"> See [Nerves Package Configuration](Systems.md#nerves-package-configuration) doc\n> for more info about artifact sites and customizing your Nerves package\n\n`artifact_sites` only declare the path of the location to the artifact. This is\nbecause the name of the artifact is defined by Nerves and used to download the\ncorrect one. The artifact name for a Nerves system follows the structure\n` -portable- - .tar.gz`. The checksum at the end of the\nfile is calculated based off the contents of the files and directories\nspecified in the `checksum` list in the `nerves_package` configuration.  It is\nimportant to note that if you modify contents of any of the `checksum` files or\ndirectories after creating the artifact, the artifact will not match and will\nnot be used. Therefore, you first need to define the `artifact_sites` before\ncreating the artifact.\n\nTo construct an artifact, simply build the project and call `mix nerves.artifact`\nfrom within the directory of your custom Nerves system. For example, if your\nsystem name is `custom_rpi3` and the version is `0.1.0` you will see a file\nsimilar to `custom_rpi3-portable-0.1.0-ABCDEF0.tar.gz` in your current working\ndirectory. This file should be placed in the location specified by the\n`artifact_sites`. If you are using the Github Releases helper, you will need\nto create a release from your tag on Github and then upload the file.\n\nNow, instead of using a `:path` dependency in your main project, you can use a\n`:github` dependency to make it easier to share with others.\n\n```elixir\n# Update the `custom_rpi3` dep in your `deps/0` function.\n{:custom_rpi3, github: \"YourGitHubUserName/custom_rpi3\", runtime: false, targets: :custom_rpi3}\n```\n\nYou can also [publish the system package to hex](https://hex.pm/docs/publish).\nYou should not need to change anything in the `mix.exs` file at this point to\ndo so.\n\n```plain\nmix hex.publish\n```\n\nBack in your main project, update deps:\n\n```elixir\n# make sure you check the version here.\n{:custom_rpi3, \"~> 1.7\", runtime: false, targets: :custom_rpi3}\n```","ref":"customizing-systems.html#nerves-package-configuration-info"},{"type":"extras","title":"Custom System Maintenance - Customizing Your Own Nerves System","doc":"After customizing a Nerves System, creating artifacts, and publishing the\npackage, you will probably want to keep track of the latest updates to the\noriginal system. Assuming you followed the `git` section in the [Getting\nStarted](#getting-setup-to-build-a-system) section, you will have a remote\ncalled `upstream`. Check this by doing:\n\n```plain\n$ git remote -v\norigin git@github.com:YourGitHubUserName/custom_rpi3.git (fetch)\norigin git@github.com:YourGitHubUserName/custom_rpi3.git (push)\nupstream https://github.com/nerves-project/nerves_system_rpi3.git (fetch)\nupstream https://github.com/nerves-project/nerves_system_rpi3.git (push)\n```\n\nWhen you are ready to update your system (for example, after Nerves publishes a\nnew version), you can just merge the `upstream` changes in. For example, if you\nstarted with `nerves_system_rpi3` at `v1.7.1`, when `v1.7.2` gets published,\nyou can do the following to upgrade your custom system:\n\n```bash\ngit fetch --all\ngit merge upstream/main\n# Solve any merge conflicts\ngit push origin main\n```\n\nYou can also use the GitHub interface to do this:\n\n```text\nhttps://github.com/YourGitHubUserName/custom_rpi3/compare/main...nerves-project:main?expand=1\n```\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"customizing-systems.html#custom-system-maintenance"},{"type":"extras","title":"Experimental features","doc":"# Experimental features\n\nThe features described in this document are experimental. They are under\nconsideration and or actively being developed.","ref":"experimental-features.html"},{"type":"extras","title":"Firmware patches - Experimental features","doc":"Firmware update files (`.fw`) contain everything your target needs to boot and\nrun your application. Commonly, this single file package will contain your root\nfilesystem, the Linux kernel, a bootloader, and some extra files and metadata\nspecific to your target. Packaging all these files together provides a convenient\nand reliable means of distributing firmware that can be used to boot new devices\nas well as upgrade existing ones. Unfortunately, this mechanism is not conducive\nto applying updates to devices that use expensive metered network connections\nwhere the cost of every byte counts. This problem can be alleviated with firmware\npatches.\n\nA firmware patch file's content structure is identical to that of a regular\nfirmware update file, it contains your root file system, the Linux kernel, and\nso on. The main difference is that the contents of these files are no longer a\nbit for bit representation but instead the delta between two known versions of\nfirmware. Currently, the system will only apply patches to the root file system,\nbut there are plans to support other files. It is important to note that in order\nto generate a firmware patch file, you will need to supply two full firmware\nupdate files, the firmware that the target is updating from (currently running)\nand the firmware the device will be updating to (the desired new firmware).\nAttempting to apply a firmware patch to a target that is not running the \"from\"\nfirmware will result in returning an error when attempting to apply it.\nGenerating and applying firmware patch files will require that your host machine\nand your target have `fwup` >= 1.6.0 installed.\n\n#","ref":"experimental-features.html#firmware-patches"},{"type":"extras","title":"Preparing your Nerves system - Experimental features","doc":"Firmware update patches will require modifications to the `fwup.conf` of your\nNerves system. These updates must be applied in full to a running target before\nit is capable of applying firmware update patches.\n\nIn your `fwup.conf`, find the references to `rootfs.img`, in typical systems\nthere will be 4 references.\n\n* `file-resource`:\n  Unchanged\n* Inside the `complete` task:\n  Unchanged. When writing a complete firmware on to a new device. A patch\n  cannot be applied on the target.\n* Inside the `upgrade.a` task:\n  When new firmware is written in to firmware slot `a`.\n* Inside the `upgrade.b` task:\n  When new firmware is written in to firmware slot `b`.\n\nWe only need to modify the actions taken in the `upgrade.a` and `upgrade.b` steps.\n\nChange the reference in the `upgrade.a` task:\n\n```text\non-resource rootfs.img { raw_write(${ROOTFS_A_PART_OFFSET}) }\n```\n\nTo:\n\n```text\non-resource rootfs.img {\n  delta-source-raw-offset=${ROOTFS_B_PART_OFFSET}\n  delta-source-raw-count=${ROOTFS_B_PART_COUNT}\n  raw_write(${ROOTFS_A_PART_OFFSET})\n}\n```\n\nChange the reference in the `upgrade.b` task:\n\n```text\non-resource rootfs.img { raw_write(${ROOTFS_B_PART_OFFSET}) }\n```\n\nTo:\n\n```text\non-resource rootfs.img {\n  delta-source-raw-offset=${ROOTFS_A_PART_OFFSET}\n  delta-source-raw-count=${ROOTFS_A_PART_COUNT}\n  raw_write(${ROOTFS_B_PART_OFFSET})\n}\n```\n\nYou'll also need to ensure that your system is being build using\n`nerves_system_br` >= 1.11.2. This will be in your mix dependencies. If you\nattempt to apply a firmware patch to a device that does not support it, you\nwill receive an error similar to the following:\n\n```sh\nRunning fwup...\nfwup: Upgrading partition B\nfwup: File 'rootfs.img' isn't expected size (7373 vs 49201152) and xdelta3 patch support not enabled on it. (Add delta-source-raw-offset or delta-source-raw-count at least)\n```\n\n#","ref":"experimental-features.html#preparing-your-nerves-system"},{"type":"extras","title":"Preparing your project - Experimental features","doc":"Generating a root filesystem patch requires a bit comparison between two root\nfile systems. We use xdelta3 and provide it the \"from\" and \"to\" SquashFS files.\nSquashFS will compress the root filesystem structure and data by default. The\nresulting patch file size is often quite higher compared to the expected source\nmodification size due to the bit for bit comparison being inefficient when\ncomparing compressed data. SquashFS can be configured to disable compression,\nallowing us to create more efficient patches. Disabling SquashFS compression\nallows us to create more effective patches. Add the following `mksquashfs_flags`\nto your project's mix config.\n\n```elixir\n# Customize non-Elixir parts of the firmware. See\n# https://hexdocs.pm/nerves/advanced-configuration.html for details.\n\nconfig :nerves, :firmware,\n  rootfs_overlay: \"rootfs_overlay\",\n  mksquashfs_flags: [\"-noI\", \"-noId\", \"-noD\", \"-noF\", \"-noX\"]\n```\n\nPatch sizes can also be optimized by configuring the build system's\n`source_date_epoch` date. This will help with reproducible builds by preventing\ntimestamps modifications from affecting the output bit representation.\n\n```elixir\n# Set the SOURCE_DATE_EPOCH date for reproducible builds.\n# See https://reproducible-builds.org/docs/source-date-epoch/ for more information\n\nconfig :nerves, source_date_epoch: \"1596027629\"\n```\n\n#","ref":"experimental-features.html#preparing-your-project"},{"type":"extras","title":"Testing firmware patches locally - Experimental features","doc":"Create a new project using `mix nerves.new  ` and apply the steps\nlisted in the `Preparing your project` section. Then, choose a target, in this\nexample, I will be using a Raspberry Pi Zero W `rpi0` and building an app\ncalled `test_patch`.\n\n```sh\nexport MIX_TARGET=rpi0\nmix deps.get\n```\n\nCreate your initial firmware and burn it to an SD card\n\n```sh\nmix firmware.burn\n```\n\nConnect the SD card and power on the device by connecting a micro USB cable to\nthe host USB port on the Raspberry Pi. You can ssh into the device at\n`nerves.local` and you should get an IEX prompt.\n\n```sh\nssh nerves.local\n\nInteractive Elixir (1.10.4) - press Ctrl+C to exit (type h() ENTER for help)\nToolshed imported. Run h(Toolshed) for more info.\nRingLogger is collecting log messages from Elixir and Linux. To see the\nmessages, either attach the current IEx session to the logger:\n\n  RingLogger.attach\n\nor print the next messages in the log:\n\n  RingLogger.next\n\niex(1)> TestPatch.hello\n:world\n```\n\nMake some changes to the function. Open `lib/ .ex` and modify the\n`hello/0` function.\n\n```elixir\ndef hello do\n  :patched\nend\n```\n\nNow lets generate a patch firmware.\n\n`mix firmware.patch`\n\nYou should see output similar to the following:\n\n```text\nFinished generating patch firmware\n\nSource\ntest_patch/_build/rpi0_dev/nerves/images/test_patch.fw\nuuid: 6cf7f75f-eb93-5a91-e28c-fd414602b6e7\"\n\nsize: 22079567 bytes\n\nTarget\nnerves-project/tests/test_patch/_build/rpi0_dev/nerves/images/patch/target.fw\nuuid: 69752f24-291f-5f00-4ad3-ca359017009f\"\n\nsize: 22077072 bytes\n\nPatch\ntest_patch/_build/rpi0_dev/nerves/images/patch.fw\nsize: 4425660 bytes\n```\n\nLets update the device using the patch file.\n\n```sh\nmix upload --firmware /path/to/test_patch/_build/rpi0_dev/nerves/images/patch.fw\n```\n\nThe size difference between the `Target` output firmware size `22077072` and the\npatched firmware size `4425660` has a pretty significant size reduction. For\nsuch a small change, we might expect more. A lot of this size come from the\nfiles that are also included in the firmware that are not currently being patched\nsuch as the Linux kernel and other files that do not change frequently.\nWe anticipate that all other files will offer similar support, but we started\nwith the first most impactful file, the SquashFS root filesystem, so we can begin\ntesting this workflow using devices.","ref":"experimental-features.html#testing-firmware-patches-locally"},{"type":"extras","title":"Nerves package environment variables - Experimental features","doc":"Packages can provide custom system environment variables to be exported when\n`Nerves.Env.bootstrap/0` is called. The initial use case for this feature is to\nexport system specific information for llvm-based tools. Here is an example from\n`nerves_system_rpi0`\n\n```elixir\n  defp nerves_package do\n    [\n      # ...\n      env: [\n        {\"TARGET_ARCH\", \"arm\"},\n        {\"TARGET_CPU\", \"arm1176jzf_s\"},\n        {\"TARGET_OS\", \"linux\"},\n        {\"TARGET_ABI\", \"gnueabi\"}\n      ]\n      # ...\n    ]\n  end\n```\n\n \nIs something wrong?\n \nEdit this page on GitHub","ref":"experimental-features.html#nerves-package-environment-variables"},{"type":"extras","title":"Using the CLI","doc":"# Using the CLI\n\nCommand line documentation is now at [IEx with Nerves Page](https://hexdocs.pm/nerves/iex-with-nerves.html).","ref":"using-the-cli.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v1.10.3 - 2023-07-07 - Changelog","doc":"* Improvements\n  * Support Elixir 1.15 / OTP 26\n  * Fix misleading `%IO.Stream{}` error when building firmware\n  * Add validations for `vm.args.eex` during firmware build","ref":"changelog.html#v1-10-3-2023-07-07"},{"type":"extras","title":"v1.10.2 - 2023-04-11 - Changelog","doc":"* Improvements\n  * Change `BuildRunners.Docker` to use GitHub Container Registry by default","ref":"changelog.html#v1-10-2-2023-04-11"},{"type":"extras","title":"v1.10.1 - 2023-03-08 - Changelog","doc":"* Improvements\n  * Use `GitHubAPI` for public release artifacts for helpful reports on error\n  * Allow `castore: v1.0` to be used","ref":"changelog.html#v1-10-1-2023-03-08"},{"type":"extras","title":"v1.10.0 - 2023-03-03 - Changelog","doc":"This release removes the ability to specify an alternative JSON codec with\n`:json_codec` config option and defaults to using `Jason`. If set, everything\nwill function as normal but you will see a compiler warning.\n\n* Bug fix\n  * Prevent accidentally installing `:nerves` as an archive\n  * Add default mksquashfs flags when none specified","ref":"changelog.html#v1-10-0-2023-03-03"},{"type":"extras","title":"v1.9.3 - 2023-02-11 - Changelog","doc":"* Bug fix\n  * Temporarily revert GitHub release update in v1.9.2. It produces an error on\n    new projects when downloading artifacts. It's easily fixed by adding a\n    `jason`, but a better fix will be coming.","ref":"changelog.html#v1-9-3-2023-02-11"},{"type":"extras","title":"v1.9.2 - 2023-02-05 - Changelog","doc":"* Improvements\n  * `:github_api` artifact site resolver was completely refactored\n    * More contextual error messages\n    * `GITHUB_TOKEN` and `GH_TOKEN` environment variables supported (They were\n      previously ignored despite the error message suggesting them to be used)\n    * `:user` option no longer required, but still supported (effectively ignored\n      by GitHub if the token is supplied)\n  * `:github_release` switched to use the same GitHub resolver as `:github_api`\n    in order to have the same benefits\n  * Remove duplicate artifact request with 64 byte checksum name\n\n* Bug Fix\n  * `mix firmware` now places temporary build products in `MIX_BUILD_PATH` which\n    prevents them from being stored in `_build/` root and compiling different\n    targets in different terminals. See #576\n  * Check if supplied rootfs_overlays have incompatible directories. See\n    [nerves-project/nerves_system_br#495](https://github.com/nerves-project/nerves_system_br/issues/495).","ref":"changelog.html#v1-9-2-2023-02-05"},{"type":"extras","title":"v1.9.1 - 2022-09-11 - Changelog","doc":"This is a patch release that fixes trivial tooling issues found when using\nElixir 1.14 and Erlang 25.0.4. It's expected to be a safe update from v1.9.0.","ref":"changelog.html#v1-9-1-2022-09-11"},{"type":"extras","title":"v1.9.0 - 2022-08-23 - Changelog","doc":"This release removes warnings when using Elixir 1.14 rc releases since they\nappear to work fine.\n\n* Improvements\n  * Added `mix nerves.artifact.details` to list information in Nerves system and\n    toolchain projects. Thanks to @udoschneider for this feature.\n  * Many documentation updates including version charts for Nerves systems.\n    Thanks to @mnishiguchi.","ref":"changelog.html#v1-9-0-2022-08-23"},{"type":"extras","title":"v1.8.0 - 2022-05-11 - Changelog","doc":"This release requires Elixir 1.11.2 or later. It has no new features. This is\nthe first batch of updates to improve our ability to maintain Nerves tooling\nlong term now that we can remove old features and workaround.\n\n* Bug fix\n  * Fix missing space in `CFLAGS` and `CXXFLAGS`. It would sometimes cause\n    compiler warnings.","ref":"changelog.html#v1-8-0-2022-05-11"},{"type":"extras","title":"v1.7.16 - Changelog","doc":"* Bug fix\n  * Fix Erlang compiler check so that Erlang/OTP 24.3 does not trigger an error\n    when building projects.","ref":"changelog.html#v1-7-16"},{"type":"extras","title":"v1.7.15 - Changelog","doc":"* Bug fix\n  * Fix `TARGET_GCC_FLAGS` issue that inadvertently removed `CFLAGS` options on\n    Nerves systems that used it.","ref":"changelog.html#v1-7-15"},{"type":"extras","title":"v1.7.14 - Changelog","doc":"* Improvements\n  * Unset environment variables set by Erlang that can confuse some C/C++\n    libraries when building.\n  * Add experimental support for `TARGET_GCC_FLAGS` for enabling CPU-specific\n    features in NIFs and ports via Nerves package definitions. This is similar\n    in intent to `TARGET_CPU`, etc.","ref":"changelog.html#v1-7-14"},{"type":"extras","title":"v1.7.13 - Changelog","doc":"* Improvements\n  * Verify the remote website when downloading artifacts. This fixes the warning\n    about unverified HTTPS connections.\n  * Fix error message printout when Nerves toolchain builds fail","ref":"changelog.html#v1-7-13"},{"type":"extras","title":"v1.7.12 - Changelog","doc":"* Improvements\n  * Allow Elixir 1.13.0-rc.0 to be used to build projects. It looks like it\n    works fine and doesn't cause issues with Nerves.\n  * Add message after the build completes to let you know what to do next.","ref":"changelog.html#v1-7-12"},{"type":"extras","title":"v1.7.11 - Changelog","doc":"* Bug fixes\n  * Don't set xattrs when running `mix firmware.unpack`. This fixes filesystem\n    permission errors during extraction for some users.","ref":"changelog.html#v1-7-11"},{"type":"extras","title":"v1.7.10 - Changelog","doc":"* Improvements\n  * Update `mix firmware.unpack` to be more flexible with input firmware and\n    output directories. If you're using `mix firmware.unpack` in a script, you\n    may need to update the script.\n  * Reduce C compiler build prints","ref":"changelog.html#v1-7-10"},{"type":"extras","title":"v1.7.9 - Changelog","doc":"* Improvements\n  * Add helper script generator for using gdb to analyze core dumps. Nerves\n    systems ship with debug symbols (target images have these stripped) that can\n    be used to get stack traces and more from core dumps from the Erlang VM and\n    other C/C++ programs. See the [Debugging C in Nerves blog\n    post](https://embedded-elixir.com/post/2021-07-03-debugging-c/) for an example.\n  * Support the new `:limits` option in erlinit so that it's possible to set the\n    core dump limits (i.e., enable core dumps) before Erlang starts.","ref":"changelog.html#v1-7-9"},{"type":"extras","title":"v1.7.8 - Changelog","doc":"* Bug fixes\n  * Fix toolchain downloads when using Erlang/OTP 24 on Apple M1 macs.","ref":"changelog.html#v1-7-8"},{"type":"extras","title":"v1.7.7 - Changelog","doc":"* Bug fixes\n  * Fix compiler version check error when using Erlang/OTP 24","ref":"changelog.html#v1-7-7"},{"type":"extras","title":"v1.7.6 - Changelog","doc":"* Enhancements\n  * Update supported Elixir version to include 1.12","ref":"changelog.html#v1-7-6"},{"type":"extras","title":"v1.7.5 - Changelog","doc":"* Bug fixes\n  * Fixes an issue where query parameters would be percent-encoded twice.\n    Packages that use `query_params` argument option to `artifact_sites` could\n    be impacted. For example, packages storing build artifacts in AWS S3\n    require the `X-Amz-Credential` query parameter key whose value\n    includes the reserved character `/`. This symbol is double encoded to\n    `%252F`. This failed on systems with Erlang OTP-23.2 and above.\n    See https://github.com/nerves-project/nerves/issues/604 for additional context.","ref":"changelog.html#v1-7-5"},{"type":"extras","title":"v1.7.4 - Changelog","doc":"* Experimental features\n  * Packages can provide custom system environment variables to be exported.\n    The initial use case for this feature is to export system specific\n    information for llvm-based tools.","ref":"changelog.html#v1-7-4"},{"type":"extras","title":"v1.7.3 - Changelog","doc":"* Bug fixes\n  * Fixes a hang when downloading artifacts from GitHub. The hang looked like\n    this and affected artifact downloads from public GitHub repositories:\n\n    ```sh\n    Resolving Nerves artifacts...\n      Resolving nerves_toolchain_xyz\n      => Trying https:...\n    ```","ref":"changelog.html#v1-7-3"},{"type":"extras","title":"v1.7.2 - Changelog","doc":"* Bug fixes\n  * Fix Elixir semver requirements to produce warnings on unsupported versions.\n  * Produce better errors on HTTP timeouts","ref":"changelog.html#v1-7-2"},{"type":"extras","title":"v1.7.1 - Changelog","doc":"* Enhancements\n  * Documentation and docker improvements for Windows Subsystem for Linux 2","ref":"changelog.html#v1-7-1"},{"type":"extras","title":"v1.7.0 - Changelog","doc":"Nerves 1.7.0 removes support for creating OTP releases using Distillery and\nonly supports using Elixir releases. As a result, the minimum supported version\nof Elixir is now version 1.9.\n\nOfficial Nerves systems now support applying firmware using patches. This\ngreatly reduces the amount of data that required to push firmware updates\nto devices. The minimum requirement for fwup has been updated to 1.8\nto enable support for this feature.\n\n* Bug fixes\n  * Pass all unspecified erlinit args to the generator instead of silently\n    ignoring them.\n  * Use host CC when compiling the port.","ref":"changelog.html#v1-7-0"},{"type":"extras","title":"v1.6.5 - Changelog","doc":"* Bug fixes\n  * Fix issues with executing system commands on non mac hosts.","ref":"changelog.html#v1-6-5"},{"type":"extras","title":"v1.6.4 - Changelog","doc":"* Experimental features\n  * Added `mix firmware.patch` to locally create firmware patch files for\n    feature testing. This feature is under development.\n    See the [experimental features](https://github.com/nerves-project/nerves/blob/main/docs/Experimental%20Features.md) doc for more info.\n  * Added `:mksquashfs_flags` to the nerves firmware config to allow passing\n    additional flags to the `mksquashfs` call that produces the final rootfs.\n    If you are experimenting with creating patchable firmware, you should\n    use this feature to disable squashfs compression.\n\n    ```elixir\n    config :nerves, :firmware\n      mksquashfs_flags: [\"-noI\", \"-noD\", \"-noF\", \"-noX\"]\n    ```\n\n* Bug fixes\n  * Replace calls to `System.cmd` with a `Nerves.Port.cmd`. This code was\n    provided by `muontrap` and is used to clean up spawned system processes\n    when the vm exits.\n    This fixes issues with the docker build runner executing multiple times\n    and multiple calls to `mix firmware` after breaking out of the VM before\n    the first call finishes.\n  * Fix issue where SD card detection may fail while calling `mix burn` when`fwup`\n    returns additional fields.\n  * Clean the release directory when calling `mix firmware`. This prevents\n    OTP releases from accumulating unnecessary libraries and OTP applications\n    over time.","ref":"changelog.html#v1-6-4"},{"type":"extras","title":"v1.6.3 - Changelog","doc":"* Bug fixes\n  * Fix required key validation on github_api resolver.","ref":"changelog.html#v1-6-3"},{"type":"extras","title":"v1.6.2 - Changelog","doc":"* Bug fixes\n  * Improve error message returned when calling `mix firmware` when the local\n    system artifact cannot be found and possibly needs to be built.\n\n  * GitHub API artifact resolver will no longer raise if missing required opts.\n\n  The GitHub API artifact resolver is useful when you want to enable access\n  to artifacts added to GitHub releases in private GitHub repositories.\n  Fetching an artifact from a private GitHub repo requires the passing\n  `username, token, tag` as options. If any of these options were omitted,\n  the resolver would raise and prevent compilation from continuing.\n  This is problematic when you are trying to actually compile the system\n  in CI. Artifact resolvers should make a best effort on downloading the\n  artifacts, and return `{:error, reason}` if they are unsuccessful. This\n  will allow the system to fall back to performing a compile.","ref":"changelog.html#v1-6-2"},{"type":"extras","title":"v1.6.1 - Changelog","doc":"* Enhancements\n  * Updated documentation to reflect changes in [`nerves_bootstrap 1.8`](https://github.com/nerves-project/nerves_bootstrap/releases/tag/v1.8.0)\n    Updates references to `nerves_init_gadget` and replace with `nerves_pack`.\n    This change shifts new projects and main documentation to promote the use of\n    [`vintage_net`](https://github.com/nerves-networking/vintage_net) for device networking.\n  * Bump the host installed `fwup` version requirement to `~> 1.5`.","ref":"changelog.html#v1-6-1"},{"type":"extras","title":"v1.6.0 - Changelog","doc":"Nerves 1.6.0 adds support for Elixir 1.10.\n\nAs part of the update to Elixir 1.10, it became more difficult to support old\nElixir and Erlang versions. Therefore, Nerves 1.6.0 requires at least Elixir\nv1.7.0 and Erlang/OTP 21. If your project requires an older version of Elixir or\nErlang/OTP you can pin the version of `nerves` to an older version.\n\nFor example, set your nerves dependency in your mix.exs to:\n\n```elixir\n{:nerves, \"~> 1.5.0\", runtime: false},\n```\n\n* Enhancements\n  * Add support for aarch64 host architecture.\n  * Add `mix firmware.metadata` for listing firmware metadata values.","ref":"changelog.html#v1-6-0"},{"type":"extras","title":"v1.5.4 - Changelog","doc":"* Enhancements\n  * Add `mix firmware.unpack` to unpack generated `.fw` files. This is useful\n    to inspect the contents of the target root filesystem and other .fw info\n    on the host.\n  * Update `mix burn` to accept the path to a `.fw` file with `--firmware | -i`.\n\n* Bug fixes\n  * Invoke `mix firmware` when calling `mix firmware.image`. This matches the\n    behavior of `mix firmware.burn`.\n  * Fix issue with artifact base_dir expansion. This fixes an issue where mix\n    would attempt to resolve the nerves dependency artifacts even though they\n    have already been downloaded.\n  * Always generate `erlinit.config`, even if there are no config override in\n    mix config. This fixes an issue where removing overrides from mix config\n    would not update the erlinit.config.","ref":"changelog.html#v1-5-4"},{"type":"extras","title":"v1.5.3 - Changelog","doc":"* Bug fixes\n  * Fix various erlinit option parsing/formatting issues.","ref":"changelog.html#v1-5-3"},{"type":"extras","title":"v1.5.2 - Changelog","doc":"* Enhancements\n  * erlinit.config options can be overridden using the application config now.\n    For example, in your config.exs you can now add:\n\n    ```elixir\n    config :nerves, :erlinit,\n      ctty: \"ttyAMA0\"\n    ```\n\n  * Nerves tooling now supports setting the SOURCE_DATE_EPOCH environment\n    variable for reproducible builds during compilation via `:source_date_epoch`\n    in your application config. This removes timestamp differences between\n    builds. See [reproducible-builds.org](https://reproducible-builds.org/) for more information.\n  * Windows Subsystem for Linux improvements\n  * Support XDG_DATA_HOME. If XDG_DATA_HOME is set, Nerves will now store its\n    data under that directory.\n\n* Bug fixes\n  * Do not require sudo on `mix burn` if already privileged.\n  * Keep all boot scripts. Previously, extraneous boot scripts from the OTP\n    release process were removed. Keeping them makes it possible to start\n    Erlang slave nodes and support use cases where triggers at device boot\n    time launch different scripts.","ref":"changelog.html#v1-5-2"},{"type":"extras","title":"v1.5.1 - Changelog","doc":"* Bug fixes\n  * Update compiler check on `mix firmware` to use the system OTP version\n    when recommending an Elixir install.\n  * Check if using Distillery when calling `mix nerves.release.init`.\n    This is no longer required for Elixir 1.9+ releases.","ref":"changelog.html#v1-5-1"},{"type":"extras","title":"v1.5.0 - Changelog","doc":"**Updating to Nerves v1.5.0 requires modifications to your project**\nSee the [project update guide](https://hexdocs.pm/nerves/updating-projects.html#updating-from-v1-4-to-v1-5) to learn how to migrate your project.\n\n* Enhancements\n  * Added support for Elixir 1.9+ releases.\n\n* Bug fixes\n  * Do not include empty priv directories when constructing rootfs\n    priorities.","ref":"changelog.html#v1-5-0"},{"type":"extras","title":"v1.4.5 - Changelog","doc":"* Enhancements\n  * Updated docs.\n\n* Bug fixes\n  * Updated the requirement for `distillery` to `~> 2.0.12`. This fixes an issue\n    where `nerves` would downgrade to `1.4.0` when updating `shoehorn`.\n  * Empty `priv` directories are not added to the squashfs sort ordering list.","ref":"changelog.html#v1-4-5"},{"type":"extras","title":"v1.4.4 - Changelog","doc":"* Bug fixes\n  * This improves the path fix in v1.4.3 (see\n    https://github.com/nerves-project/nerves/issues/389) to cover the local\n    build runner as well.","ref":"changelog.html#v1-4-4"},{"type":"extras","title":"v1.4.3 - Changelog","doc":"* Bug fixes\n  * Raise an exception if the artifact cache fails to create a directory\n  * Fixes `ArgumentError` when using OTP >= 21.3.0 and calling `mix nerves.system.shell`\n  * Fixes issue with `mix nerves.system.shell` using `asdf` >= 0.7.0 where the\n    path would contain `::` and Buildroot would raise the error:\n\n    ```text\n    You seem to have the current working directory in your\n    PATH environment variable. This doesn't work.\n    support/dependencies/dependencies.mk:21: recipe for target 'dependencies' failed\n    ```","ref":"changelog.html#v1-4-3"},{"type":"extras","title":"v1.4.2 - Changelog","doc":"* Improvements\n  * Generate rootfs.priorities file. This is used internally when constructing\n    the squashfs filesystem to arrange the contents in the order the files are\n    loaded at runtime which improves boot performance.","ref":"changelog.html#v1-4-2"},{"type":"extras","title":"v1.4.1 - Changelog","doc":"* Improvements\n  * Improve error message when artifacts can't be found","ref":"changelog.html#v1-4-1"},{"type":"extras","title":"v1.4.0 - Changelog","doc":"Version v1.4.0 adds support for Elixir 1.8's new built-in support for mix\ntargets. In Nerves, the `MIX_TARGET` was used to select the appropriate set of\ndependencies for a device. This lets you switch between building for different\nboards and your host. Elixir 1.8 pulls this support into `mix` and lets you\nannotate dependencies for which targets they should be used.\n\nSee the [project update guide](https://hexdocs.pm/nerves/updating-projects.html#updating-from-v1-3-x-to-v1-4-x) to learn how to migrate your project.","ref":"changelog.html#v1-4-0"},{"type":"extras","title":"v1.3.4 - Changelog","doc":"* Bug fixes\n  * Fixed issue where specifying `build_runner_opts` without `build_runner`\n    would prevent `build_runner_opts` from being set.\n  * Allow `http_opts` to be merged in from the artifact site opts. This fixes\n    an issue with downloading artifacts from github enterprise by specifying\n    `[autoredirect: true]` in the artifact site opts.","ref":"changelog.html#v1-3-4"},{"type":"extras","title":"v1.3.3 - Changelog","doc":"* Bug fixes\n  * Lock dependency on distillery to `2.0.10` to work around:\n    https://github.com/bitwalker/distillery/issues/585","ref":"changelog.html#v1-3-3"},{"type":"extras","title":"v1.3.2 - Changelog","doc":"* Bug fixes\n  * Improved handling for burning firmware with Windows Subsystem for Linux.\n  * `mix nerves.deps.get` will raise if a download was incomplete or corrupt\n    after trying all resolvers.\n  * `mix firmware.burn` will call `mix firmware` to ensure the firmware is the\n    latest.\n  * `mix burn` was added to allow for burning the latest built firmware without\n    calling `mix firmware`.","ref":"changelog.html#v1-3-2"},{"type":"extras","title":"v1.3.1 - Changelog","doc":"* Bug fixes\n  * Fix `fwup` invocations for NixOS users\n  * Add `--verbose` option on `mix firmware` to help debug OTP release\n    generation\n  * Force users to run Elixir 1.7.3 or later if using Elixir 1.7. This avoids\n    a known issue in Elixir 1.7.2 and Distillery 2.0.\n  * Remove unused cookies in default `rel/config.exs` files","ref":"changelog.html#v1-3-1"},{"type":"extras","title":"v1.3.0 - Changelog","doc":"This version adds support for Elixir ~> 1.7 which requires updates to your\nMix project.\n\n**Modify the release config**\n\nIt is required to modify the `rel/config.exs` file.\n\nChange this:\n\n```elixir\nrelease :my_app do\n  set version: current_version(:my_app)\n  plugin Shoehorn\n  if System.get_env(\"NERVES_SYSTEM\") do\n    set dev_mode: false\n    set include_src: false\n    set include_erts: System.get_env(\"ERL_LIB_DIR\")\n    set include_system_libs: System.get_env(\"ERL_SYSTEM_LIB_DIR\")\n    set vm_args: \"rel/vm.args\"\n  end\nend\n```\n\nTo this:\n\n```elixir\nrelease :my_app do\n  set version: current_version(:my_app)\n  plugin Shoehorn\n  plugin Nerves\nend\n```\n\n**Update shoehorn**\n\nYou will need to update your version of shoehorn to `{:shoehorn, \"~> 0.4\"}`.","ref":"changelog.html#v1-3-0"},{"type":"extras","title":"v1.2.1 - Changelog","doc":"* Enhancements\n  * Update minimum required version for fwup to at least 1.2.5","ref":"changelog.html#v1-2-1"},{"type":"extras","title":"v1.2.0 - Changelog","doc":"* Enhancements\n  * Added ability to override provisioning.conf in the project mix config.\n    This can be done by setting the key `provisioning`.\n\n    Example:\n\n      ```elixir\n      config :nerves, :firmware,\n        provisioning: \"config/provisioning.conf\"\n\n      # or delegate it to an app that sets nerves_provisioning: \"path/to/file\"\n\n      config :nerves, :firmware,\n        provisioning: :nerves_hub\n      ```\n\n  * Bug Fixes\n    * Fix issue with setting provisioning environment variables when calling\n      `mix firmware.burn` on Linux systems. Environment variables prefixed with\n      `NERVES_` and the variable `SERIAL_NUMBER` will be copied into the environment.","ref":"changelog.html#v1-2-0"},{"type":"extras","title":"v1.1.1 - Changelog","doc":"* Enhancements\n  * Updated docs to bump required versions of tools.\n\n* Bug Fixes\n  * Docker build runner\n    * Use the version of the `nerves_system_br` as the tag for the docker image\n      to pull by default.\n    * Create and set the user id and group id in the docker entrypoint.\n      This fixes issues with building buildroot packages that require\n      access to the users home folder.","ref":"changelog.html#v1-1-1"},{"type":"extras","title":"v1.1.0 - Changelog","doc":"* Enhancements\n  * `mix firmware.burn` can run within Windows Subsystem for Linux\n  * Added `make_args` to `build_runner_opts`\n\n  For example:\n\n    You can configure the number of parallel jobs that buildroot\n    can use for execution. This is useful for situations where you may\n    have a machine with a lot of CPUs but not enough ram.\n\n    ```elixir\n      # mix.exs\n      defp nerves_package do\n        [\n          # ...\n          build_runner_opts: [make_args: [\"PARALLEL_JOBS=8\"]],\n        ]\n      end\n    ```","ref":"changelog.html#v1-1-0"},{"type":"extras","title":"v1.0.1 - Changelog","doc":"* Enhancements\n  * General documentation updates.\n* Bug fixes\n  * Do not fetch artifacts on deps.get if they are overridden using environment\n    variables like `NERVES_SYSTEM=/path/to/system`.","ref":"changelog.html#v1-0-1"},{"type":"extras","title":"v1.0.0 - Changelog","doc":"* Bug Fixes\n  * `Nerves.Artifact.BuildRunners.Docker` was running as root and caused file\n    permission issues with the `deps` directory of the root `mix` project.\n    The `Docker` build runner now executes as the same user id and group id as\n    the host.","ref":"changelog.html#v1-0-0"},{"type":"extras","title":"v1.0.0-rc.2 - Changelog","doc":"This version renames the module `Nerves.Artifact.Provider` to\n`Nerves.Artifact.BuildRunner`. This change should only affect custom systems\nand host tools that override the defaults in `nerves_package` config.\n\n* Enhancements\n  * Allow specifying multiple rootfs_overlay directories in the config.\n  * Automatically remove corrupt files from the download directory.\n  * Updated System documentation.\n* Bug Fixes\n  * Check the download directory before attempting to download the artifact.\n  * Changed the host tool check to use `System.find_executable(\"command\")` instead of\n    calling out to `System.cmd(\"which\", [\"command\"])`. This addressed an issue with\n    NodeJS breaking anything that called into `which` resulting in an obscure error.","ref":"changelog.html#v1-0-0-rc-2"},{"type":"extras","title":"v1.0.0-rc.1 - Changelog","doc":"This rc contains documentation cleanup and updates through out.\n\n* Enhancements\n  * Support forwarding the ssh-agent through Docker for the Nerves system shell.\n  * Allow headers and query params to be passed to the `:prefix` `artifact_sites`\n    helper.\n\n    Example:\n    `{:prefix, \"https://my_server.com/\", headers: [{\"Authorization\", \"Basic 1234\"}]}`\n    `{:prefix, \"https://my_server.com/\", query_params: %{\"id\" => \"1234\"}}`\n\n  * Added `github_api`to `artifact_sites` for accessing release artifacts on private\n    github repositories.\n\n    Example:\n    `{:github_api, \"owner/repo\", username: \"skroob\", token: \"1234567\", tag: \"v0.1.0\"}`\n\n* Bug Fixes\n  * Disable the nerves_package compiler if the `NERVES_ENV_DISABLED` is set.\n    This makes it easier to execute `mix` tasks without building the system.\n\n    Example:\n    `NERVES_ENV_DISABLED=1 mix docs`","ref":"changelog.html#v1-0-0-rc-1"},{"type":"extras","title":"v1.0.0-rc.0 - Changelog","doc":"Nerves no longer automatically compiles any `nerves_package` that is missing its\npre-compiled artifact. This turned out to rarely be desired and caused\nunexpectedly long compilation times when things like the Linux kernel or gcc got\ncompiled.\n\nWhen a pre-compiled artifact is missing, Nerves will now tell you what your\noptions are to resolve this. It could be retrying `mix deps.get` to download it\nagain. If you want to force compilation to happen, add a `:nerves` option for\nthe desired package in your top level project:\n\n```elixir\n  {:nerves_system_rpi0, \"~> 1.0-rc\", nerves: [compile: true]}\n```\n\n* Bug Fixes\n  * Mix raises a more informative error if the `nerves_package` compiler\n    attempts to run and the `nerves_bootstrap` application has not been\n    started.  This also produces more informative errors when trying to\n    compile from the top of an umbrella.","ref":"changelog.html#v1-0-0-rc-0"},{"type":"extras","title":"v0.11.0 - Changelog","doc":"* Bug Fixes\n  * Including the entire artifact checksum in artifact download file name was causing issues with\n    file encryption libraries. Fixed by changing the artifact download name to only\n    use the first 7 of the artifact checksum.","ref":"changelog.html#v0-11-0"},{"type":"extras","title":"v0.10.1 - Changelog","doc":"* Bug Fixes\n  * Ensure the artifact cache dir is clean and created before putting artifacts.","ref":"changelog.html#v0-10-1"},{"type":"extras","title":"v0.10.0 - Changelog","doc":"* Enhancements\n  * Call `bootstrap/1` on any package that defines a platform\n  * Added Nerves.Utils.File.tar helper for creating archives\n  * Only apply the host tuple `portable` to packages with type `system`\n  * Packages other then toolchains and systems can override their artifact\n    paths using an env var of their app name. For example. a package called\n    `:host_tool` would be able to override the artifact path by setting\n    `HOST_TOOL` in the environment.\n  * Allow any package that declares a provider to create an artifact.\n  * Fixed up test fixtures and added integration test.\n\n* Bug Fixes\n  * Do not raise when trying to make a directory when putting an artifact in\n    the global cache.\n  * Ensure the Nerves environment has been started when calling `nerves\n    artifact`","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"v0.9.4 - Changelog","doc":"* Bug Fixes\n  * Fix artifact archiver to use `Artifact.download_name/1` instead of\n    `Artifact.name/1`. Fixes issues with the Docker provider and\n    `mix nerves.artifact`\n  * Fix issue with `nerves.system.shell` not rendering properly","ref":"changelog.html#v0-9-4"},{"type":"extras","title":"v0.9.3 - Changelog","doc":"* Bug Fixes\n  * Artifact download_path should use download_name. This was causing a\n    mismatch between dl files from buildroot and the resolver causing it to\n    have to download them twice\n  * Fixed issue with compiling certain nerves packages when calling\n    `mix deps.compile`","ref":"changelog.html#v0-9-3"},{"type":"extras","title":"v0.9.2 - Changelog","doc":"* Bug Fixes\n  * Fixed issue where env var artifact path overides were being calculated\n    instead of honored.","ref":"changelog.html#v0-9-2"},{"type":"extras","title":"v0.9.1 - Changelog","doc":"* Bug Fixes\n  * Fixed issue with artifact default path containing duplicate names\n  * `Nerves.Env.host_os` can be set from `$HOST_OS` for use with canadian\n    cross compile\n  * `Nerves.Env.host_arch` can be set from `$HOST_ARCH` for use with canadian\n    cross compile\n  * mkdir -p on `Artifact.base_dir` before trying to link to build path\n    artifacts\n  * raise if artifact_urls are not binaries.","ref":"changelog.html#v0-9-1"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"* Update Notes\n\nStarting in Nerves v0.9.0, artifacts will no longer be fetched during `mix\ncompile`. Artifact archives are intended to be fetched following `mix deps.get`.\nTo handle this, you will need to update your installed version of\n`nerves_bootstrap` by calling `mix nerves.local`. After updating\n`nerves_bootstrap`, you should update your `mix.exs` file to add the new\nrequired mix aliases found there. A helper function is available named\n`Nerves.Bootstrap.add_aliases` that you can pipe your existing aliases to like\nthis:\n\n```elixir\n  defp aliases(_target) do\n    [\n      # Add custom mix aliases here\n    ]\n    |> Nerves.Bootstrap.add_aliases()\n  end\n```\n\nAlso, update your nerves dependency to:\n\n`{:nerves, \"~> 0.9\", runtime: false}`\n\n* API Changes\n  * Moved `Nerves.Package.Providers` to `Nerves.Artifact.Providers`\n  * Moved `Nerves.Package.Providers.HTTP` to `Nerves.Artifact.Resolver`\n  * `Nerves.Artifact.Resolver` no longer implements the\n    `Nerves.Artifact.Provider` behaviour.\n\n* Enhancements\n  * Added Mix task `nerves.artifact.get`. Use to fetch the artifact archive from an\n    `artifact_url` location. Once downloaded its checksum will be checked against\n    `artifact_checksum` from the `nerves_package` config in `mix.exs`. The Mix task\n    `nerves.deps.get` will recursively call `nerves.artifact.get` to fetch archives.\n  * Added Mix task `nerves.artifact`. This task will produce the\n    artifact archive file which are used when calling `nerves.artifact.get`.\n  * Nerves packages can override the Provider in the `nerves_package` config\n    in `mix.exs` using the keys `provider` and `provider_opts`. This is\n    useful to force a package to build using a specific provider like\n    `Nerves.Artifact.Providers.Docker`. See the [package configuration docs](https://hexdocs.pm/nerves/systems.html#package-configuration)\n    for more information.\n  * Added `artifact_sites` to the `nerves_package` config. Artifact sites\n    are helpers that are useful for cleanly specifying locations where artifacts\n    can be fetched. If you are hosting your artifacts using Github releases\n    you can specify it like this:\n\n    ```elixir\n    artifact_sites: [\n      {:github_releases, \"organization/project\"}\n    ]\n    ```\n\n    You can also specify your own custom server location by using the `:prefix`\n    helper by passing a url or file path:\n\n    ```elixir\n    artifact_sites: [\n      {:prefix, \"/path/to/artifacts\"}\n      {:prefix, \"https://my_bucket.s3-east.amazonaws.com/artifacts\"}\n    ]\n    ```\n\n    Artifact sites will be tried in order until one successfully downloads the\n    artifact.\n* Bug Fixes\n  * Fixed issue with `Nerves.Utils.HTTPResolver` crashing when missing the\n    `content-disposition` and `content-length` headers.\n  * Run integrity check on tar files to validate they are not corrupted on\n    download.","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"v0.8.3 - Changelog","doc":"* Bug Fixes\n  * Revert plugin Nerves in new project generator until\n    the fix can be made in distillery.\n    This issue was causing the release to contain compiled\n    libraries from the host instead of the target.\n    The error would look similar to this\n\n    ```text\n    Got:\n    ELF 64-bit LSB relocatable, x86-64, version 1\n\n    If binary, expecting:\n    ELF 32-bit LSB executable, ARM, EABI5 version 1, interpreter /lib/ld-linux.so.3, for GNU/Linux 4.1.39\n    ```\n\n    You can fix this by updating and regenerating the new project.","ref":"changelog.html#v0-8-3"},{"type":"extras","title":"v0.8.2 - Changelog","doc":"* Enhancements\n  * Added [contributing guide](https://github.com/nerves-project/nerves/blob/main/docs/CONTRIBUTING.md)\n  * Improved error messages when `NERVES_SYSTEM` or `NERVES_TOOLCHAIN` are unset.\n\n* Bug Fixes\n  * Don't override the output_dir in the Distillery Plugin.","ref":"changelog.html#v0-8-2"},{"type":"extras","title":"v0.8.1 - Changelog","doc":"* Bug Fixes\n  * Fixed an error in the `Nerves` Distillery plugin that was causing the following error message:\n\n    ```text\n    Plugin failed: no function clause matching in IO.chardata_to_string/1\n    ```","ref":"changelog.html#v0-8-1"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"* Enhancements\n  * Removed legacy compiler key from the package struct. The `nerves_package` compiler will be chosen by default.\n  * Simplified the distillery release config by making Nerves a distillery plugin\n  * Skip archival phase when making firmware.\n  * Allow the progress bar to be disabled for use in CI systems by setting `NERVES_LOG_DISABLE_PROGRESS_BAR=1`\n  * Deprecate nerves.exs. The contents of nerves.exs files have been moved into mix.exs under the project key `nerves_package`\n\n* Bug Fixes\n  * raise an exception when the artifact build encounters an error","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.5 - Changelog","doc":"* Enhancements\n  * Docker\n    * Reduced the image size by optimizing docker file.\n    * Images are pulled from Docker Hub instead of building locally.\n    * Containers are transient and build files are stored in docker volumes.\n    * NERVES_BR_DL_DIR is mounted as a host volume instead of a docker volume.\n\n* Bug Fixes\n  * Docker\n    * Fixed issue where moving the project location on the host would require\n      the container to be force deleted.","ref":"changelog.html#v0-7-5"},{"type":"extras","title":"v0.7.4 - Changelog","doc":"* Bug Fixes\n  * Make sure the path NERVES_DL_DIR exists before writing artifacts to it.","ref":"changelog.html#v0-7-4"},{"type":"extras","title":"v0.7.3 - Changelog","doc":"* Enhancements\n  * [mix firmware.image] remove the need to pass an image name. Default to the app name.\n  * [mix] added shortdocs to all mix tasks.\n  * [fwup] bumped requirement to ~> 0.15 and support 1.0.0 pre release.\n  * Cache downloads to ~/.nerves/dl or $NERVES_DL_DIR if defined.","ref":"changelog.html#v0-7-3"},{"type":"extras","title":"v0.7.2 - Changelog","doc":"* Bug Fixes\n  * Fixed issue where `nerves.system.shell` would hang and load improperly.\n* Enhancements\n  * Deprecated the `rootfs_additions` configuration option, to be superseded by\n    the `rootfs_overlay` option, which matches the convention used by the\n    Buildroot community.","ref":"changelog.html#v0-7-2"},{"type":"extras","title":"v0.7.1 - Changelog","doc":"* Bug Fixes\n  * The `nerves.system.shell` Mix task should not do `make clean` by default.\n* Enhancements\n  * The \"Customizing Your Own Nerves System\" documentation has been updated to\n    include the `mix nerves.system.shell` functionality, including a blurb to\n    recommend running a clean build any time it's not working as expected.","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"0.7.0 - Changelog","doc":"* Bug Fixes\n  * Try to include the parent project when loading Nerves packages\n  * Better error message from the Docker provider when Docker is not installed\n  * Delete system artifact directories only when instructed by `mix nerves.clean` on Linux.\n    This prevents triggering a full rebuild for every change made to a custom system.\n* Enhancements\n  * Added support for the new `nerves.system.shell` task, provided by\n    `nerves_bootstrap`, to `Nerves.Package.Providers.Docker` and\n    `Nerves.Package.Providers.Local`, which provides a consistent way to\n    configure a Buildroot-based Nerves system on both OSX and Linux. This\n    replaces the `nerves.shell` Mix task, which had not been fully implemented.\n  * `mix firmware.burn` no longer asks for your password if using Linux and have\n     read/write permissions on the SD card device.","ref":"changelog.html#0-7-0"},{"type":"extras","title":"0.6.1 - Changelog","doc":"* Bug Fixes\n  * Docker Provider: Fix version parsing issue when major, minor, or patch contains leading zeros.","ref":"changelog.html#0-6-1"},{"type":"extras","title":"0.6.0 - Changelog","doc":"* Bug Fixes\n  * Require Nerves Packages to have a version\n* Enhancements\n  * Propagate Mix.Project.config settings into the firmware metadata\n  * Removed checksum from docker container name. Docker provider now only builds changes\n  * Added Nerves.Env.clean for cleaning package providers","ref":"changelog.html#0-6-0"},{"type":"extras","title":"0.5.2 - Changelog","doc":"* BugFixes\n  * Handle redirects manually as a fix to OTP 19.3 caused by [ERL-316](https://bugs.erlang.org/browse/ERL-316)","ref":"changelog.html#0-5-2"},{"type":"extras","title":"0.5.1 - Changelog","doc":"* BugFixes\n  * Handle redirects manually as a fix to OTP 19.3 caused by [ERL-316](https://bugs.erlang.org/browse/ERL-316)","ref":"changelog.html#0-5-1"},{"type":"extras","title":"0.5.0 - Changelog","doc":"* Bug Fixes\n  * `:nocache` the HTTP provider if the download list is empty\n  * return an error when tar is unsuccessful at decompressing an artifact\n  * return `:error` for any error in downloading artifacts\n  * clean up temp files after downloading artifacts\n  * expand path before comparing for dep type: Fixes path deps in umbrella\n  * clean up artifact dir before copying new artifact\n* Enhancements\n  * changed console output for higher visibility Nerves compiler messages\n  * added ability to specify the images_path in the Mix.Project config\n  * changed default images_path to `#{build_path}/nerves/images`\n  * updated docs to reflect changes made to project structure\n  * added `mix nerves.info` task. Can be used to gain information about the Nerves env","ref":"changelog.html#0-5-0"},{"type":"extras","title":"0.4.8 - Changelog","doc":"* Bug Fixes\n  * removed `--silent` from `mix release.clean` for compatibility with `:distillery ~> 1.2.0`","ref":"changelog.html#0-4-8"},{"type":"extras","title":"0.4.7 - Changelog","doc":"* Bug Fixes\n  * [Providers.Local] Fix return error on non zero exit status code\n  * Fixed IO stream split to handle ANSI code case regression","ref":"changelog.html#0-4-7"},{"type":"extras","title":"0.4.6 - Changelog","doc":"* Bug Fixes\n  * fix artifact http download manager to take as long as it needs unless idle for more than 2 minutes.\n  * [Providers.Docker] Fixed IO stream parsing to handle occasions where ANSI codes are not being passed.\n  * loosened dependency on distillery","ref":"changelog.html#0-4-6"},{"type":"extras","title":"0.4.5 - Changelog","doc":"* Bug Fixes\n  * catch exits from mix release.clean when calling mix firmware","ref":"changelog.html#0-4-5"},{"type":"extras","title":"0.4.4 - Changelog","doc":"* Bug Fixes\n  * return an `{:error, message}` response from the http provider when a resource is not found","ref":"changelog.html#0-4-4"},{"type":"extras","title":"0.4.3 - Changelog","doc":"* Enhancements\n  * Mix will display a progress bar, percentage, and total / expected bytes when downloading artifacts.\n  * Added task `mix firmware.image my_app.img` for producing images for use with applications like dd\n  * Silenced output from distillery which would contain misleading information for the nerves project\n\n* Bug Fixes\n  * Docker provider could potentially produce application id's that were invalid","ref":"changelog.html#0-4-3"},{"type":"extras","title":"0.4.2 - Changelog","doc":"* Bug Fixes\n  * Fixed issue where artifact paths could not be set by system env var\n  * Mix Task `nerves.release.init` was failing due to missing template. Include priv in hex package files.","ref":"changelog.html#0-4-2"},{"type":"extras","title":"0.4.1 - Changelog","doc":"* Bug Fixes\n  * Do not stop the Nerves.Env at the end of the package compiler. This would cause the packages to resolve the wrong dep type.\n  * Fixed issue where remote artifacts would not be globally cached\n  * Fixed issue with package compiler where it would always force systems to be built","ref":"changelog.html#0-4-1"},{"type":"extras","title":"0.4.0 - Changelog","doc":"* Enhancements\n  * Improved test suite\n  * Added documentation for modules\n  * Consolidated the Nerves Environment to the Nerves package","ref":"changelog.html#0-4-0"},{"type":"extras","title":"0.4.0-rc.0 - Changelog","doc":"* Enhancements\n  * Consolidated compilers into `nerves_package`.\n  * Removed dependency for `nerves_system`\n  * Removed dependency for `nerves_toolchain`\n  * Added Docker provider for building custom systems on machines other than linux","ref":"changelog.html#0-4-0-rc-0"},{"type":"extras","title":"0.3.4 - Changelog","doc":"* Bug Fixes\n  * Fixed regression with `mix firmware.burn` to allow prompts\n* Enhancements\n  * Added ability to override task in `mix firmware.burn`. You can now pass `-t` or `--task` to perform `upgrade` or anything else. Default is `complete`","ref":"changelog.html#0-3-4"},{"type":"extras","title":"0.3.3 - Changelog","doc":"* Bug Fixes\n  * Updated nerves.precompile / loadpaths to support Elixir 1.3.x aliases.\n* Enhancements\n  * Removed dependency on porcelain","ref":"changelog.html#0-3-3"},{"type":"extras","title":"0.3.2 - Changelog","doc":"* Bug Fixes\n  * Support for elixir 1.3.0-dev\n  * Invoke `nerves.loadpaths` on preflight of `mix firmware` and `mix firmware.burn`. Fixes `ERROR: It looks like the system hasn't been built!`","ref":"changelog.html#0-3-2"},{"type":"extras","title":"0.3.1 - Changelog","doc":"* Enhancements\n  * Perform host tool checks before executing scripts","ref":"changelog.html#0-3-1"},{"type":"extras","title":"0.3.0 - Changelog","doc":"* Enhancements\n  * Added nerves_bootstrap archive\n  * `mix firmware` Create firmware bundles from mix\n  * `mix firmware.burn` Burn Firmware bundles to SD cards","ref":"changelog.html#0-3-0"},{"type":"extras","title":"0.2.0 - Changelog","doc":"* Enhancements\n  * Added support for 0.4.0 system paths","ref":"changelog.html#0-2-0"}],"content_type":"text/markdown"}